/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *	rommon Common Functions
 */

#include <stdio.h>
#include "comdefs.h"
#include "serial.h"

#define BS      0x08
#define LF      0x0a
#define CR      0x0d

char InputLine[MAX_SERIAL][DEFAULT_LINE_SIZE+1];

static char *InLinePointer[MAX_SERIAL];
static unsigned char InCharCount[MAX_SERIAL];


/*
 *	Byte to Hexadecimal ASCII
 *  Input:  arg1: Input Byte
 *  Output:	rval: ASCII Character
 */
unsigned char Byte2HexASCII(unsigned char c)
{
	c &= 0xf;
	if(c <= 9)
		return(c+'0');
	else
		return(c+'a'-10);
}

/*
 *	check Hexadecimal number in ASCII
 *  Input:	arg1: Input Line
 *  Output:	rval: Hexadecimal number, 0xff is not Hex
 */
static int IsHexASCII(char *s)
{
	char c = *s;

	if(c >= 'a')
		c -= 'a' - 'A';
	if(c >= '0' && c <= '9')
		return (c - '0');
	else if(c >= 'A' && c <= 'F')
		return (c - 'A' + 10);
	else
		return 0xff;
}

/*
 *	Hexadecimal ASCII to long word
 *  Input:	arg1: pointer to Input Line
 *          arg2: numbers of Input Line
 *  Output:	rval: long word
 */
unsigned long HexASCII2Long(char **ps, int size)
{
	unsigned long value = 0;
	int           c;

	while((c = IsHexASCII(*ps)) != 0xff && size > 0){
		value = (value << 4) + c;
		(*ps)++;
		size--;
	}
	return value;
}

/*
 *	Skip Blanks
 *  Input:  arg1: pointer to Input Line
 */
void SkipBlanks(char **ps)
{
	while(*(*ps) != 0){
		if(*(*ps) != ' ')
			break;
		(*ps)++;
	}
}

/*
 *	Send Character with count
 *  Input:  arg1: Character sent
 *          arg2: Count
 */
void SendCharCount(char c, int count)
{
	while(count > 0){
		putchar(c);
		count--;
	}
}

/*
 *	Initialize Recive Line
 *  Input:  arg1: Serial Channel #
 */
void InitRecLine(int id)
{
	InCharCount[id]   = 0;
	InLinePointer[id] = &InputLine[id][0];
}

/*
 *	Recive Line
 *  Input:  arg1: send Serial Channel #
 *          arg2: recvie Serial Channel #
 *  output: rval: Input Buffer, 0 if no line
 */
char *ReciveLine(int sid, int rid)
{
	char *sp = &InputLine[rid][0];
	char *cp = InLinePointer[rid];
	char *rp = 0;
	char c;

	if(InCharCount[rid] == 0){
		do{
			c = ReciveChar(rid);
			if(c == BS){
				if(cp > sp){
					SendChar(sid, BS);
					SendChar(sid, ' ');
					SendChar(sid, BS);
					cp--;
				}
			}
			else if(c != CR && c != LF && c != 0){
				SendChar(sid, c);
				*cp++ = c;
				if(cp >= (sp+DEFAULT_LINE_SIZE))
					c = CR;
			}
			if(c == CR){
				SendChar(sid, CR);
				SendChar(sid, LF);
				InCharCount[rid] = (unsigned char)(cp-sp);
				*cp = '\0';
				rp = sp;
				break;
			}
		}while(c != 0);
		InLinePointer[rid] = cp;
	}
	else
		rp = sp;
	return rp;
}

/*
 *	Move Long Word (Increment Type)
 *  Input:  arg1: Destination Address
 *          arg2: Source      Address
 *          arg3: Length
 */
void MoveLongInc(unsigned long *d, unsigned long *s, int len)
{
	while(len > 0){
		*d++ = *s++;
		len -= 4;
	}
}

