
#ifndef _SYS_DEFS_H_
#define _SYS_DEFS_H_

/*	Values	*/

#if BOARDNO == 0
#define TARGET_CPU_STR		"DK-DEV-5CSXC6N"
#elif BOARDNO == 1
#define TARGET_CPU_STR		"DE0-Nano-SoC"
#elif BOARDNO == 2
#define TARGET_CPU_STR		"DE10-Nano"
#else
#error	"NOT SOPPORT BOARD !"
#endif

/* endian */
#define SIL_ENDIAN      0		/* LITTLE ENDIAN */

/*	Address		*/
#define RAM_BASE        0x01000000
#define RAM_SIZE        (128*1024*1024)
#define VECTOR_SIZE		(4*8)
#define MonitorVector   vector_table
#define CLOAD_ADDRESS   0x20000000


/*
 *  ԤΤ
 *  ϥåȿ˰¸롣
 */
#define    SIL_DLY_TIM1     1
#define    SIL_DLY_TIM2     2

#define CACHE_LINE_SIZE	    32	/* A9 cacle line size */

/*	Default Values	*/

#define MAX_INT_NUM     32
#define DEF_DUMP_LENGTH	256
#define NOT_INITDECT

#ifndef _MACRO_ONLY
/*
 *  ѥ¸Υǡ
 */
#define	_int8_		char		/* 8ӥåȤ	*/
#define	_int16_		short		/* 16ӥåȤ	*/
#define	_int32_		int			/* 32ӥåȤ	*/
#define	_int64_		long long	/* 64ӥåȤ	*/

/*
 *  ROMMONǻѤ뷿
 */
typedef _int32_     int32_t;
typedef long		intptr_t;	/* ݥ󥿤ǼǤդ */

/*
 *  ѥγĥǽΤΥޥ
 */
#define	Inline          static inline

typedef	int                 ID;			/* ֥ȤIDֹ */
typedef	int                 ER;			/* 顼 */
typedef int                 bool_t;		/*  */

#ifndef NULL
#define NULL                0			/* ̵ݥ */
#endif /* NULL */

#ifndef true
#define true                1			/*  */
#endif /* true */

#ifndef false
#define false               0			/*  */
#endif /* false */

/*
 *  SDMMCĥ顼
 */
#define E_OK                0			/* ｪλ */
#define E_SYS               (-5)		/* ƥ२顼 */
#define E_PAR               (-17)		/* ѥ᡼顼 */
#define E_OBJ               (-41)		/* ֥Ⱦ֥顼 */
#define E_TMOUT             (-50)		/* ݡ󥰼Ԥޤϥॢ */
#define E_SDCOM             (-80)		/* ޥɥ顼 */

extern void sys_printf(const char *s);

#endif	/* _MACRO_ONLY */

/*	Serial Channels		*/

#define MAX_SERIAL		1
#define DEF_MON_SERIAL	0

#include "socfpga_cv.h"

/* serial definitions */

#define UART_CLOCK          100000000
#define DEFAULT_SPEED		115200

#endif	/* SYS_DEFS_H_ */

