/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2007 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *	rommon Serial Functions
 */
#include "sys_defs.h"
#include "sil.h"
#include "serial.h"

#define DEFAULT_PCLK    12000000
#define DEFAULT_DLL     0x00000003
#define DEFAULT_FDR     0x00000067

#define US_TXEMPTY	0x20
#define US_FE       0x08
#define US_PE       0x04
#define US_OE       0x02
#define US_RXRDY    0x01

#define US_ETXI     0x02
#define US_ERXI     0x01

typedef struct uart_struct {
	unsigned long base;
	void *        func;
	unsigned int  intno;
	unsigned int  errcount;
} uart_struct_t;

/*interrupt mask*/
unsigned char int_mode_table[MAX_INT_NUM]={
    0,			/* 00: wdt */
    0,
    0,
    0,
    14,			/* 04: timer #0 lowest system timer */
    15,			/* 05: timer #1 */
    7,			/* 06: uart #0 console 1 */
    7,			/* 07: uart #1 console 2 */
    15,
    15,
    15,
    15,
    15,
    12,			/* 13: RTC */
    15,
    15,
    15,
    15,
    15,
    15,
    15,
    8,			/* 21: ETHER */
    15,
    15,
    3,			/* 24: MMC */
    9,			/* 25: GPDMA */
    15,			/* 26: timer #2 */
    15,			/* 27: timer #3 */
    15,			/* 28: uart #2 */
    15,			/* 29: uart #3 */
    15,
    15
};

static uart_struct_t uart_table[2];


void SendTXWait(int id);

static void sys_putc(int c)
{
	SendTXWait(0);
	SendTX(0, c);
}

static void sys_printf(const char *s)
{
	int c;

	while((c = *s++) != 0){
		if(c == '\n')
			sys_putc('\r');
		sys_putc(c);
	}
}

/*
 *  ̤㳰äν
 */
void undef_exception(void)
{
    sys_printf("Unregistered Exception occurs. UNDEF !\n");
    while(1);
}

void swi_exception(void)
{
    sys_printf("Unregistered Exception occurs. SWI !\n");
    while(1);
}

void prefetch_exception(void)
{
    sys_printf("Unregistered Exception occurs. PREFETCH !\n");
    while(1);
}

void data_abort_exception(void)
{
    sys_printf("Unregistered Exception occurs. DATA ABORT !\n");
    while(1);
}


void irq_exception(void)
{
    sys_printf("Unregistered Exception occurs. IRQ !\n");
    while(1);
}

void fiq_exception(void)
{
    sys_printf("Unregistered Exception occurs. FIQ !\n");
    while(1);
}

static void uart_isr0(void)
{
	ComInterRX(0);
}

static void uart_isr1(void)
{
	ComInterRX(1);
}

/*
 *  ߥϥɥ
 *
 *  ֹ inhno γߥϥɥεưϤ inthdr ꤹ롥
 */
static void define_inh(unsigned int inhno, void * inthdr)
{
    if(inhno < MAX_INT_NUM){
		sil_wrw_mem((uint32_t *)(TADR_VIC_BASE+TOFF_VIC_INTENCLR), 1<<inhno);
		sil_wrw_mem((uint32_t *)(TADR_VIC_BASE+TOFF_VIC_VECTADDRB+inhno*4), (unsigned long)inthdr);
		sil_wrw_mem((uint32_t *)(TADR_VIC_BASE+TOFF_VIC_VECTPRIO+inhno*4), (unsigned long)int_mode_table[inhno]);
		sil_wrw_mem((uint32_t *)(TADR_VIC_BASE+TOFF_VIC_SOFTINTCLR), 1<<inhno);
		sil_wrw_mem((uint32_t *)(TADR_VIC_BASE+TOFF_VIC_INTENABLE), 1<<inhno);
	}
}

/*
 *	Optional Initialize
 */
void BeforeInit(void)
{
	unsigned long tmp;
	unsigned int  i;

	uart_table[0].base = TADR_UART0_BASE;
	uart_table[0].func = uart_isr0;
	uart_table[0].intno = INTNO_UART0;
	uart_table[0].errcount = 0;
	uart_table[1].base = TADR_UART1_BASE;
	uart_table[1].func = uart_isr1;
	uart_table[1].intno = INTNO_UART1;
	uart_table[1].errcount = 0;

   /* initialize VIC */
	sil_wrw_mem((uint32_t *)(TADR_VIC_BASE+TOFF_VIC_INTENCLR), 0xffffffff);
	sil_wrw_mem((uint32_t *)(TADR_VIC_BASE+TOFF_VIC_VECTADDR), 0x00000000);
	sil_wrw_mem((uint32_t *)(TADR_VIC_BASE+TOFF_VIC_INTSELECT), 0x00000000);

	for(i = 0 ; i < MAX_INT_NUM ; i++){
		sil_wrw_mem((uint32_t *)(TADR_VIC_BASE+TOFF_VIC_VECTADDRB+i*4), 0x00000000);
		sil_wrw_mem((uint32_t *)(TADR_VIC_BASE+TOFF_VIC_VECTPRIO+i*4), 0x0000000f);
	}

   /* Configure UART0 for 115200 baud. */
	tmp  = sil_rew_mem((uint32_t *)(TADR_PINSEL_BASE+TOFF_PINSEL0));
	tmp &= ~0x000000f0;
	tmp |= 0x00000050;                   /* Enable RxD0 TxD0 pin         */
	sil_wrw_mem((uint32_t *)(TADR_PINSEL_BASE+TOFF_PINSEL0), tmp);

	sil_wrw_mem((uint32_t *)(TADR_UART0_BASE+TOFF_UART_LCR), 0x00000083);	/* 8 bits, no Parity, 1 Stop bit*/
#if DEFAULT_SPEED == 115200
	sil_wrw_mem((uint32_t *)(TADR_UART0_BASE+TOFF_UART_DLL), DEFAULT_DLL);	/* for 12MHz PCLK Clock         */
	sil_wrw_mem((uint32_t *)(TADR_UART0_BASE+TOFF_UART_FDR), DEFAULT_FDR);	/* Fractional Divider           */
#else
	tmp = (DEFAULT_PCLK * 10) / 16 / DEFAULT_SPEED;
	tmp = (tmp+5) / 10;
	sil_wrw_mem((uint32_t *)(TADR_UART0_BASE+TOFF_UART_DLL), tmp & 0xff);	/* set divisor */
	sil_wrw_mem((uint32_t *)(TADR_UART0_BASE+TOFF_UART_DLM), tmp >> 8);
#endif
	sil_wrw_mem((uint32_t *)(TADR_UART0_BASE+TOFF_UART_LCR), 0x00000003);	/* DLAB = 0                     */

   /* Configure UART1 for 115200 baud. */
	tmp  = sil_rew_mem((uint32_t *)(TADR_PINSEL_BASE+TOFF_PINSEL0));
	tmp &= ~0xC0000000;
	tmp |= 0x40000000;                   /* Enable TxD1 pin              */
	sil_wrw_mem((uint32_t *)(TADR_PINSEL_BASE+TOFF_PINSEL0), tmp);
	tmp  = sil_rew_mem((uint32_t *)(TADR_PINSEL_BASE+TOFF_PINSEL1));
	tmp &= ~0x00000003;
	tmp |= 0x00000001;                   /* Enable RxD1 pin              */

	sil_wrw_mem((uint32_t *)(TADR_PINSEL_BASE+TOFF_PINSEL1), tmp);

	sil_wrw_mem((uint32_t *)(TADR_UART1_BASE+TOFF_UART_LCR), 0x00000083);	/* 8 bits, no Parity, 1 Stop bit*/
#if DEFAULT_SPEED == 115200
	sil_wrw_mem((uint32_t *)(TADR_UART1_BASE+TOFF_UART_DLL), DEFAULT_DLL);	/* for 12MHz PCLK Clock         */
	sil_wrw_mem((uint32_t *)(TADR_UART1_BASE+TOFF_UART_FDR), DEFAULT_FDR);	/* Fractional Divider           */
#else
	tmp = (DEFAULT_PCLK * 10) / 16 / DEFAULT_SPEED;
	tmp = (tmp+5) / 10;
	sil_wrw_mem((uint32_t *)(TADR_UART1_BASE+TOFF_UART_DLL), tmp & 0xff);	/* set divisor */
	sil_wrw_mem((uint32_t *)(TADR_UART1_BASE+TOFF_UART_DLM), tmp >> 8);
#endif
	sil_wrw_mem((uint32_t *)(TADR_UART1_BASE+TOFF_UART_LCR), 0x00000003);	/* DLAB = 0                     */

	/* MMC pin seklect (MCI poweron pin to GPIO) */
	tmp  = sil_rew_mem((uint32_t *)(TADR_PINSEL_BASE+TOFF_PINSEL1));
	tmp &= ~0x00003fc0;
	tmp |= 0x00002A80;
	sil_wrw_mem((uint32_t *)(TADR_PINSEL_BASE+TOFF_PINSEL1), tmp);
	tmp  = sil_rew_mem((uint32_t *)(TADR_PINSEL_BASE+TOFF_PINSEL4));
	tmp &= ~0x0fc00000;
	tmp |= 0x0A800000;
	sil_wrw_mem((uint32_t *)(TADR_PINSEL_BASE+TOFF_PINSEL4), tmp);
}

/*
 *	Initialize Serial Channel
 *  Input: id: Serial Channel #
 */
void InitSIO(int id)
{
	unsigned long  base = uart_table[id].base;
#if DEFAULT_SPEED != 115200
	unsigned long  tmp;
#endif

    /*
     * Wait 롥
     */
    sil_dly_nse(5000);

	sil_wrw_mem((uint32_t *)(base+TOFF_UART_LCR), 0x00000083);	/* 8 bits, no Parity, 1 Stop bit*/
#if DEFAULT_SPEED == 115200
	sil_wrw_mem((uint32_t *)(base+TOFF_UART_DLL), DEFAULT_DLL);	/* for 12MHz PCLK Clock         */
	sil_wrw_mem((uint32_t *)(base+TOFF_UART_FDR), DEFAULT_FDR);	/* Fractional Divider           */
#else
	tmp = (DEFAULT_PCLK * 10) / 16 / DEFAULT_SPEED;
	tmp = (tmp + 5) / 10;
	sil_wrw_mem((uint32_t *)(base+TOFF_UART_DLL), tmp & 0xff);	/* set divisor */
	sil_wrw_mem((uint32_t *)(base+TOFF_UART_DLM), tmp >> 8);
#endif
	sil_wrw_mem((uint32_t *)(base+TOFF_UART_LCR), 0x00000003);	/* DLAB = 0                     */
												/* Enable RDA and THRE interrupts      */
    sil_dly_nse(5000);
	define_inh(uart_table[id].intno, uart_table[id].func);
    sil_wrw_mem((uint32_t *)(base+TOFF_UART_IER), US_ERXI);
}

/*
 *  Get RX Data
 *  Input: id: Serial Channel #
 *  output: c: Rx Data
 */
unsigned short GetRxData(int id)
{
	unsigned long  base = uart_table[id].base;
	unsigned short c    = 0;
	unsigned long  tmp;

    tmp = sil_rew_mem((uint32_t *)(base+TOFF_UART_LSR));
	if(tmp & (US_FE|US_PE|US_OE)){
		uart_table[id].errcount++;
	}
	if(tmp & US_RXRDY){
		c = (unsigned short)sil_rew_mem((uint32_t *)(base+TOFF_UART_RBR));
		c |= CHKRXDATA;
	}
	return c;
}

/*
 *  Enable Tx interrupt
 *  Input: id: Serial Channel #
 */
void EnableITX(int id)
{
	unsigned long  base = uart_table[id].base;
	unsigned long  tmp;

	tmp = sil_rew_mem((uint32_t *)(base+TOFF_UART_IER));
	tmp |= US_ETXI;
    sil_wrw_mem((uint32_t *)(base+TOFF_UART_IER), tmp);
}

/*
 *  Disable Tx interrupt
 *  Input: id: Serial Channel #
 */
void DisableITX(int id)
{
	unsigned long  base = uart_table[id].base;
	unsigned long  tmp;

	tmp = sil_rew_mem((uint32_t *)(base+TOFF_UART_IER));
	tmp &= ~US_ETXI;
    sil_wrw_mem((uint32_t *)(base+TOFF_UART_IER), tmp);
}

/*
 *  Send Tx in interrupt
 *  Input: id: Serial Channel #
 *         c : Send charactor
 */
void SendTX(int id, char c)
{
	sil_wrw_mem((uint32_t *)(uart_table[id].base+TOFF_UART_THR), c);
}

/*
 * Send Tx wait
 * Inputs: id: Serial Channel #
 */
void SendTXWait(int id)
{
	while((sil_rew_mem((uint32_t *)(uart_table[id].base+TOFF_UART_LSR)) & US_TXEMPTY) == 0);
}

