/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: lpc2388.S,v 1.01 2013/02/10 22:02:38 roi Exp $
 */

/*
 *    ͥѤΥȥåץ⥸塼(ARMv4)
 */
#define _MACRO_ONLY
#include "sys_defs.h"
#include "mondefs.h"
#include "serial.h"

#define SCS_Val         0x00000020

/* Constants */
#define OSCRANGE        (1<<4)			/* Oscillator Range Select */
#define OSCEN           (1<<5)			/* Main oscillator Enable */
#define OSCSTAT         (1<<6)			/* Main Oscillator Status */
#define PLLCON_PLLE     (1<<0)			/* PLL Enable */
#define PLLCON_PLLC     (1<<1)			/* PLL Connect */
#define PLLSTAT_M       (0x7FFF<<0)		/* PLL M Value */
#define PLLSTAT_N       (0xFF<<16)		/* PLL N Value */
#define PLLSTAT_PLOCK   (1<<26)			/* PLL Lock Status */

#define CLKSRCSEL_Val   0x00000001
#define PLLCFG_Val      0x0000000B
#define CCLKCFG_Val     0x00000005
#define USBCLKCFG_Val   0x00000005
#define PCLKSEL0_Val    0x00000000
#define PCLKSEL1_Val    0x01000000

#define MAMTIM_Val      0x00000004
#define MAMCR_Val       0x00000002


        /*
         * Vectorơ֥ȥץơ֥
         * Ϲ0x3c
         */
        .section .vector,"a"
        .code 32
        .align 0
        .global vector_table
vector_table:
        ldr pc, reset_vector       /* ꥻå             */
        ldr pc, undef_vector       /* ̤̿           */
        ldr pc, swi_vector         /* եȥ   */
        ldr pc, prefech_vector     /* ץեåܡ */
        ldr pc, data_abort_vector  /* ǡܡ       */
        ldr pc, reserved_vector
        ldr pc, irq_vector         /* IRQ                  */
        ldr pc, fiq_vector         /* IRQ                  */

/*
 *  ٥ơ֥
 */
_kernel_arm_vector_add:
reset_vector:
        .long   start
undef_vector:
        .long   undef_handler
swi_vector:
        .long   swi_handler
prefech_vector:
        .long   prefetch_abort_handler
data_abort_vector:
        .long   data_abort_handler
reserved_vector:
		.long   reserved_handler
irq_vector:
        .long   irq_handler
fiq_vector:
        .long   fiq_handler

        .text
        .code 32
        .align     0
        .global    start
start:
        mov  r1, #(0x13|0xC0) /* To System mode */
		msr  cpsr,r1

        /*
         * åݥ󥿤ȡե졼ݥ󥿤ν
         * SL(å¥쥸r10)ꤹɬפ뤫?
         * gccϥǥեȤǤ-mapcsʤΤɬפʤ
         */
        ldr  r3,=STACKTOP
        mov  sp,r3
        mov  r11,#0        /* Arm⡼ѥե졼ݥ   */         
        mov  r7,#0         /* Thubm⡼ѥե졼ݥ */

									/* Setup Clock */
        ldr     r0,=TADR_SCB_BASE
        mov     r1,#0xAA
        mov     r2,#0x55
									/* Configure and Enable PLL */
        ldr     r3,=SCS_Val			/* Enable main oscillator */
        str     r3,[r0, #TOFF_SCB_SCS]

osc_loop:
        ldr     r3,[r0, #TOFF_SCB_SCS]	/* Wait for main osc stabilize */
        ands    r3,r3, #OSCSTAT
        beq     osc_loop

        ldr     r3,=CLKSRCSEL_Val		/* Select PLL source clock */
        str     r3,[r0, #TOFF_SCB_CLKSRCSEL]
        ldr     r3,=PLLCFG_Val
        str     r3,[r0, #TOFF_SCB_PLLCFG]
        str     r1,[r0, #TOFF_SCB_PLLFEED]
        str     r2,[r0, #TOFF_SCB_PLLFEED]
        mov     r3,#PLLCON_PLLE
        str     r3,[r0, #TOFF_SCB_PLLCON]
        str     r1,[r0, #TOFF_SCB_PLLFEED]
        str     r2,[r0, #TOFF_SCB_PLLFEED]

									/* Wait until PLL Locked */
pll_loop:
        ldr     r3,[r0, #TOFF_SCB_PLLSTAT]
        ands    r3,r3,#PLLSTAT_PLOCK
        beq     pll_loop

m_n_lock:
        ldr     r3,[r0, #TOFF_SCB_PLLSTAT]
        ldr     r4,=(PLLSTAT_M | PLLSTAT_N)
        and     r3,r3, r4
        ldr     r4,=PLLCFG_Val
        eors    r3,r3, r4
        bne     m_n_lock

									/* Setup CPU clock divider */
        mov     r3,#CCLKCFG_Val
        str     r3,[r0, #TOFF_SCB_CCLKCFG]
									/* Setup USB clock divider */
        ldr     r3,=USBCLKCFG_Val
        str     r3,[R0, #TOFF_SCB_USBCLKCFG]
									/* Setup Peripheral Clock */
        ldr     r3,=PCLKSEL0_Val
        str     r3,[r0, #TOFF_SCB_PCLKSEL0]
        ldr     r3,=PCLKSEL1_Val
        str     r3,[r0, #TOFF_SCB_PCLKSEL1]
									/* Switch to PLL Clock */
        mov     r3,#(PLLCON_PLLE | PLLCON_PLLC)
        str     r3,[r0, #TOFF_SCB_PLLCON]
        str     r1,[r0, #TOFF_SCB_PLLFEED]
        str     r2,[r0, #TOFF_SCB_PLLFEED]

									/* Setup MAM */
        ldr     r0,=TADR_PINSEL_BASE
        mov     r3,#0
        str     r3,[r0, #TOFF_PINSEL10]
        ldr     r0,=TADR_SCB_BASE
        mov     r1,#MAMTIM_Val
        str     r1,[r0, #TOFF_SCB_MAMTIM]
        mov     r1,#MAMCR_Val
        str     r1,[r0, #TOFF_SCB_MAMCR]

									/* Setup the stack for each mode */
        msr     cpsr_c,#(0x11|0xC0)	/* Set up Fast Interrupt Mode and set FIQ Mode Stack */
        ldr     r13,=(STACKINT+FIQ_DATA_SIZE)	/* Init stack FIQ */

        msr     cpsr_c,#(0x12|0xC0)	/* Set up Interrupt Mode and set IRQ Mode Stack */
        ldr     r13,=STACKINT		/* Init stack IRQ */
        msr     cpsr_c,#(0x13|0xC0)	/* Return Supervisor Mode and set Supervisor Mode */

        /*
         *  bssΥꥢ
         */
start_1:
        ldr     r1,=__bss_start
        ldr     r2,=__bss_end
        cmp     r1,r2
        bhs     start_3
        mov     r0,#0
start_2:
        str     r0,[r1],#4
        cmp     r1,r2
        blo     start_2

start_3:
#if ROM_EXEC != 0
        /*
         *  dataν(ROMб)
         *  __idata_start  __idata_end ޤǤ__data_start ʹߤ
         *  ԡ
         */
        ldr     r1,=__idata_start
        ldr     r3,=__idata_end
        cmp     r1,r3
        bhs     start_5
        ldr     r2,=__data_start
start_4:        
        ldr     r0,[r1],#4
        str     r0,[r2],#4
        cmp     r1,r3
        blo     start_4
#endif /* ROM EXEC MODE */
start_5:
        ldr     r0,=MonMain
        mov     lr,pc
        bx      r0

start_6:
		b       start_6

        /*
         *  ǥեȥץؿthumbбϥɥ
         */
        .global undef_handler
        .global swi_handler
        .global prefetch_abort_handler
        .global data_abort_handler
        .global reserved_handler
        .global irq_handler
        .global frq_handler

        .text
        .code 32
        .align 	0

undef_handler:
        msr     CPSR_c,#0xDF	@ System mode , I and F bits set (interrupts disabled)
        ldr     r0,=__vector__
        ldr     r0,[r0, #0]
        ldr     r0,[r0, #4]
        mov     lr,pc
        bx      r0
undef_exception_returned:
        b       undef_exception_returned

swi_handler:
        msr     CPSR_c,#0xDF	@ System mode , I and F bits set (interrupts disabled)
        ldr     r0,=__vector__
        ldr     r0,[r0, #0]
        ldr     r0,[r0, #8]
        mov     lr,pc
        bx      r0
swi_exception_returned:
        b       swi_exception_returned

prefetch_abort_handler:
        msr     CPSR_c,#0xDF	@ System mode , I and F bits set (interrupts disabled)
        ldr     r0,=__vector__
        ldr     r0,[r0, #0]
        ldr     r0,[r0, #12]
        mov     lr,pc
        bx      r0
prefetch_exception_returned:
        b       prefetch_exception_returned

data_abort_handler:
        msr     CPSR_c,#0xDF		@ System mode , I and F bits set (interrupts disabled)
        ldr     r0,=__vector__
        ldr     r0,[r0, #0]
        ldr     r0,[r0, #16]
        mov     lr,pc
        bx      r0
data_abort_exception_returned:
        b       data_abort_exception_returned

reserved_handler:
        b       reserved_handler

irq_handler:
        stmfd   sp!, {r0,pc}
        ldr     r0,=__vector__
        ldr     r0,[r0, #0]
        ldr     r0,[r0, #24]
        str     r0,[sp,#4]
        ldmfd   sp!,{r0,pc}

fiq_handler:
        stmfd   sp!,{r0,pc}
        ldr     r0,=__vector__
        ldr     r0,[r0, #0]
        ldr     r0,[r0, #28]
        str     r0,[sp,#4]
        ldmfd   sp!,{r0,pc}

/*
 *
 *  ߤν
 *
 */
        .text
        .align 4
        .global IRQ_Handler
IRQ_Handler:
        /* 
         * ߥ⡼ 
         * 
         * cpsrspsr_irq褬r14_irq(lp)ꡤ
         * spsr_irqr14_irqr13(sp)_irq r14,r13Ȥʤ롥
         */
        sub     lr,lr,#4			/* construct the return address */
        stmfd   sp!, {lr}			/* and push the adjusted lr_IRQ */
        mrs     lr,spsr				/* copy spsr_IRQ to lr */
        stmfd   sp!, {r0-r4,r12,lr}	/* save AAPCS regs and spsr_IRQ */

        /* 
         *  ѡХ⡼ɤ
         */
        msr     cpsr_c, #(0x13|0x80)/* To System mode */
        and     r1,sp,#4			/* test alignment of the stack */
        sub     sp,sp,r1			/* remove any misalignment (0 or 4) */
        stmfd   sp!, {r1,lr}		/* store the adjustment and lr_SYS */

        /*
         *  װȽꡥ
         */
        ldr     r3,=TADR_VIC_BASE
        ldr     r0,[r3, #TOFF_VIC_VECTADDR]
        cmp     r0,#0x00
        bne     IRQ_callhandler
        ldr     r0,=irq_exception

        /*
         * ߵ
         */
IRQ_callhandler:
        mrs     r2,cpsr			/* interrupt enable */
        and     r2, r2, #~0x80
        msr     cpsr,r2

        /*
         * Call Handler
         */
        mov     lr, pc
        bx      r0

        /* 
         * ߶ػ 
         */
        mrs     r2,cpsr			/* interrupt disable */
        orr     r2,r2,#0x80
        msr     cpsr,r2
        ldmfd   sp!, {r1,lr}	/* restore stack adjustment and lr_SYS */
        add     sp,sp,r1		/* and the stack adjustment (0 or 4) */

        /*
         * ߥꥢ
         */
        ldr     r3,=TADR_VIC_BASE
        ldr     r0,=0x00000000
        str     r0,[r3, #TOFF_VIC_VECTADDR]

								/* to IRQ mode interrupt disable */
        msr     cpsr_c,#(0x12|0x80)
        ldmfd   sp!, {r0-r4,r12,lr}	/* restore registers */
        msr     spsr_cxsf,lr	/* and spsr_IRQ */
        ldmfd   sp!,{pc}^		/* return from IRQ mode */

        .text
        .align 4
        .global FIQ_Handler
FIQ_Handler:
         /* Switch in SVC/User Mode to allow User Stack access for C code */
         /* because the FIQ is not yet acknowledged */
         /* Save and r0 in FIQ_Register */
         mov    r9, r0
         ldr    r0, [r8, #TOFF_VIC_VECTADDR]
         msr    cpsr_c,#(0x13|0xC0)
         /* Save scratch/used registers and LR in User Stack */
         ldr    sp, =(STACKINT+FIQ_DATA_SIZE)
         stmfd  sp!, { r1-r3, r12, lr}
         /* Branch to the routine pointed by the AIC_FVR */
         mov    r14, pc
         bx     r0
         /* Restore scratch/used registers and LR from User Stack */
         ldmia  sp!, { r1-r3, r12, lr}
         /* Leave Interrupts disabled and switch back in FIQ mode */
         msr    cpsr_c, #(0x11|0xC0)
         /* Restore the R0 ARM_MODE_SVC register */
         mov    r0, r9
         /* Restore the Program Counter using the LR_fiq directly in the PC */
         subs   pc, lr, #4

        .text
        .align 4
        .global Disable
        .global Enable
        .global SetVector

/*
 *  interrupt disable
 */
Disable:
        mrs  r0,CPSR
        orr  r0,r0,#0x80	@ I bit set
        msr  CPSR,r0
        bx   lr

/*
 *  interrupt enable
 */
Enable:
        mrs  r0,CPSR
        and  r0,r0,#~0x80	@ I bit reset
        msr  CPSR,r0
        bx   lr

/*
 *  set vector
 */
SetVector:
        ldr  r1, =__vector__
        str  r0, [r1]
        bx   lr

/*
 * եȥǥ쥣ؿ
 */
	    .global sil_dly_nse
sil_dly_nse:
        sub   r0, r0, #SIL_DLY_TIM1
        cmp   r0, #0
        bgt   _sil_dly_nse1
        bx    lr
_sil_dly_nse1:
        sub   r0, r0, #SIL_DLY_TIM2
        cmp   r0, #0
        bgt   _sil_dly_nse1
        bx    lr

        .data
        .align     4
        .global    UserVector
        .global    MonitorVector
UserVector:
        .long      RAM_BASE
        .long      undef_exception
        .long      swi_exception
        .long      prefetch_exception
        .long      data_abort_exception
        .long      0
        .long      IRQ_Handler
        .long      FIQ_Handler

MonitorVector:
        .long      start
        .long      undef_exception
        .long      swi_exception
        .long      prefetch_exception
        .long      data_abort_exception
        .long      0
        .long      IRQ_Handler
        .long      FIQ_Handler
__vector__:
        .long      MonitorVector

