/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *	rommon Serial Functions
 */
#include "sys_defs.h"
#include "sil.h"
#include "serial.h"


/*
 *	Optional Initialize
 */
void BeforeInit(void)
{
	unsigned char tmp;

	sil_wrb_mem((uint8_t *)IOREG_P1DDR, 0xff);		/* Enable A0  - A7  */
	sil_wrb_mem((uint8_t *)IOREG_P2DDR, 0xff);		/* Enable A8  - A15 */
	sil_wrb_mem((uint8_t *)IOREG_P3DDR, 0xff);		/* Enable D8  - D15 */
	sil_wrb_mem((uint8_t *)IOREG_P5DDR, P5DDR_A16);/* Enable A16 */
											/* Enable CS1 - CS2	*/
	sil_wrb_mem((uint8_t *)IOREG_P8DDR, P8DDR_CS1|P8DDR_CS2);
											/* Enable Upper CAS	*/
	sil_wrb_mem((uint8_t *)IOREG_PBDDR, PBDDR_UCAS);
				/* DRAM: 2,048/32ms: 32ms / 2,048 = 15.625us	*/
				/* 20MHz / 8 / 39 = 1 / 15.6us			*/
	tmp = (32*(CLOCK_RATE/1000))/(8*2048);
	sil_wrb_mem((uint8_t *)IOREG_RTCOR, tmp);
											/* clock / 8		*/
	sil_wrb_mem((uint8_t *)IOREG_RTMCSR, RTMCSR_CKS1);
											/* CA: 10 bit, A23-A10	*/
	sil_wrb_mem((uint8_t *)IOREG_DRCRB, DRCRB_RCYCE|DRCRB_MXC1);
											/* Enable Upper CAS	*/
	sil_wrb_mem((uint8_t *)IOREG_DRCRA, DRCRA_BE|DRCRA_DRAS0);
	sil_dly_nse(1000L);
}

/*
 *	Initialize Serial Channel
 *  Input: id: Serial Channel #
 */
void InitSIO(int id)
{
	unsigned long base = id * 8 + IOREG_SCI_BASE;
	unsigned char dummy;

												/* Initialize SCR, SMR and BRR */
	sil_wrb_mem((uint8_t *)(base+IOREG_SCR_OFFSET), 0x00);
	sil_wrb_mem((uint8_t *)(base+IOREG_SMR_OFFSET), DEFAULT_SMR);
	sil_wrb_mem((uint8_t *)(base+IOREG_BRR_OFFSET), DEFAULT_BRR);

	sil_dly_nse(1000L);
	sil_wrb_mem((uint8_t *)(base+IOREG_SCR_OFFSET), SCR_RIE|SCR_TE|SCR_RE);
	dummy = sil_reb_mem((uint8_t *)(base+IOREG_SSR_OFFSET));		/* Dummy read */
	sil_wrb_mem((uint8_t *)(base+IOREG_SSR_OFFSET), SSR_TDRE);		/* Clear error flags */
}

/*
 *  Get RX Data
 *  Input: id: Serial Channel #
 *  output: c: Rx Data
 */
unsigned short GetRxData(int id)
{
	unsigned long  base = id * 8 + IOREG_SCI_BASE;
	unsigned short c    = 0;
	unsigned char  tmp;

	tmp = sil_reb_mem((uint8_t *)(base+IOREG_SSR_OFFSET));
	if(tmp & (SSR_OPER|SSR_FER|SSR_PER)){
		tmp &= ~(SSR_OPER|SSR_FER|SSR_PER);
		sil_wrb_mem((uint8_t *)(base+IOREG_SSR_OFFSET), tmp);
	}
	if(tmp & SSR_RDRF){
		c  = sil_reb_mem((uint8_t *)(base+IOREG_RDR_OFFSET));
		c |= CHKRXDATA;
		tmp &= ~SSR_RDRF;
		sil_wrb_mem((uint8_t *)(base+IOREG_SSR_OFFSET), tmp);
	}
	return c;
}

/*
 *  Enable Tx interrupt
 *  Input: id: Serial Channel #
 */
void EnableITX(int id)
{
	unsigned long scr_addr = id * 8 + IOREG_SCI_BASE + IOREG_SCR_OFFSET;

	sil_wrb_mem((uint8_t *)scr_addr, sil_reb_mem((uint8_t *)scr_addr) | SCR_TIE);
}

/*
 *  Disable Tx interrupt
 *  Input: id: Serial Channel #
 */
void DisableITX(int id)
{
	unsigned long scr_addr = id * 8 + IOREG_SCI_BASE + IOREG_SCR_OFFSET;

	sil_wrb_mem((uint8_t *)scr_addr, sil_reb_mem((uint8_t *)scr_addr) & ~SCR_TIE);
}

/*
 *  Send Tx in interrupt
 *  Input: id: Serial Channel #
 *         c : Send charactor
 */
void SendTX(int id, char c)
{
	unsigned long base = id * 8 + IOREG_SCI_BASE;

	sil_wrb_mem((uint8_t *)(base+IOREG_TDR_OFFSET), c);
	sil_wrb_mem((uint8_t *)(base+IOREG_SSR_OFFSET), sil_reb_mem((uint8_t *)(base+IOREG_SSR_OFFSET)) & ~SSR_TDRE);
}

/*
 * Send Tx wait
 * Inputs: id: Serial Channel #
 */
void SendTXWait(int id)
{
	unsigned long base = id * 8 + IOREG_SCI_BASE;

	while ((sil_reb_mem((uint8_t *)(base+IOREG_SSR_OFFSET)) & SSR_TDRE) == 0);

}

static void kputchar(char c)
{
	if(c == '\n'){
		SendTXWait(DEF_MON_SERIAL);
		SendTX(DEF_MON_SERIAL, '\r');
	}
	SendTXWait(DEF_MON_SERIAL);
	SendTX(DEF_MON_SERIAL, c);
}

static void kprints(const char *s)
{
	while(*s)
		kputchar(*s++);
	kputchar('\n');
}

void interror(int no)
{
	kprints("Undefined Interrupt: ");
	kputchar(Byte2HexASCII(no >> 4));
	kputchar(Byte2HexASCII(no & 0xf));
	kprints(", Shutdowned\n");
}


