/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2016-2019 by TOPPERS PROJECT Educational Working Group.
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

#ifndef _SERIAL_H_
#define _SERIAL_H_

/*
 *	serial.h -- H8 Serial Definitions
 */

/*	Default Values	*/

#define DEF_SCITX_BUFF_SIZE	128				/* default SCI Transmit buffer size */
#define DEF_SCIRX_BUFF_SIZE	128				/* default SCI Recive   buffer size */
#define DEFAULT_LINE_SIZE	(DEF_SCIRX_BUFF_SIZE - 1)	/* default line size (without terminator) */

/*	Parameters	*/

#define SCI_LOW_WMARK		(DEF_SCIRX_BUFF_SIZE / 3)
#define SCI_HIGH_WMARK		(SCI_LOW_WMARK * 2)
#define CHKRXDATA           0xff00

/*  Logical Serial id */

#define	DUMMY_MON_SERIAL	-1

#ifndef _MACRO_ONLY
/*
 *	External Functions
 */

extern void InitSerial(int id);
extern void SendChar(int id, char c);
extern char ReciveChar(int id);
extern void ComInterRX(int id);
extern void ComInterTX(int id);
extern void ComInterCTS(int id, int val);

extern void InitSIO(int id);
extern unsigned short GetRxData(int id);
extern void EnableITX(int id);
extern void DisableITX(int id);
extern void SendTXWait(int id);
extern void SendTX(int id, char c);
extern void SetRTS(int id, int val);

#endif	/* _MACRO_ONLY */
#endif	/* of #ifndef _SERIAL_H_ */
