/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2015      by Roi Takeuchi
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *	rommon Serial Functions
 */
#include "sys_defs.h"
#include <string.h>
#include "sil.h"
#include "serial.h"

#define sil_orh_mem(a, b)		sil_wrh_mem((a), sil_reh_mem(a) | (b))
#define sil_andh_mem(a, b)		sil_wrh_mem((a), sil_reh_mem(a) & ~(b))
#define sil_modh_mem(a, b, c)	sil_wrh_mem((a), (sil_reh_mem(a) & (~b)) | (c))
#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))
#define sil_andw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) & ~(b))
#define sil_modw_mem(a, b, c)	sil_wrw_mem((a), (sil_rew_mem(a) & (~b)) | (c))

/*
 *  GPIO BASE AND PIN POSITION
 */

#if BOARDNO == 1	/* STM32-E407 */
#define TADR_U1_GPIO_BASE  TADR_GPIOB_BASE
#define TADR_U2_GPIO_BASE  TADR_GPIOD_BASE
#define U1_USART           RCC_APB1ENR_USART3EN
#define U1_PORT            RCC_AHB1ENR_GPIOBEN
#define U2_PORT            RCC_AHB1ENR_GPIODEN
#define TX1_PINPOS         10
#define RX1_PINPOS         11
#define TX2_PINPOS         5
#define RX2_PINPOS         6
#define GPIO_Speed         GPIO_Speed_50MHz
#elif BOARDNO == 2	/* STM32F429 */
#define TADR_U1_GPIO_BASE  TADR_GPIOA_BASE
#define U1_USART           RCC_APB2ENR_USART1EN
#define U1_PORT            RCC_AHB1ENR_GPIOAEN
#define TX1_PINPOS         9
#define RX1_PINPOS         10
#define GPIO_Speed         GPIO_Speed_50MHz
#elif BOARDNO == 5	/* STM32F446Z */
#define TADR_U1_GPIO_BASE  TADR_GPIOD_BASE
#define U1_USART           RCC_APB1ENR_USART3EN
#define U1_PORT            RCC_AHB1ENR_GPIODEN
#define TX1_PINPOS         8
#define RX1_PINPOS         9
#define GPIO_Speed         GPIO_Speed_100MHz
#else				/* STM32F4-Discovery STM32F401 */
#define TADR_U1_GPIO_BASE  TADR_GPIOA_BASE
#define U1_USART           RCC_APB1ENR_USART2EN
#define U1_PORT            RCC_AHB1ENR_GPIOAEN
#define TX1_PINPOS         2
#define RX1_PINPOS         3
#define GPIO_Speed         GPIO_Speed_50MHz
#endif

/*
 *  USART Priority
 */
#define MAIN_PRIORITY      0
#define SUB_PRIORITY       0

/*
 *  GPIO Configuration Mode enumeration
 */
#define GPIO_Mode_IN    0x0					/* GPIO Input Mode */
#define GPIO_Mode_OUT   GPIO_MODER_MODER0	/* GPIO Output Mode */
#define GPIO_Mode_AF    GPIO_MODER_MODER1	/* GPIO Alternate function Mode */
#define GPIO_Mode_AN    GPIO_MODER_MODER2	/* GPIO Analog Mode */

/*
 *  GPIO Output type enumeration
 */
#define GPIO_OType_PP   0x0
#define GPIO_OType_OD   0x1

/*
 *  GPIO Output Maximum frequency enumeration
 */
#define GPIO_Speed_2MHz   0x0						/* Low speed */
#define GPIO_Speed_25MHz  GPIO_OSPEEDER_OSPEEDR0	/* Medium speed */
#define GPIO_Speed_50MHz  GPIO_OSPEEDER_OSPEEDR1	/* Fast speed */
#define GPIO_Speed_100MHz GPIO_OSPEEDER_OSPEEDR2	/* High speed on 30 pF (80 MHz Output max speed on 15 pF) */

/*
 *  GPIO Configuration PullUp PullDown enumeration
 */
#define GPIO_PuPd_NOPULL 0x0
#define GPIO_PuPd_UP     GPIO_PUPDR_PUPDR0
#define GPIO_PuPd_DOWN   GPIO_PUPDR_PUPDR1

/*
 *  AF 7 selection
 */
#define GPIO_AF7                0x07	/* AF7 value */

/*
 *  USART Word Length
 */
#define USART_WordLength_8b     0x0000
#define USART_WordLength_9b     USART_CR1_M

/*
 *  USART Stop Bits
 */ 
#define USART_StopBits_1        0x0000
#define USART_StopBits_0_5      USART_CR2_STOP_0
#define USART_StopBits_2        USART_CR2_STOP_1
#define USART_StopBits_1_5      USART_CR2_STOP

/*
 *  USART Parity
 */
#define USART_Parity_No         0x0000
#define USART_Parity_Even       USART_CR1_PCE
#define USART_Parity_Odd        (USART_CR1_PCE | USART_CR1_PS) 

/*
 *  USART MODE
 */
#define USART_Mode_Rx           USART_CR1_RE
#define USART_Mode_Tx           USART_CR1_TE

/** @defgroup USART_Hardware_Flow_Control 
  * @{
  */ 
#define USART_HardwareFlowControl_None       0x0000
#define USART_HardwareFlowControl_RTS        USART_CR3_RTSE
#define USART_HardwareFlowControl_CTS        USART_CR3_CTSE
#define USART_HardwareFlowControl_RTS_CTS    (USART_CR3_RTSE | USART_CR3_CTSE)

#define CR1_CLEAR_MASK          (USART_CR1_M | USART_CR1_PCE | USART_CR1_PS | USART_CR1_TE | USART_CR1_RE)
#define CR3_CLEAR_MASK          (USART_CR3_RTSE | USART_CR3_CTSE)


typedef struct usart_struct {
	unsigned int    taddr;
	unsigned int	no;
} usart_struct_t;

static usart_struct_t usart_table[MAX_SERIAL] = {
#if BOARDNO == 1	/* STM32-E407 */
	{	TADR_USART3_BASE, INTNO_USART3 },
	{	TADR_USART2_BASE, INTNO_USART2 }
#elif BOARDNO == 2	/* STM32F429 */
	{	TADR_USART1_BASE, INTNO_USART1 }
#elif BOARDNO == 5	/* STM32F446Z */
	{	TADR_USART3_BASE, INTNO_USART3 }
#else				/* STM32F4-Discovery STM32F401 */
	{	TADR_USART2_BASE, INTNO_USART2 }
#endif
};

void SendTXWait(int id);
extern int MonVector[];

static void sys_putc(int c)
{
	SendTXWait(DEF_MON_SERIAL);
	SendTX(DEF_MON_SERIAL, c);
	if(c == '\n'){
		SendTXWait(DEF_MON_SERIAL);
		SendTX(DEF_MON_SERIAL, '\r');
	}
}

static void sys_printf(const char *s)
{
	int c;

	while((c = *s++) != 0){
		sys_putc(c);
	}
}

#if 0	/* ROI DEBUG */
void put_hex(char a, int val)
{
	int i, j;
	sys_putc(a);
	sys_putc(' ');
	for(i = 28 ; i >= 0 ; i-= 4){
		j = (val >> i) & 0xf;;
		if(j > 9)
			j += ('A'-10);
		else
			j += '0';
		sys_putc(j);
	}
	sys_putc('\n');
	sys_putc('\r');
}


#endif	/* ROI DEBUG */
void Disable(void)
{
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_ICER+((usart_table[0].no>>5)*4)), 1 << (usart_table[0].no & 0x1F));
#if defined(TADR_U2_GPIO_BASE)
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_ICER+((usart_table[1].no>>5)*4)), 1 << (usart_table[1].no & 0x1F));
#endif
}

void Enable(void)
{
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_ISER+((usart_table[0].no>>5)*4)), 1 << (usart_table[0].no & 0x1F));
#if defined(TADR_U2_GPIO_BASE)
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_ISER+((usart_table[1].no>>5)*4)), 1 << (usart_table[1].no & 0x1F));
#endif
}

/*
 *  ̤㳰äν
 */
void NMI_Handler(void)
{
    sys_printf("NMI Exception occurs. !\n");
    while(1);
}

void HardFault_Handler(void)
{
    sys_printf("Hard Fault Exception occurs. !\n");
    while(1);
}

void MemManage_Handler(void)
{
    sys_printf("Memory Manager Exception occurs. !\n");
    while(1);
}

void BusFault_Handler(void)
{
    sys_printf("Bus Fault Exception occurs. !\n");
    while(1);
}


void UsageFault_Handler(void)
{
    sys_printf("Usage Fault Exception occurs. !\n");
    while(1);
}

void DebugMon_Handler(void)
{
    sys_printf("Debug Monitor Exception occurs. !\n");
    while(1);
}

void PendSV_Handler(void)
{
    sys_printf("Pend SV Exception occurs. !\n");
    while(1);
}

static void setup_gpio_source(uint32_t base, unsigned char source, unsigned char select)
{
	uint32_t tmpreg, regoff;
	regoff = TOFF_GPIO_AFR0+((source>>1) & 0x4);
	tmpreg = (sil_rew_mem((uint32_t *)(base+regoff)) & ~(0xF << ((source & 0x07) * 4)))
			    | (select << ((source & 0x07) * 4));
	sil_wrw_mem((uint32_t *)(base+regoff), tmpreg);
}


/*
 *	Initialize Serial Channel
 *  Input: id: Serial Channel #
 */
void InitSIO(int id)
{
	unsigned int  usart_base = usart_table[id].taddr;
	RCC_ClocksTypeDef RCC_ClocksStatus;
	unsigned int  tmpreg = 0x00, apbclock = 0x00;
	unsigned int  integerdivider = 0x00;
	unsigned int  fractionaldivider = 0x00;
	unsigned char tmppriority = 0x00, tmppre = 0x00, tmpsub = 0x0F;

	if(id == 0){
		/* enable APB2 peripheral clock for USART1
		 * note that only USART1 and USART6 are connected to APB2
		 * the other USARTs are connected to APB1
		 */
#if U1_USART == RCC_APB2ENR_USART1EN
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB2ENR), U1_USART);
#else
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB1ENR), U1_USART);
#endif
		/* enable the peripheral clock for the pins used by USART1, PB6 for TX and PB7 for RX */
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB1ENR), U1_PORT);

		/* This sequence sets up the TX pin so they work correctly with the USART2 peripheral */
		sil_modw_mem((uint32_t *)(TADR_U1_GPIO_BASE+TOFF_GPIO_MODER), (GPIO_MODER_MODER2 << (TX1_PINPOS*2)), (GPIO_Mode_AF << (TX1_PINPOS*2)));

        /* Speed mode configuration */
		sil_modw_mem((uint32_t *)(TADR_U1_GPIO_BASE+TOFF_GPIO_OSPEEDR), (GPIO_OSPEEDER_OSPEEDR2 << (TX1_PINPOS*2)), (GPIO_Speed << (TX1_PINPOS*2)));

		/* Output mode configuration*/
		sil_modw_mem((uint32_t *)(TADR_U1_GPIO_BASE+TOFF_GPIO_OTYPER), (GPIO_OTYPER_OT << TX1_PINPOS), (GPIO_OType_PP << TX1_PINPOS));

		/* Pull-up Pull down resistor configuration */
		sil_modw_mem((uint32_t *)(TADR_U1_GPIO_BASE+TOFF_GPIO_PUPDR), (GPIO_PUPDR_PUPDR2 << (TX1_PINPOS*2)), (GPIO_PuPd_UP << (TX1_PINPOS*2)));

		/* This sequence sets up the RX pin so they work correctly with the USART2 peripheral */
		sil_modw_mem((uint32_t *)(TADR_U1_GPIO_BASE+TOFF_GPIO_MODER), (GPIO_MODER_MODER2 << (RX1_PINPOS*2)), (GPIO_Mode_AF << (RX1_PINPOS*2)));

        /* Speed mode configuration */
		sil_modw_mem((uint32_t *)(TADR_U1_GPIO_BASE+TOFF_GPIO_OSPEEDR), (GPIO_OSPEEDER_OSPEEDR2 << (RX1_PINPOS*2)), (GPIO_Speed << (RX1_PINPOS*2)));

		/* Output mode configuration*/
		sil_modw_mem((uint32_t *)(TADR_U1_GPIO_BASE+TOFF_GPIO_OTYPER), (GPIO_OTYPER_OT << RX1_PINPOS), (GPIO_OType_PP << RX1_PINPOS));

		/* Pull-up Pull down resistor configuration*/
		sil_modw_mem((uint32_t *)(TADR_U1_GPIO_BASE+TOFF_GPIO_PUPDR), (GPIO_PUPDR_PUPDR2 << (RX1_PINPOS*2)), (GPIO_PuPd_UP << (RX1_PINPOS*2)));

		/* The RX and TX pins are now connected to their AF so that the USART1 can take over control of the pins */
		setup_gpio_source(TADR_U1_GPIO_BASE, TX1_PINPOS, GPIO_AF7);
		setup_gpio_source(TADR_U1_GPIO_BASE, RX1_PINPOS, GPIO_AF7);
	}
	else{
#if !defined(TADR_U2_GPIO_BASE)
		return;
#else
		/* enable APB1 peripheral clock for USART2 */
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB1ENR), RCC_APB1ENR_USART2EN);

		/* enable the peripheral clock for the pins used by USART2, PD5 for TX and PD6 for RX */
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB1ENR), RCC_AHB1ENR_GPIODEN);

		/* This sequence sets up the TX pin so they work correctly with the USART2 peripheral */
		sil_modw_mem((uint32_t *)(TADR_U2_GPIO_BASE+TOFF_GPIO_MODER), (GPIO_MODER_MODER2 << (TX2_PINPOS*2)), (GPIO_Mode_AF << (TX2_PINPOS*2)));

        /* Speed mode configuration */
		sil_modw_mem((uint32_t *)(TADR_U2_GPIO_BASE+TOFF_GPIO_OSPEEDR), (GPIO_OSPEEDER_OSPEEDR2 << (TX2_PINPOS*2)), (GPIO_Speed << (TX2_PINPOS*2)));

		/* Output mode configuration*/
		sil_modw_mem((uint32_t *)(TADR_U2_GPIO_BASE+TOFF_GPIO_OTYPER), (GPIO_OTYPER_OT << TX2_PINPOS), (GPIO_OType_PP << TX2_PINPOS));

		/* Pull-up Pull down resistor configuration*/
		sil_modw_mem((uint32_t *)(TADR_U2_GPIO_BASE+TOFF_GPIO_PUPDR), (GPIO_PUPDR_PUPDR2 << (TX2_PINPOS*2)), (GPIO_PuPd_UP << (TX2_PINPOS*2)));

		/* This sequence sets up the RX pin so they work correctly with the USART2 peripheral */
		sil_modw_mem((uint32_t *)(TADR_U2_GPIO_BASE+TOFF_GPIO_MODER), (GPIO_MODER_MODER2 << (RX2_PINPOS*2)), (GPIO_Mode_AF << (RX2_PINPOS*2)));

        /* Speed mode configuration */
		sil_modw_mem((uint32_t *)(TADR_U2_GPIO_BASE+TOFF_GPIO_OSPEEDR), (GPIO_OSPEEDER_OSPEEDR2 << (RX2_PINPOS*2)), (GPIO_Speed << (RX2_PINPOS*2)));

		/* Output mode configuration*/
		sil_modw_mem((uint32_t *)(TADR_U2_GPIO_BASE+TOFF_GPIO_OTYPER), (GPIO_OTYPER_OT << RX2_PINPOS), (GPIO_OType_PP << RX2_PINPOS));

		/* Pull-up Pull down resistor configuration*/
		sil_modw_mem((uint32_t *)(TADR_U2_GPIO_BASE+TOFF_GPIO_PUPDR), (GPIO_PUPDR_PUPDR2 << (RX2_PINPOS*2)), (GPIO_PuPd_UP << (RX2_PINPOS*2)));

		/* The RX and TX pins are now connected to their AF so that the USART2 can take over control of the pins */
		setup_gpio_source(TADR_U2_GPIO_BASE, TX2_PINPOS, GPIO_AF7);
		setup_gpio_source(TADR_U2_GPIO_BASE, RX2_PINPOS, GPIO_AF7);
#endif
	}

	/* Configure the USART Stop Bits, Clock, CPOL, CPHA and LastBit :
	   Set STOP[13:12] bits according to USART_StopBits value */
	sil_modh_mem((uint16_t *)(usart_base+TOFF_USART_CR2), USART_CR2_STOP, USART_StopBits_1);

	/* Configure the USART Word Length, Parity and mode: 
	   Set the M bits according to USART_WordLength value 
	   Set PCE and PS bits according to USART_Parity value
	   Set TE and RE bits according to USART_Mode value */
	sil_modh_mem((uint16_t *)(usart_base+TOFF_USART_CR1), CR1_CLEAR_MASK, USART_WordLength_8b | USART_Parity_No | USART_Mode_Rx | USART_Mode_Tx);

	/* Configure the USART HFC : 
	   Set CTSE and RTSE bits according to USART_HardwareFlowControl value */
	sil_modh_mem((uint16_t *)(usart_base+TOFF_USART_CR3), CR3_CLEAR_MASK, USART_HardwareFlowControl_None);

	/* Configure the USART Baud Rate */
	RCC_GetClocksFreq(&RCC_ClocksStatus);

	if ((usart_base == TADR_USART1_BASE) || (usart_base == TADR_USART6_BASE))
		apbclock = RCC_ClocksStatus.PCLK2_Frequency;
	else
		apbclock = RCC_ClocksStatus.PCLK1_Frequency;

	/* Determine the integer part */
	if ((sil_reh_mem((uint16_t *)(usart_base+TOFF_USART_CR1)) & USART_CR1_OVER8) != 0){
		integerdivider = ((25 * apbclock) / (2 * (DEFAULT_SPEED)));	/* 8 Samples */
		tmpreg = (integerdivider / 100) << 4;
		fractionaldivider = integerdivider - (100 * (tmpreg >> 4));
		tmpreg |= ((((fractionaldivider * 8) + 50) / 100)) & 0x07;
	}
	else{ /* if ((USARTx->CR1 & USART_CR1_OVER8) == 0) */
		integerdivider = ((25 * apbclock) / (4 * (DEFAULT_SPEED)));	/* 16 Samples */
		tmpreg = (integerdivider / 100) << 4;
		fractionaldivider = integerdivider - (100 * (tmpreg >> 4));
		tmpreg |= ((((fractionaldivider * 16) + 50) / 100)) & 0x0F;
	}
	/* Write to USART BRR register */
	sil_wrh_mem((uint16_t *)(usart_base+TOFF_USART_BRR), tmpreg);

	sil_orh_mem((uint16_t *)(usart_base+TOFF_USART_CR1), USART_CR1_RXNEIE);

	/*
	 * Initializes the NVIC peripheral according to the specified
	 * parameters in USART1 or USART2.
	 */
	/* Compute the Corresponding IRQ Priority --------------------------------*/
	tmppriority = (0x700 - (sil_rew_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_AIRCR)) & 0x700))>> 0x08;
	tmppre = (0x4 - tmppriority);
	tmpsub = tmpsub >> tmppriority;

	tmppriority = MAIN_PRIORITY << tmppre;					// the priority group of the USART1 interrupts (0)
	tmppriority |=  (SUB_PRIORITY & tmpsub);		// this sets the subpriority inside the group (0)
	tmppriority = tmppriority << 0x04;

	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_IP+usart_table[id].no*4), tmppriority);

	/* Enable the Selected IRQ Channels --------------------------------------*/
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_ISER+((usart_table[id].no>>5)*4)), 0x01 << (usart_table[id].no & 0x1F));

    /* Enable the selected USART by setting the UE bit in the CR1 register */
	sil_orh_mem((uint16_t *)(usart_base+TOFF_USART_CR1), USART_CR1_UE);
}

#if BOARDNO == 1 || BOARDNO == 5	/* STM32-E407 */
/*
 *  this is the interrupt request handler (IRQ) for ALL USART3 interrupts
 */
void USART3_IRQHandler(void)
#elif BOARDNO == 2	/* STM32F429 */
/*
 *  this is the interrupt request handler (IRQ) for ALL USART1 interrupts
 */
void USART1_IRQHandler(void)
#else				/* STM32F4-Discovery STM32F401 */
/*
 *  this is the interrupt request handler (IRQ) for ALL USART2 interrupts
 */
void USART2_IRQHandler(void)
#endif
{
	unsigned short regcr1 = sil_reh_mem((uint16_t *)(usart_table[0].taddr+TOFF_USART_CR1));
	unsigned short regsr  = sil_reh_mem((uint16_t *)(usart_table[0].taddr+TOFF_USART_SR));

	/* check if the USART1 receive interrupt flag was set */
	if((regcr1 & USART_CR1_RXNEIE) != 0 && (regsr & USART_SR_RXNE) != 0){
		ComInterRX(0);
	}
	if((regcr1 & USART_CR1_TXEIE) != 0 && (regsr & USART_SR_TXE) != 0){
		ComInterTX(0);
	}
}

#if BOARDNO == 1
/*
 *  this is the interrupt request handler (IRQ) for ALL USART2 interrupts
 */
void USART2_IRQHandler(void)
{
	unsigned short regcr1 = sil_reh_mem((uint16_t *)(usart_table[1].taddr+TOFF_USART_CR1));
	unsigned short regsr  = sil_reh_mem((uint16_t *)(usart_table[1].taddr+TOFF_USART_SR));

	/* check if the USART2 receive interrupt flag was set */
	if((regcr1 & USART_CR1_RXNEIE) != 0 && (regsr & USART_SR_RXNE) != 0){
		ComInterRX(1);
	}
	if((regcr1 & USART_CR1_TXEIE) != 0 && (regsr & USART_SR_TXE) != 0){
		ComInterTX(1);
	}
}
#endif

/*
 *  Get RX Data
 *  Input: id: Serial Channel #
 *  output: c: Rx Data
 */
unsigned short GetRxData(int id)
{
	return sil_reh_mem((uint16_t *)(usart_table[id].taddr+TOFF_USART_DR)) | CHKRXDATA;
}

/*
 *  Enable Tx interrupt
 *  Input: id: Serial Channel #
 */
void EnableITX(int id)
{
	sil_orh_mem((uint16_t *)(usart_table[id].taddr+TOFF_USART_CR1), USART_CR1_TXEIE);
}

/*
 *  Disable Tx interrupt
 *  Input: id: Serial Channel #
 */
void DisableITX(int id)
{
	sil_andh_mem((uint16_t *)(usart_table[id].taddr+TOFF_USART_CR1), USART_CR1_TXEIE);
}

/*
 *  Send Tx in interrupt
 *  Input: id: Serial Channel #
 *         c : Send charactor
 */
void SendTX(int id, char c)
{
	sil_wrh_mem((uint16_t *)(usart_table[id].taddr+TOFF_USART_DR), (c & 0xFF));
}

/*
 * Send Tx wait
 * Inputs: id: Serial Channel #
 */
void SendTXWait(int id)
{
	while((sil_reh_mem((uint16_t *)(usart_table[id].taddr+TOFF_USART_SR)) & USART_SR_TC) == 0);
}

