/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2015-2019 by Roi Takeuchi
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *	rommon Serial Functions
 */
#include "sys_defs.h"
#include <string.h>
#include "sil.h"
#include "serial.h"

/*
 *  SILؿΥޥ
 */
#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))
#define sil_andw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) & ~(b))
#define sil_modw_mem(a, b, c)	sil_wrw_mem((a), (sil_rew_mem(a) & (~b)) | (c))

#if !defined  (HSI_VALUE)
#define HSI_VALUE          16000000	/* Value of the Internal oscillator in Hz*/
#endif /* HSI_VALUE */
#if !defined  (LSE_VALUE)
#define LSE_VALUE          32768	/* Value of the LSE oscillator in Hz */
#endif /* LSE_VALUE */

/*
 *  USART CLOCK SOURCE
 */
#define RCC_USARTCLKSOURCE_PCLK1      0x00000000
#define RCC_USARTCLKSOURCE_PCLK2      0x00000000
#define RCC_USARTCLKSOURCE_SYSCLK     RCC_CCIPR_USART1SEL_0
#define RCC_USARTCLKSOURCE_HSI        RCC_CCIPR_USART1SEL_1
#define RCC_USARTCLKSOURCE_LSE        (RCC_CCIPR_USART1SEL_0 | RCC_CCIPR_USART1SEL_1)

/*
 *  GPIO BASE AND PIN POSITION
 */
#define TADR_U1_GPIO_BASE  TADR_GPIOA_BASE
#define U1_RCC_USART       TOFF_RCC_APB1ENR2
#define U1_USART           RCC_APB1ENR2_LPUART1EN
#define U1_PORT            RCC_AHB2ENR_GPIOAEN
#define U1_TX_AF           0x0C
#define U1_RX_AF           0x0C
#define TX1_PINPOS         2
#define RX1_PINPOS         3
#define GPIO_Speed         GPIO_Speed_100MHz

/*
 *  USART Priority
 */
#define MAIN_PRIORITY      0
#define SUB_PRIORITY       0

/*
 *  GPIO Configuration Mode enumeration
 */
#define GPIO_Mode_IN    0x0					/* GPIO Input Mode */
#define GPIO_Mode_OUT   GPIO_MODER_MODER0	/* GPIO Output Mode */
#define GPIO_Mode_AF    GPIO_MODER_MODER1	/* GPIO Alternate function Mode */
#define GPIO_Mode_AN    GPIO_MODER_MODER2	/* GPIO Analog Mode */

/*
 *  GPIO Output type enumeration
 */
#define GPIO_OType_PP   0x0
#define GPIO_OType_OD   0x1

/*
 *  GPIO Output Maximum frequency enumeration
 */
#define GPIO_Speed_2MHz   0x0						/* Low speed */
#define GPIO_Speed_25MHz  GPIO_OSPEEDER_OSPEEDR0	/* Medium speed */
#define GPIO_Speed_50MHz  GPIO_OSPEEDER_OSPEEDR1	/* Fast speed */
#define GPIO_Speed_100MHz GPIO_OSPEEDER_OSPEEDR2	/* High speed on 30 pF (80 MHz Output max speed on 15 pF) */

/*
 *  GPIO Configuration PullUp PullDown enumeration
 */
#define GPIO_PuPd_NOPULL 0x0
#define GPIO_PuPd_UP     GPIO_PUPDR_PUPDR0
#define GPIO_PuPd_DOWN   GPIO_PUPDR_PUPDR1

/*
 *  USART Word Length
 */
#define USART_WordLength_8b     0x0000
#define USART_WordLength_9b     USART_CR1_M

/*
 *  USART Stop Bits
 */ 
#define USART_StopBits_1        0x0000
#define USART_StopBits_0_5      USART_CR2_STOP_0
#define USART_StopBits_2        USART_CR2_STOP_1
#define USART_StopBits_1_5      USART_CR2_STOP

/*
 *  USART Parity
 */
#define USART_Parity_No         0x0000
#define USART_Parity_Even       USART_CR1_PCE
#define USART_Parity_Odd        (USART_CR1_PCE | USART_CR1_PS) 

/*
 *  USART MODE
 */
#define USART_Mode_Rx           USART_CR1_RE
#define USART_Mode_Tx           USART_CR1_TE


#define UART_CLOCKPRESCALER     0x00000000
#define UART_CLOCK_DIV_FACTOR   1

/** @defgroup USART_Hardware_Flow_Control 
  * @{
  */ 
#define USART_HardwareFlowControl_None       0x0000
#define USART_HardwareFlowControl_RTS        USART_CR3_RTSE
#define USART_HardwareFlowControl_CTS        USART_CR3_CTSE
#define USART_HardwareFlowControl_RTS_CTS    (USART_CR3_RTSE | USART_CR3_CTSE)

#define CR1_CLEAR_MASK          (USART_CR1_M | USART_CR1_PCE | USART_CR1_PS | USART_CR1_TE | USART_CR1_RE)
#define CR3_CLEAR_MASK          (USART_CR3_RTSE | USART_CR3_CTSE)


typedef struct usart_struct {
	unsigned int    taddr;
	unsigned int	no;
	unsigned int    shift;
} usart_struct_t;

static usart_struct_t usart_table[MAX_SERIAL] = {
	{	TADR_LPUART1_BASE, (IRQ_VECTOR_LPUART1-16), 10 }
};

void SendTXWait(int id);
extern int MonVector[];
extern void RCC_GetClocksFreq(RCC_ClocksTypeDef* RCC_Clocks);


static void sys_putc(int c)
{
	SendTXWait(DEF_MON_SERIAL);
	SendTX(DEF_MON_SERIAL, c);
	if(c == '\n'){
		SendTXWait(DEF_MON_SERIAL);
		SendTX(DEF_MON_SERIAL, '\r');
	}
}

static void sys_printf(const char *s)
{
	int c;

	while((c = *s++) != 0){
		sys_putc(c);
	}
}

#if 0	/* ROI DEBUG */
void put_hex(char a, int val)
{
	int i, j;
	sys_putc(a);
	sys_putc(' ');
	for(i = 28 ; i >= 0 ; i-= 4){
		j = (val >> i) & 0xf;;
		if(j > 9)
			j += ('A'-10);
		else
			j += '0';
		sys_putc(j);
	}
	sys_putc('\n');
	sys_putc('\r');
}


#endif	/* ROI DEBUG */
void Disable(void)
{
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_ICER+((usart_table[0].no>>5)*4)), 1 << (usart_table[0].no & 0x1F));
}

void Enable(void)
{
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_ISER+((usart_table[0].no>>5)*4)), 1 << (usart_table[0].no & 0x1F));
}

/*
 *  ̤㳰äν
 */
void NMI_Handler(void)
{
    sys_printf("NMI Exception occurs. !\n");
    while(1);
}

void HardFault_Handler(void)
{
    sys_printf("Hard Fault Exception occurs. !\n");
    while(1);
}

void MemManage_Handler(void)
{
    sys_printf("Memory Manager Exception occurs. !\n");
    while(1);
}

void BusFault_Handler(void)
{
    sys_printf("Bus Fault Exception occurs. !\n");
    while(1);
}


void UsageFault_Handler(void)
{
    sys_printf("Usage Fault Exception occurs. !\n");
    while(1);
}

void DebugMon_Handler(void)
{
    sys_printf("Debug Monitor Exception occurs. !\n");
    while(1);
}

void PendSV_Handler(void)
{
    sys_printf("Pend SV Exception occurs. !\n");
    while(1);
}

static void setup_gpio_source(uint32_t base, unsigned char source, unsigned char select)
{
	uint32_t tmpreg, regoff;
	regoff = TOFF_GPIO_AFR0+((source>>1) & 0x4);
	tmpreg = (sil_rew_mem((uint32_t *)(base+regoff)) & ~(0xF << ((source & 0x07) * 4)))
			    | (select << ((source & 0x07) * 4));
	sil_wrw_mem((uint32_t *)(base+regoff), tmpreg);
}

/*
 *	Initialize Serial Channel
 *  Input: id: Serial Channel #
 */
void InitSIO(int id)
{
	unsigned int  usart_base = usart_table[id].taddr;
	RCC_ClocksTypeDef RCC_ClocksStatus;
	unsigned int   tmpreg = 0x00, csource = 0;
	unsigned char  tmppriority = 0x00, tmppre = 0x00, tmpsub = 0x0F;

	if(id != 0)
		return;

	/*
	 *  USART/GPIOå
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+U1_RCC_USART), U1_USART);
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB2ENR), U1_PORT);

	/*
	 *  TX-GPIO
	 */
	sil_modw_mem((uint32_t *)(TADR_U1_GPIO_BASE+TOFF_GPIO_MODER), (GPIO_MODER_MODER2 << (TX1_PINPOS*2)), (GPIO_Mode_AF << (TX1_PINPOS*2)));
	sil_modw_mem((uint32_t *)(TADR_U1_GPIO_BASE+TOFF_GPIO_OSPEEDR), (GPIO_OSPEEDER_OSPEEDR2 << (TX1_PINPOS*2)), (GPIO_Speed << (TX1_PINPOS*2)));
	sil_modw_mem((uint32_t *)(TADR_U1_GPIO_BASE+TOFF_GPIO_OTYPER), (GPIO_OTYPER_OT << TX1_PINPOS), (GPIO_OType_PP << TX1_PINPOS));
	sil_modw_mem((uint32_t *)(TADR_U1_GPIO_BASE+TOFF_GPIO_PUPDR), (GPIO_PUPDR_PUPDR2 << (TX1_PINPOS*2)), (GPIO_PuPd_UP << (TX1_PINPOS*2)));

	/*
	 *  RX-GPIO
	 */
	sil_modw_mem((uint32_t *)(TADR_U1_GPIO_BASE+TOFF_GPIO_MODER), (GPIO_MODER_MODER2 << (RX1_PINPOS*2)), (GPIO_Mode_AF << (RX1_PINPOS*2)));
	sil_modw_mem((uint32_t *)(TADR_U1_GPIO_BASE+TOFF_GPIO_OSPEEDR), (GPIO_OSPEEDER_OSPEEDR2 << (RX1_PINPOS*2)), (GPIO_Speed << (RX1_PINPOS*2)));
	sil_modw_mem((uint32_t *)(TADR_U1_GPIO_BASE+TOFF_GPIO_OTYPER), (GPIO_OTYPER_OT << RX1_PINPOS), (GPIO_OType_PP << RX1_PINPOS));
	sil_modw_mem((uint32_t *)(TADR_U1_GPIO_BASE+TOFF_GPIO_PUPDR), (GPIO_PUPDR_PUPDR2 << (RX1_PINPOS*2)), (GPIO_PuPd_UP << (RX1_PINPOS*2)));

	/*
	 *  RX/TX AF
	 */
	setup_gpio_source(TADR_U1_GPIO_BASE, TX1_PINPOS, U1_TX_AF);
	setup_gpio_source(TADR_U1_GPIO_BASE, RX1_PINPOS, U1_RX_AF);
	sil_dly_nse(200*1000);

	/*
	 *  USART STOPӥå
	 */
	sil_modw_mem((uint32_t *)(usart_base+TOFF_USART_CR2), USART_CR2_STOP, USART_StopBits_1);

	/*
	 *  USART ǡĹѥƥ̿⡼
	 */
	sil_modw_mem((uint32_t *)(usart_base+TOFF_USART_CR1), CR1_CLEAR_MASK, USART_WordLength_8b | USART_Parity_No | USART_Mode_Rx | USART_Mode_Tx);

	/*
	 *  USART ե
	 */
	sil_modw_mem((uint32_t *)(usart_base+TOFF_USART_CR3), CR3_CLEAR_MASK, USART_HardwareFlowControl_None);

	/*
	 *  USART BAUD
	 */
	RCC_GetClocksFreq(&RCC_ClocksStatus);
	csource = (sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CCIPR)) >> usart_table[id].shift) & 3;
	if(usart_base == TADR_LPUART1_BASE){	/* LPUART */
		sil_modw_mem((uint32_t *)(usart_base+TOFF_USART_PRESC), USART_PRESC_PRESCALER, UART_CLOCKPRESCALER);	/* DIV1 */
		switch(csource){
		case RCC_USARTCLKSOURCE_SYSCLK:
			tmpreg = RCC_ClocksStatus.SYSCLK_Frequency;
			break;
		case RCC_USARTCLKSOURCE_HSI:
			tmpreg = HSI_VALUE;
			break;
		case RCC_USARTCLKSOURCE_LSE:
			tmpreg = LSE_VALUE;
			break;
		default:
			tmpreg = RCC_ClocksStatus.PCLK1_Frequency;
			break;
		}
		tmpreg = (((unsigned long long)(tmpreg / UART_CLOCK_DIV_FACTOR) * 256U) + (DEFAULT_SPEED / 2U)) / DEFAULT_SPEED;
	}
	else{	/* USART */
		switch(csource){
		case RCC_USARTCLKSOURCE_SYSCLK:
			tmpreg = RCC_ClocksStatus.SYSCLK_Frequency;
			break;
		case RCC_USARTCLKSOURCE_HSI:
			tmpreg = HSI_VALUE;
			break;
		case RCC_USARTCLKSOURCE_LSE:
			tmpreg = LSE_VALUE;
			break;
		default:
			if(usart_base == TADR_USART1_BASE || usart_base == TADR_UART5_BASE)
				tmpreg = RCC_ClocksStatus.PCLK2_Frequency;
			else
				tmpreg = RCC_ClocksStatus.PCLK1_Frequency;
			break;
		}
		if((sil_rew_mem((uint32_t *)(usart_base+TOFF_USART_CR1)) & USART_CR1_OVER8) != 0){
			unsigned int usartdiv = ((tmpreg/2) + (DEFAULT_SPEED/2)) / DEFAULT_SPEED;
			tmpreg = usartdiv & 0xFFF0U;
			tmpreg |= (unsigned short)((usartdiv & 0x0000000F) >> 1);
		}
		else{
			tmpreg = (tmpreg + (DEFAULT_SPEED/2)) / DEFAULT_SPEED;
		}
	}
	sil_wrw_mem((uint32_t *)(usart_base+TOFF_USART_BRR), tmpreg);

	sil_andw_mem((uint32_t *)(usart_base+TOFF_USART_CR2), (USART_CR2_LINEN | USART_CR2_CLKEN));
	sil_andw_mem((uint32_t *)(usart_base+TOFF_USART_CR3), (USART_CR3_SCEN | USART_CR3_HDSEL | USART_CR3_IREN));

	sil_modw_mem((uint32_t *)(usart_base+TOFF_USART_CR1), 0, USART_CR1_RXNEIE);

	/*
	 *  NVIC USART
	 */
	tmppriority = (0x700 - (sil_rew_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_AIRCR)) & 0x700))>> 0x08;
	tmppre = (0x4 - tmppriority);
	tmpsub = tmpsub >> tmppriority;

	tmppriority = MAIN_PRIORITY << tmppre;					// the priority group of the USART1 interrupts (0)
	tmppriority |=  (SUB_PRIORITY & tmpsub);		// this sets the subpriority inside the group (0)
	tmppriority = tmppriority << 0x04;

	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_IP+usart_table[id].no*4), tmppriority);

	/*
	 *  USART ͭ
	 */
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_ISER+((usart_table[id].no>>5)*4)), 0x01 << (usart_table[id].no & 0x1F));

    /*
	 *  USART ͭ
	 */
	sil_orw_mem((uint32_t *)(usart_base+TOFF_USART_CR1), USART_CR1_UE);
}

/*
 *  LPUART1ߥϥɥ
 */
void LPUART1_IRQHandler(void)
{
	unsigned int regcr1 = sil_rew_mem((uint32_t *)(usart_table[0].taddr+TOFF_USART_CR1));
	unsigned int regisr = sil_rew_mem((uint32_t *)(usart_table[0].taddr+TOFF_USART_ISR));

	/*
	 *  å
	 */
	if((regcr1 & USART_CR1_RXNEIE) != 0 && (regisr & USART_ISR_RXNE) != 0){
		ComInterRX(0);
	}

	/*
	 *  å
	 */
	if((regcr1 & USART_CR1_TXEIE) != 0 && (regisr & USART_ISR_TXE) != 0){
		ComInterTX(0);
	}
}

/*
 *  Get RX Data
 *  Input: id: Serial Channel #
 *  output: c: Rx Data
 */
unsigned short GetRxData(int id)
{
	return sil_rew_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_RDR)) | CHKRXDATA;
}

/*
 *  Enable Tx interrupt
 *  Input: id: Serial Channel #
 */
void EnableITX(int id)
{
	sil_orw_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_CR1), USART_CR1_TXEIE);
}

/*
 *  Disable Tx interrupt
 *  Input: id: Serial Channel #
 */
void DisableITX(int id)
{
	sil_andw_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_CR1), USART_CR1_TXEIE);
}

/*
 *  Send Tx in interrupt
 *  Input: id: Serial Channel #
 *         c : Send charactor
 */
void SendTX(int id, char c)
{
	sil_wrw_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_TDR), (c & 0xFF));
}

/*
 * Send Tx wait
 * Inputs: id: Serial Channel #
 */
void SendTXWait(int id)
{
	while((sil_rew_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_ISR)) & USART_ISR_TC) == 0);
}

