
#ifndef _SYS_DEFS_H_
#define _SYS_DEFS_H_

/*	Values	*/
#if BOARDNO == 1
#define TARGET_CPU_STR		"STM32G431 Nucleo-64"
#else
#define TARGET_CPU_STR		"STM32G474 Nucleo-64"
#endif

/* endian */
#define SIL_ENDIAN      0		/* LITTLE ENDIAN */

/*	Address		*/
#define RAM_BASE        0x20000000
#if BOARDNO == 1
#define RAM_SIZE        (22*1024)
#else
#define RAM_SIZE        (96*1024)
#endif

/*
 *  ԤΤ
 *  ϥåȿ˰¸롣
 */
#define SIL_DLY_TIM1    44
#define SIL_DLY_TIM2    24

/*	Default Values	*/

#define MAX_INT_NUM     102
#define DEF_DUMP_LENGTH	256
#define NOT_INITDECT
#define RESET_VECTOR    1

#ifndef TOPPERS_MACRO_ONLY
/*
 *  ѥ¸Υǡ
 */
#define	_int8_		char		/* 8ӥåȤ	*/
#define	_int16_		short		/* 16ӥåȤ	*/
#define	_int32_		int			/* 32ӥåȤ	*/

/*
 *  ѥγĥǽΤΥޥ
 */
#define	Inline          static inline

typedef struct {
	unsigned int SYSCLK_Frequency;	/*  SYSCLK clock frequency expressed in Hz */
	unsigned int PCLK1_Frequency;	/*  PCLK1 clock frequency expressed in Hz */
	unsigned int PCLK2_Frequency;	/*  PCLK2 clock frequency expressed in Hz */
}RCC_ClocksTypeDef;

#endif	/* TOPPERS_MACRO_ONLY */

/*	Serial Channels		*/

#define MAX_SERIAL		1
#define DEF_MON_SERIAL	0

#include "stm32g4xx.h"

/* serial definitions */

#define DEFAULT_SPEED		115200

#endif	/* SYS_DEFS_H_ */

