/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2015-2019 by Roi Takeuchi
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */
/*
 *	rommon Serial Functions
 */
#include "sys_defs.h"
#include <string.h>
#include "sil.h"
#include "serial.h"
#include "mondefs.h"

#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))
#define sil_andw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) & ~(b))
#define sil_modw_mem(a, b, c)	sil_wrw_mem((a), (sil_rew_mem(a) & (~b)) | (c))

/*
 *  USART TIMEOUT
 */
#define UART_TIMEOUT_VALUE              0x1FFFFFF

/*
 *  USART Priority
 */
#define MAIN_PRIORITY      0
#define SUB_PRIORITY       1

/*
 *  USART_Hardware_Flow_Control UART Hardware Flow Control
 */
#define UART_HWCONTROL_NONE                 0x00000000

/*
 *  UARTEx_Word_Length UARTEx Word Length
 */
#define UART_WORDLENGTH_7B                  USART_CR1_M_1
#define UART_WORDLENGTH_8B                  0x00000000
#define UART_WORDLENGTH_9B                  USART_CR1_M_0

/*
 *  UART_Stop_Bits   UART Number of Stop Bits
 */
#define UART_STOPBITS_0_5                   USART_CR2_STOP_0		/* UART frame with 0.5 stop bit */
#define UART_STOPBITS_1                     0x00000000				/* UART frame with 1 stop bit */
#define UART_STOPBITS_1_5                   (USART_CR2_STOP_0 | USART_CR2_STOP_1)	/* UART frame with 1.5 stop bits */
#define UART_STOPBITS_2                     USART_CR2_STOP_1		/* UART frame with 2 stop bits */

/*
 *  UART_Parity  UART Parity
 */
#define UART_PARITY_NONE                    0x00000000				/* No parity */
#define UART_PARITY_EVEN                    USART_CR1_PCE			/* Even parity */
#define UART_PARITY_ODD                     (USART_CR1_PCE | USART_CR1_PS)	/* Odd parity  */

/*
 *  UART_Mode UART Transfer Mode
 */
#define UART_MODE_RX                        USART_CR1_RE			/* RX mode */
#define UART_MODE_TX                        USART_CR1_TE			/* TX mode */
#define UART_MODE_TX_RX                     (USART_CR1_TE |USART_CR1_RE)	/* RX and TX mode */

/*
 *  UART_ClockPrescaler
 */
#define UART_PRESCALER_DIV1                 0x00000000				/* fclk_pres = fclk */
#define UART_PRESCALER_DIV2                 0x00000001				/* fclk_pres = fclk/2 */
#define UART_PRESCALER_DIV4                 0x00000002				/* fclk_pres = fclk/4 */
#define UART_PRESCALER_DIV6                 0x00000003				/* fclk_pres = fclk/6 */
#define UART_PRESCALER_DIV8                 0x00000004				/* fclk_pres = fclk/8 */
#define UART_PRESCALER_DIV10                0x00000005				/* fclk_pres = fclk/10 */
#define UART_PRESCALER_DIV12                0x00000006				/* fclk_pres = fclk/12 */
#define UART_PRESCALER_DIV16                0x00000007				/* fclk_pres = fclk/16 */
#define UART_PRESCALER_DIV32                0x00000008				/* fclk_pres = fclk/32 */
#define UART_PRESCALER_DIV64                0x00000009				/* fclk_pres = fclk/64 */
#define UART_PRESCALER_DIV128               0x0000000A				/* fclk_pres = fclk/128 */
#define UART_PRESCALER_DIV256               0x0000000B				/* fclk_pres = fclk/256 */

/*
 *  UART ISR ACK Flag
 */
#define ISR_ACK                             (USART_ISR_TEACK | USART_ISR_REACK)

/*
 *  RCCEx_USART16_Clock_Source
 */
#define RCC_USART16CLKSOURCE_D2PCLK2        (0x00000000U)
#define RCC_USART16CLKSOURCE_PLL2           RCC_D2CCIP2R_USART16SEL_0
#define RCC_USART16CLKSOURCE_PLL3           RCC_D2CCIP2R_USART16SEL_1
#define RCC_USART16CLKSOURCE_HSI            (RCC_D2CCIP2R_USART16SEL_0 | RCC_D2CCIP2R_USART16SEL_1)
#define RCC_USART16CLKSOURCE_CSI            RCC_D2CCIP2R_USART16SEL_2
#define RCC_USART16CLKSOURCE_LSE            (RCC_D2CCIP2R_USART16SEL_0 | RCC_D2CCIP2R_USART16SEL_2)

#define RCC_USART234578CLKSOURCE_D2PCLK1    (0x00000000U)
#define RCC_USART234578CLKSOURCE_PLL2       RCC_D2CCIP2R_USART28SEL_0
#define RCC_USART234578CLKSOURCE_PLL3       RCC_D2CCIP2R_USART28SEL_1
#define RCC_USART234578CLKSOURCE_HSI        (RCC_D2CCIP2R_USART28SEL_0 | RCC_D2CCIP2R_USART28SEL_1)
#define RCC_USART234578CLKSOURCE_CSI        RCC_D2CCIP2R_USART28SEL_2
#define RCC_USART234578CLKSOURCE_LSE        (RCC_D2CCIP2R_USART28SEL_0 | RCC_D2CCIP2R_USART28SEL_2)

typedef struct usart_struct {
	unsigned int    taddr;
	unsigned int	no;
} usart_struct_t;

typedef struct usart_gpio {
	unsigned int    tx_gaddr;
	unsigned int    rx_gaddr;
	unsigned int	tx_af;
	unsigned int	rx_af;
	unsigned int	tx_pin;
	unsigned int	rx_pin;
	unsigned int	tx_gpio_clock;
	unsigned int	rx_gpio_clock;
	unsigned int    usart_caddr;
	unsigned int	usart_clock;
} usart_gpio_t;

static const usart_struct_t usart_table[MAX_SERIAL] = {
	{ TADR_USART3_BASE, IRQ_VECTOR_USART3-16 }
};

static const usart_gpio_t usart_gpio[MAX_SERIAL] = {
	{ TADR_GPIOD_BASE, TADR_GPIOD_BASE, 0x07, 0x07, 8, 9, RCC_AHB4ENR_GPIODEN, RCC_AHB4ENR_GPIODEN,
	 (TADR_RCC_BASE+TOFF_RCC_APB1LENR), RCC_APB1LENR_USART3EN }
};


void SendTXWait(int id);
extern int MonVector[];

extern void RCC_GetClocksFreq(RCC_ClocksTypeDef* RCC_Clocks);


static void sys_putc(int c)
{
	SendTXWait(DEF_MON_SERIAL);
	SendTX(DEF_MON_SERIAL, c);
	if(c == '\n'){
		SendTXWait(DEF_MON_SERIAL);
		SendTX(DEF_MON_SERIAL, '\r');
	}
}

static void sys_printf(const char *s)
{
	int c;

	while((c = *s++) != 0){
		sys_putc(c);
	}
}

#if 1	/* ROI DEBUG */
void put_hex(char a, int val)
{
	int i, j;
	sys_putc(a);
	sys_putc(' ');
	for(i = 28 ; i >= 0 ; i-= 4){
		j = (val >> i) & 0xf;;
		if(j > 9)
			j += ('A'-10);
		else
			j += '0';
		sys_putc(j);
	}
	sys_putc('\n');
	sys_putc('\r');
}
#endif	/* ROI DEBUG */

void Disable(void)
{
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_ICER+((usart_table[0].no>>5)*4)), 1 << (usart_table[0].no & 0x1F));
}

void Enable(void)
{
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_ISER+((usart_table[0].no>>5)*4)), 1 << (usart_table[0].no & 0x1F));
}

void execDisable(void)
{
	uint32_t op_addr = ((uint32_t)&UserVector) & ~31;
	int op_end = op_addr + 0x00080000;

	asm("dsb 0xF":::"memory");
	while(op_addr < op_end) {
		sil_wrw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_DCCIMVAC), op_addr);
		op_addr += 32;
	}
	asm("dsb 0xF":::"memory");
	asm("isb 0xF":::"memory");
}

/*
 *  ̤㳰äν
 */
void NMI_Handler(void)
{
    sys_printf("NMI Exception occurs. !\n");
    while(1);
}

void HardFault_Handler(void)
{
    sys_printf("Hard Fault Exception occurs. !\n");
    while(1);
}

void MemManage_Handler(void)
{
    sys_printf("Memory Manager Exception occurs. !\n");
    while(1);
}

void BusFault_Handler(void)
{
    sys_printf("Bus Fault Exception occurs. !\n");
    while(1);
}


void UsageFault_Handler(void)
{
    sys_printf("Usage Fault Exception occurs. !\n");
    while(1);
}

void DebugMon_Handler(void)
{
    sys_printf("Debug Monitor Exception occurs. !\n");
    while(1);
}

void PendSV_Handler(void)
{
    sys_printf("Pend SV Exception occurs. !\n");
    while(1);
}

/*
 * GPIO Configuration Mode 
 * Elements values convention: 0xX0yz00YZ
 *           - X  : GPIO mode or EXTI Mode
 *           - y  : External IT or Event trigger detection 
 *           - z  : IO configuration on External IT or Event
 *           - Y  : Output type (Push Pull or Open Drain)
 *           - Z  : IO Direction mode (Input, Output, Alternate or Analog)
 */ 
#define GPIO_MODE_INPUT       0x00000000	/* Input Floating Mode                   */
#define GPIO_MODE_OUTPUT_PP   0x00000001	/* Output Push Pull Mode                 */
#define GPIO_MODE_AF_PP       0x00000002	/* Alternate Function Push Pull Mode     */
#define GPIO_MODE_ANALOG      0x00000003	/* Analog Mode  */

/*
 *  GPIO Output type enumeration
 */
#define GPIO_OTYPE_PP         0x0
#define GPIO_OTYPE_OD         0x1

/*
 * brief GPIO Output Maximum frequency
 */
#define GPIO_SPEED_LOW        0x00000000	/* Low speed     */
#define GPIO_SPEED_MEDIUM     0x00000001	/* Medium speed  */
#define GPIO_SPEED_FAST       0x00000002	/* Fast speed    */
#define GPIO_SPEED_HIGH       0x00000003	/* High speed    */

 /*
  * GPIO Pull-Up or Pull-Down Activation
  */ 
#define GPIO_NOPULL           0x00000000	/* No Pull-up or Pull-down activation  */
#define GPIO_PULLUP           0x00000001	/* Pull-up activation                  */
#define GPIO_PULLDOWN         0x00000002	/* Pull-down activation                */

#define UART_CR1_FIELDS       ((uint32_t)(USART_CR1_M | USART_CR1_PCE | USART_CR1_PS | \
                                     USART_CR1_TE | USART_CR1_RE | USART_CR1_OVER8 | USART_CR1_FIFOEN))

#define USART_CR3_FIELDS      ((uint32_t)(USART_CR3_RTSE | USART_CR3_CTSE | USART_CR3_ONEBIT| \
                                      USART_CR3_TXFTCFG | USART_CR3_RXFTCFG ))

/*
 * Encode Priority
 *  The function encodes the priority for an interrupt with the given priority group,
 *  preemptive priority value, and subpriority value.
 *  In case of a conflict between priority grouping and available
 *  priority bits (TBITW_IPRI), the smallest possible priority group is set.
 *  param [in]     PriorityGroup  Used priority group.
 *  param [in]   PreemptPriority  Preemptive priority value (starting from 0).
 *  param [in]       SubPriority  Subpriority value (starting from 0).
 *  return                        Encoded priority. Value can be used in the function \ref NVIC_SetPriority().
 */
static uint32_t EncodePriority (uint32_t PriorityGroup, uint32_t PreemptPriority, uint32_t SubPriority)
{
	uint32_t PreemptPriorityBits;
	uint32_t SubPriorityBits;

	PriorityGroup &= 0x07;
	PreemptPriorityBits = ((7 - PriorityGroup) > TBITW_IPRI) ? TBITW_IPRI : (7 - PriorityGroup);
	SubPriorityBits     = ((PriorityGroup + TBITW_IPRI) < 7) ? 0 : ((PriorityGroup - 7) + TBITW_IPRI);

	return (
           ((PreemptPriority & ((1 << PreemptPriorityBits) - 1)) << SubPriorityBits) |
           ((SubPriority     & ((1 << SubPriorityBits    ) - 1)))
	       );
}

/*
 *	Initialize Serial Channel
 *  Input: id: Serial Channel #
 */
void InitSIO(int id)
{
	const usart_gpio_t *pgpio;
	uint32_t uaddr, gaddr, n, ino, priority, prioritygrp, tickstart;
	volatile uint32_t tmpreg;
	RCC_ClocksTypeDef rcc_clocks;

	if(id != 0)
		return;

	pgpio = &usart_gpio[id];
	uaddr = usart_table[id].taddr;
	ino   = usart_table[id].no;
	gaddr = usart_gpio[id].tx_gaddr;

	/*
	 *  USART/GPIOå
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB4ENR), pgpio->tx_gpio_clock);
	tmpreg = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB4ENR));
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB4ENR), pgpio->rx_gpio_clock);
	tmpreg = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB4ENR));

	/* Enable USARTx clock */
	sil_orw_mem((uint32_t *)pgpio->usart_caddr, pgpio->usart_clock);
	/* Delay after an RCC peripheral clock enabling */
	tmpreg = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB2ENR));
	(void)(tmpreg);

	/*
	 *  TX-GPIO
	 */
	n = pgpio->tx_pin;
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_AFR0+(n >> 3)*4), (0xF << ((n & 0x07)*4)), (pgpio->tx_af << ((n & 0x07)*4)));
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_MODER), (GPIO_MODER_MODER0 << (n * 2)), (GPIO_MODE_AF_PP << (n * 2)));
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_OSPEEDR), (GPIO_OSPEEDER_OSPEEDR0 << (n * 2)), (GPIO_SPEED_HIGH << (n * 2)));
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_OTYPER), (1 << n), (GPIO_OTYPE_PP << n));
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_PUPDR), (GPIO_PUPDR_PUPDR0 << (n * 2)), ((GPIO_PULLUP) << (n * 2)));

	/*
	 *  RX-GPIO
	 */
	n = pgpio->rx_pin;
	gaddr = usart_gpio[id].rx_gaddr;
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_AFR0+(n >> 3)*4), (0xF << ((n & 0x07)*4)), (pgpio->rx_af << ((n & 0x07)*4)));
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_MODER), (GPIO_MODER_MODER0 << (n * 2)), (GPIO_MODE_AF_PP << (n * 2)));
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_OSPEEDR), (GPIO_OSPEEDER_OSPEEDR0 << (n * 2)), (GPIO_SPEED_HIGH << (n * 2)));
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_OTYPER), (1 << n), (GPIO_OTYPE_PP << n));
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_PUPDR), (GPIO_PUPDR_PUPDR0 << (n * 2)), ((GPIO_PULLUP) << (n * 2)));

	/* Disable the Peripheral */
	sil_andw_mem((uint32_t *)(uaddr+TOFF_USART_CR1), USART_CR1_UE);

	/*
	 *  USART ǡĹѥƥ̿⡼
	 */
	sil_modw_mem((uint32_t *)(uaddr+TOFF_USART_CR1), UART_CR1_FIELDS, (UART_WORDLENGTH_8B | UART_PARITY_NONE | UART_MODE_TX_RX));

	/*
	 *  USART STOPӥå
	 */
	sil_modw_mem((uint32_t *)(uaddr+TOFF_USART_CR2), USART_CR2_STOP, UART_STOPBITS_1);

	/*
	 *  USART ե
	 */
	sil_modw_mem((uint32_t *)(uaddr+TOFF_USART_CR3), USART_CR3_FIELDS, UART_HWCONTROL_NONE);

	/*
	 *  ץ쥹顼
	 */
	sil_modw_mem((uint32_t *)(uaddr+TOFF_USART_PRESC), USART_PRESC_PRESCALER, UART_PRESCALER_DIV1);

	RCC_GetClocksFreq(&rcc_clocks);
	if(uaddr == TADR_USART1_BASE || uaddr == TADR_USART6_BASE){
		switch(sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_D2CCIP2R)) & RCC_D2CCIP2R_USART16SEL){
		case RCC_USART16CLKSOURCE_D2PCLK2:
			tmpreg = rcc_clocks.PCLK2_Frequency;
	        break;
		case RCC_USART16CLKSOURCE_PLL2:
			tmpreg = rcc_clocks.PLL2_Frequency[1];
			break;
		case RCC_USART16CLKSOURCE_PLL3:
			tmpreg = rcc_clocks.PLL3_Frequency[1];
			break;
		case RCC_USART16CLKSOURCE_HSI:
			if((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_HSIDIVF) != 0)
				tmpreg = HSI_VALUE >> (sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_HSIDIV) >> 3;
			else
				tmpreg = (uint32_t) HSI_VALUE;
			break;
		case RCC_USART16CLKSOURCE_CSI:
			tmpreg = CSI_VALUE;
			break;
		case RCC_USART16CLKSOURCE_LSE:
			tmpreg = LSE_VALUE;
			break;
		default:
			return;
		}
	}
	else{	/* USART2,3 UART4-8 */
		switch(sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_D2CCIP2R)) & RCC_D2CCIP2R_USART28SEL){
		case RCC_USART234578CLKSOURCE_D2PCLK1:
			tmpreg = rcc_clocks.PCLK1_Frequency;
	        break;
		case RCC_USART234578CLKSOURCE_PLL2:
			tmpreg = rcc_clocks.PLL2_Frequency[1];
			break;
		case RCC_USART234578CLKSOURCE_PLL3:
			tmpreg = rcc_clocks.PLL3_Frequency[1];
			break;
		case RCC_USART234578CLKSOURCE_HSI:
			if((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_HSIDIVF) != 0)
				tmpreg = HSI_VALUE >> (sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_HSIDIV) >> 3;
			else
				tmpreg = (uint32_t) HSI_VALUE;
			break;
		case RCC_USART234578CLKSOURCE_CSI:
			tmpreg = CSI_VALUE;
			break;
		case RCC_USART234578CLKSOURCE_LSE:
			tmpreg = LSE_VALUE;
			break;
		default:
			return;
		}
	}
	if((sil_rew_mem((uint32_t *)(uaddr+TOFF_USART_CR1)) & USART_CR1_OVER8) != 0){
		unsigned int usartdiv = ((tmpreg/2) + (DEFAULT_SPEED/2)) / DEFAULT_SPEED;
		tmpreg = usartdiv & 0xFFF0U;
		tmpreg |= (unsigned short)((usartdiv & 0x0000000F) >> 1);
	}
	else{
		tmpreg = (tmpreg + (DEFAULT_SPEED/2)) / DEFAULT_SPEED;
	}
	sil_wrw_mem((uint32_t *)(uaddr+TOFF_USART_BRR), tmpreg);

	/* In asynchronous mode, the following bits must be kept cleared:
	- LINEN and CLKEN bits in the USART_CR2 register,
	- SCEN, HDSEL and IREN  bits in the USART_CR3 register.*/
	sil_andw_mem((uint32_t *)(uaddr+TOFF_USART_CR2), (USART_CR2_LINEN | USART_CR2_CLKEN));
	sil_andw_mem((uint32_t *)(uaddr+TOFF_USART_CR3), (USART_CR3_SCEN | USART_CR3_HDSEL | USART_CR3_IREN));

    /*
	 *  USART ͭ
	 */
	sil_orw_mem((uint32_t *)(uaddr+TOFF_USART_CR1), USART_CR1_UE);

	/* TEACK and/or REACK to check before moving huart->State to Ready */
	tickstart = 0;
    while((sil_rew_mem((uint32_t *)(uaddr+TOFF_USART_ISR)) & ISR_ACK) != ISR_ACK){
		/* Check for the Timeout */
		if(tickstart >=  UART_TIMEOUT_VALUE){
			/* Disable TXE, RXNE, PE and ERR (Frame error, noise error, overrun error) interrupts for the interrupt process */
			sil_andw_mem((uint32_t *)(uaddr+TOFF_USART_CR1), (USART_CR1_TXEIE | USART_CR1_RXNEIE | USART_CR1_PEIE));
			sil_andw_mem((uint32_t *)(uaddr+TOFF_USART_CR3), USART_CR3_EIE);
			return;
		}
		sil_dly_nse(1000);
		tickstart++;
	}

	/*
	 *  NVIC USART
	 */
	prioritygrp = (sil_rew_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_AIRCR)) & SCB_AIRCR_PRIGROUP_Msk) >> SCB_AIRCR_PRIGROUP_Pos;
	priority = EncodePriority(prioritygrp, MAIN_PRIORITY, SUB_PRIORITY);
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_IP+(ino*4)), ((priority << (8 - TBITW_IPRI)) & 0xFF));
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_ISER+(ino >> 5) * 4), (1<<(ino & 0x1F)));

    /* Enable the UART Parity Error Interrupt */
	sil_orw_mem((uint32_t *)(uaddr+TOFF_USART_CR1), USART_CR1_PEIE);

    /* Enable the UART Error Interrupt: (Frame error, noise error, overrun error) */
	sil_orw_mem((uint32_t *)(uaddr+TOFF_USART_CR3), USART_CR3_EIE);

	sil_orw_mem((uint32_t *)(uaddr+TOFF_USART_CR1), USART_CR1_RXNEIE);
}

/*
 *  this is the interrupt request handler (IRQ) for ALL USART2 interrupts
 */
void USART3_IRQHandler(void)
{
	uint32_t regcr1 = sil_rew_mem((uint32_t *)(usart_table[0].taddr+TOFF_USART_CR1));
	uint32_t regcr3 = sil_rew_mem((uint32_t *)(usart_table[0].taddr+TOFF_USART_CR3));
	uint32_t regisr = sil_rew_mem((uint32_t *)(usart_table[0].taddr+TOFF_USART_ISR));

	/* UART parity error interrupt occurred */
	if((regisr & USART_ISR_PE) != 0 && (regcr3 & USART_CR3_EIE) != 0){
		sil_wrw_mem((uint32_t *)(usart_table[0].taddr+TOFF_USART_ICR), USART_ICR_PECF);
	}

	/* UART frame error interrupt occurred */
	if((regisr & USART_ISR_FE) != 0 && (regcr3 & USART_CR3_EIE) != 0){
		sil_wrw_mem((uint32_t *)(usart_table[0].taddr+TOFF_USART_ICR), USART_ICR_FECF);
	}

	/* UART noise error interrupt occurred */
	if((regisr & USART_ISR_NE) != 0 && (regcr3 & USART_CR3_EIE) != 0){
		sil_wrw_mem((uint32_t *)(usart_table[0].taddr+TOFF_USART_ICR), USART_ICR_NCF);
	}

	/* UART Over-Run interrupt occurred */
	if((regisr & USART_ISR_ORE) != 0 && (regcr3 & USART_CR3_EIE) != 0){
		sil_wrw_mem((uint32_t *)(usart_table[0].taddr+TOFF_USART_ICR), USART_ICR_ORECF);
	}

	if((regisr & USART_ISR_RXNE) != 0 && (regcr1 & USART_CR1_RXNEIE) != 0){
		ComInterRX(0);
	}
	if((regisr & USART_ISR_TXE) != 0 && (regcr1 & USART_CR1_TXEIE) != 0){
		ComInterTX(0);
	}
}

/*
 *  Get RX Data
 *  Input: id: Serial Channel #
 *  output: c: Rx Data
 */
unsigned short GetRxData(int id)
{
	return sil_rew_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_RDR)) | CHKRXDATA;
}

/*
 *  Enable Tx interrupt
 *  Input: id: Serial Channel #
 */
void EnableITX(int id)
{
	sil_orw_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_CR1), USART_CR1_TXEIE);
}

/*
 *  Disable Tx interrupt
 *  Input: id: Serial Channel #
 */
void DisableITX(int id)
{
	sil_andw_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_CR1), USART_CR1_TXEIE);
}

/*
 *  Send Tx in interrupt
 *  Input: id: Serial Channel #
 *         c : Send charactor
 */
void SendTX(int id, char c)
{
	sil_wrw_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_TDR), (c & 0xFF));
}

/*
 * Send Tx wait
 * Inputs: id: Serial Channel #
 */
void SendTXWait(int id)
{
	while((sil_rew_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_ISR)) & USART_ISR_TC) == 0);
}

void SetVector(void *addr)
{
	sil_wrw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_VTOR), (unsigned int)addr);	/* Vector Table Relocation */
}

