
#ifndef _SYS_DEFS_H_
#define _SYS_DEFS_H_

/*	Values	*/
#define TARGET_CPU_STR	"STM32H743-Nucleo144"

/* endian */
#define SIL_ENDIAN      0		/* LITTLE ENDIAN */

/*	Address		*/
#define RAM_BASE        0x20000000
#define RAM_SIZE        (128*1024)
#define VECTOR_SIZE		(4*8)
#define FIQ_DATA_SIZE   256
#define STACKINT        (RAM_BASE+RAM_SIZE-FIQ_DATA_SIZE)	/* ߥåν */
#define STACKTOP        (STACKINT-256)						/* 桼åν */

/*
 *  ԤΤ
 *  ϥåȿ˰¸롣
 */
#define SIL_DLY_TIM1    10
#define SIL_DLY_TIM2    5

/*	Default Values	*/

#define MAX_INT_NUM     82
#define DEF_DUMP_LENGTH	256
#define NOT_INITDECT
#define RESET_VECTOR    1

#ifndef TOPPERS_MACRO_ONLY

/*
 *  Value of the External oscillator in Hz
 */
#define HSE_VALUE       (8000000)

/*
 * Value of the Internal oscillator in Hz
 */
#define CSI_VALUE       (4000000)

/*
 *  Value of the Internal oscillator in Hz
 */
#define HSI_VALUE       (64000000)

/*
 *  Value of the Internal Low Speed oscillator (LSI) value.
 */
#define LSI_VALUE       (32000)

/*
 *  Value of the External Low Speed oscillator in Hz
 */
#define LSE_VALUE       (32768)


/*
 *  ѥ¸Υǡ
 */
#define	_int8_		char		/* 8ӥåȤ	*/
#define	_int16_		short		/* 16ӥåȤ	*/
#define	_int32_		int			/* 32ӥåȤ	*/

/*
 *  ѥγĥǽΤΥޥ
 */
#define	Inline          static inline

#include "stm32h7xx.h"

typedef struct {
	unsigned int SYSCLK_Frequency;	/*  SYSCLK clock frequency expressed in Hz */
	unsigned int HCLK_Frequency;	/*  HCLK clock frequency expressed in Hz */
	unsigned int PCLK1_Frequency;	/*  PCLK1 clock frequency expressed in Hz */
	unsigned int PCLK2_Frequency;	/*  PCLK2 clock frequency expressed in Hz */
	unsigned int D3PCLK1_Frequency;	/*  D3PCLK1 clock frequency expressed in Hz */
	unsigned int PLL2_Frequency[3];	/*  PLL2 clock frequency expressed in Hz */
	unsigned int PLL3_Frequency[3];	/*  PLL3 clock frequency expressed in Hz */
}RCC_ClocksTypeDef;

#endif	/* TOPPERS_MACRO_ONLY */

/*	Serial Channels		*/
#define MAX_SERIAL		1
#define DEF_MON_SERIAL	0

/* serial definitions */

#define DEFAULT_SPEED		115200

#endif	/* SYS_DEFS_H_ */

