
#ifndef _SYS_DEFS_H_
#define _SYS_DEFS_H_

/*	Values	*/
#if BOARDNO == 1
#if MSI_RANGE == 0
#define TARGET_CPU_STR		"STM32WB55 USBDongle(D)"
#else
#define TARGET_CPU_STR		"STM32WB55 USBDongle(M)"
#endif
#else
#if MSI_RANGE == 0
#define TARGET_CPU_STR		"STM32WB55 Nucleo(D)"
#else
#define TARGET_CPU_STR		"STM32WB55 Nucleo(M)"
#endif
#endif

/* endian */
#define SIL_ENDIAN      0		/* LITTLE ENDIAN */

/*	Address		*/
#define RAM_BASE        0x20000000
#define RAM_SIZE        (192*1024)
#define VECTOR_SIZE		(4*80)

/*
 *  ԤΤ
 *  ϥåȿ˰¸롣
 */
#define SIL_DLY_TIM1    50
#if  MSI_RANGE != 0
#define SIL_DLY_TIM2   ((8050) / (1<<(MSI_RANGE+1)))
#else
#define SIL_DLY_TIM2   120
#endif

/*	Default Values	*/

#define MAX_INT_NUM     63
#define DEF_DUMP_LENGTH	256
#define NOT_INITDECT
#define RESET_VECTOR    1
#define USE_FPU         1

#ifndef TOPPERS_MACRO_ONLY
/*
 *  ѥ¸Υǡ
 */
#define	_int8_		char		/* 8ӥåȤ	*/
#define	_int16_		short		/* 16ӥåȤ	*/
#define	_int32_		int			/* 32ӥåȤ	*/

/*
 *  ѥγĥǽΤΥޥ
 */
#define	Inline          static inline

typedef struct {
	unsigned int SYSCLK_Frequency;	/*  SYSCLK clock frequency expressed in Hz */
	unsigned int HCLK_Frequency;	/*  HCLK clock frequency expressed in Hz */
	unsigned int PCLK1_Frequency;	/*  PCLK1 clock frequency expressed in Hz */
	unsigned int PCLK2_Frequency;	/*  PCLK2 clock frequency expressed in Hz */
}RCC_ClocksTypeDef;

#endif	/* TOPPERS_MACRO_ONLY */

/*	Serial Channels		*/

#define MAX_SERIAL		1
#define DEF_MON_SERIAL	0

#include "stm32wbxx.h"

/* serial definitions */

#define DEFAULT_SPEED		115200

#endif	/* SYS_DEFS_H_ */

