/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2016-2017 by TOPPERS PROJECT Educational Working Group.
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: socfpga_cv.h,v 1.1 2017/03/08 18:56:02 roi Exp $
 */

#ifndef _SOCFPGA_CV_H_
#define _SOCFPGA_CV_H_

/*
 *  åȤ̤뤿Υޥ
 */
#define TOPPERS_CYCLONE_V_SOC					/* ƥά */

/*
 *  ֹκ
 */
#ifndef TMAX_INTNO
#define TMAX_INTNO                          256
#endif

/*
 *  INTERRUPT NUMBER
 */
#define INTNO_SGI0                          0	/* Software Interrupt #0 */
#define INTNO_SGI1                          1	/* Software Interrupt #1 */
#define INTNO_SGI2                          2	/* Software Interrupt #2 */
#define INTNO_SGI3                          3	/* Software Interrupt #3 */
#define INTNO_SGI4                          4	/* Software Interrupt #4 */
#define INTNO_SGI5                          5	/* Software Interrupt #5 */
#define INTNO_SGI6                          6	/* Software Interrupt #6 */
#define INTNO_SGI7                          7	/* Software Interrupt #7 */
#define INTNO_SGI8                          8	/* Software Interrupt #8 */
#define INTNO_SGI9                          9	/* Software Interrupt #9 */
#define INTNO_SGI10                         10	/* Software Interrupt #10 */
#define INTNO_SGI11                         11	/* Software Interrupt #11 */
#define INTNO_SGI12                         12	/* Software Interrupt #12 */
#define INTNO_SGI13                         13	/* Software Interrupt #13 */
#define INTNO_SGI14                         14	/* Software Interrupt #14 */
#define INTNO_SGI15                         15	/* Software Interrupt #15 */

#define INTNO_PPI_TIMER_GLOBAL              27	/* Private Peripheral Interrupts Global Timer */
#define INTNO_PPI_TIMER_PRIVATE             29	/* Private Peripheral Interrupts Private Timer */
#define INTNO_PPI_TIMER_WATCHDOG            30	/* Private Peripheral Interrupts watchdog */

#define INTNO_CPU0_PARITYFAIL               32	/* CPU0 PARITYFAIL */
#define INTNO_CPU0_PARITYFAIL_BTAC          33	/* CPU0 PARITYFAIL BTAC */
#define INTNO_CPU0_PARITYFAIL_GHB           34	/* CPU0 PARITYFAIL GHB */
#define INTNO_CPU0_PARITYFAIL_I_TAG         35	/* CPU0 PARITYFAIL I_TAG */
#define INTNO_CPU0_PARITYFAIL_I_DATA        36	/* CPU0 PARITYFAIL I_DATA */
#define INTNO_CPU0_PARITYFAIL_TLB           37	/* CPU0 PARITYFAIL TLB */
#define INTNO_CPU0_PARITYFAIL_D_OUTER       38 	/* CPU0 PARITYFAIL D_OUTER */
#define INTNO_CPU0_PARITYFAIL_D_TAG         39	/* CPU0 PARITYFAIL D_TAG */
#define INTNO_CPU0_PARITYFAIL_D_DATA        40	/* CPU0 PARITYFAIL D_DATA  */
#define INTNO_CPU0_DEFLAGS0                 41	/* CPU0 DEFFLAG0 */
#define INTNO_CPU0_DEFLAGS1                 42	/* CPU0 DEFFLAG1 */
#define INTNO_CPU0_DEFLAGS2                 43	/* CPU0 DEFFLAG2 */
#define INTNO_CPU0_DEFLAGS3                 44	/* CPU0 DEFFLAG3 */
#define INTNO_CPU0_DEFLAGS4                 45	/* CPU0 DEFFLAG4 */
#define INTNO_CPU0_DEFLAGS5                 46	/* CPU0 DEFFLAG5 */
#define INTNO_CPU0_DEFLAGS6                 47	/* CPU0 DEFFLAG6 */

#define INTNO_CPU1_PARITYFAIL               48	/* CPU1 PARITYFAIL */
#define INTNO_CPU1_PARITYFAIL_BTAC          49	/* CPU1 PARITYFAIL BTAC */
#define INTNO_CPU1_PARITYFAIL_GHB           50	/* CPU1 PARITYFAIL GHB */
#define INTNO_CPU1_PARITYFAIL_I_TAG         51	/* CPU1 PARITYFAIL I_TAG */
#define INTNO_CPU1_PARITYFAIL_I_DATA        52	/* CPU1 PARITYFAIL I_DATA */
#define INTNO_CPU1_PARITYFAIL_TLB           53	/* CPU1 PARITYFAIL TLB */
#define INTNO_CPU1_PARITYFAIL_D_OUTER       54	/* CPU1 PARITYFAIL D_OUTER */
#define INTNO_CPU1_PARITYFAIL_D_TAG         55	/* CPU1 PARITYFAIL D_TAG */
#define INTNO_CPU1_PARITYFAIL_D_DATA        56	/* CPU1 PARITYFAIL D_DATA */
#define INTNO_CPU1_DEFLAGS0                 57	/* CPU1 DEFFLAG0 */
#define INTNO_CPU1_DEFLAGS1                 58	/* CPU1 DEFFLAG1 */
#define INTNO_CPU1_DEFLAGS2                 59	/* CPU1 DEFFLAG2 */
#define INTNO_CPU1_DEFLAGS3                 60	/* CPU1 DEFFLAG3 */
#define INTNO_CPU1_DEFLAGS4                 61	/* CPU1 DEFFLAG4 */
#define INTNO_CPU1_DEFLAGS5                 62	/* CPU1 DEFFLAG5 */
#define INTNO_CPU1_DEFLAGS6                 63	/* CPU1 DEFFLAG6 */

/*
 *  Interrupts sourced from the Snoop Control Unit (SCU).
 */
#define INTNO_SCU_PARITYFAIL0               64
#define INTNO_SCU_PARITYFAIL1               65
#define INTNO_SCU_EV_ABORT                  66

/*
 *  Interrupts sourced from the L2 Cache Controller.
 */
#define INTNO_L2_ECC_BYTE_WR_IRQ            67
#define INTNO_L2_ECC_CORRECTED_IRQ          68
#define INTNO_L2_ECC_UNCORRECTED_IRQ        69
#define INTNO_L2_COMBINED_IRQ               70

/*
 *  Interrupts sourced from the SDRAM Controller.
 */
#define INTNO_DDR_ECC_ERROR_IRQ             71

/*
 *  Interrupt request from the FPGA logic, 0 - 63.
 */
#define INTNO_F2S_FPGA_IRQ0                 72
#define INTNO_F2S_FPGA_IRQ1                 73
#define INTNO_F2S_FPGA_IRQ2                 74
#define INTNO_F2S_FPGA_IRQ3                 75
#define INTNO_F2S_FPGA_IRQ4                 76
#define INTNO_F2S_FPGA_IRQ5                 77
#define INTNO_F2S_FPGA_IRQ6                 78
#define INTNO_F2S_FPGA_IRQ7                 79
#define INTNO_F2S_FPGA_IRQ8                 80
#define INTNO_F2S_FPGA_IRQ9                 81
#define INTNO_F2S_FPGA_IRQ10                82
#define INTNO_F2S_FPGA_IRQ11                83
#define INTNO_F2S_FPGA_IRQ12                84
#define INTNO_F2S_FPGA_IRQ13                85
#define INTNO_F2S_FPGA_IRQ14                86
#define INTNO_F2S_FPGA_IRQ15                87
#define INTNO_F2S_FPGA_IRQ16                88
#define INTNO_F2S_FPGA_IRQ17                89
#define INTNO_F2S_FPGA_IRQ18                90
#define INTNO_F2S_FPGA_IRQ19                91
#define INTNO_F2S_FPGA_IRQ20                92
#define INTNO_F2S_FPGA_IRQ21                93
#define INTNO_F2S_FPGA_IRQ22                94
#define INTNO_F2S_FPGA_IRQ23                95
#define INTNO_F2S_FPGA_IRQ24                96
#define INTNO_F2S_FPGA_IRQ25                97
#define INTNO_F2S_FPGA_IRQ26                98
#define INTNO_F2S_FPGA_IRQ27                99
#define INTNO_F2S_FPGA_IRQ28                100
#define INTNO_F2S_FPGA_IRQ29                101
#define INTNO_F2S_FPGA_IRQ30                102
#define INTNO_F2S_FPGA_IRQ31                103
#define INTNO_F2S_FPGA_IRQ32                104
#define INTNO_F2S_FPGA_IRQ33                105
#define INTNO_F2S_FPGA_IRQ34                106
#define INTNO_F2S_FPGA_IRQ35                107
#define INTNO_F2S_FPGA_IRQ36                108
#define INTNO_F2S_FPGA_IRQ37                109
#define INTNO_F2S_FPGA_IRQ38                110
#define INTNO_F2S_FPGA_IRQ39                111
#define INTNO_F2S_FPGA_IRQ40                112
#define INTNO_F2S_FPGA_IRQ41                113
#define INTNO_F2S_FPGA_IRQ42                114
#define INTNO_F2S_FPGA_IRQ43                115
#define INTNO_F2S_FPGA_IRQ44                116
#define INTNO_F2S_FPGA_IRQ45                117
#define INTNO_F2S_FPGA_IRQ46                118
#define INTNO_F2S_FPGA_IRQ47                119
#define INTNO_F2S_FPGA_IRQ48                120
#define INTNO_F2S_FPGA_IRQ49                121
#define INTNO_F2S_FPGA_IRQ50                122
#define INTNO_F2S_FPGA_IRQ51                123
#define INTNO_F2S_FPGA_IRQ52                124
#define INTNO_F2S_FPGA_IRQ53                125
#define INTNO_F2S_FPGA_IRQ54                126
#define INTNO_F2S_FPGA_IRQ55                127
#define INTNO_F2S_FPGA_IRQ56                128
#define INTNO_F2S_FPGA_IRQ57                129
#define INTNO_F2S_FPGA_IRQ58                130
#define INTNO_F2S_FPGA_IRQ59                131
#define INTNO_F2S_FPGA_IRQ60                132
#define INTNO_F2S_FPGA_IRQ61                133
#define INTNO_F2S_FPGA_IRQ62                134
#define INTNO_F2S_FPGA_IRQ63                135

/*
 *  Interrupts sourced from the DMA Controller.
 */
#define INTNO_DMA_IRQ0                      136
#define INTNO_DMA_IRQ1                      137
#define INTNO_DMA_IRQ2                      138
#define INTNO_DMA_IRQ3                      139
#define INTNO_DMA_IRQ4                      140
#define INTNO_DMA_IRQ5                      141
#define INTNO_DMA_IRQ6                      142
#define INTNO_DMA_IRQ7                      143
#define INTNO_DMA_IRQ_ABORT                 144
#define INTNO_DMA_ECC_CORRECTED_IRQ         145
#define INTNO_DMA_ECC_UNCORRECTED_IRQ       146

/*
 *  Interrupts sourced from the Ethernet MAC 0 (EMAC0).
 */
#define INTNO_EMAC0_IRQ                     147
#define INTNO_EMAC0_TX_ECC_CORRECTED_IRQ    148
#define INTNO_EMAC0_TX_ECC_UNCORRECTED_IRQ  149
#define INTNO_EMAC0_RX_ECC_CORRECTED_IRQ    150
#define INTNO_EMAC0_RX_ECC_UNCORRECTED_IRQ  151

/*
 *  Interrupts sourced from the Ethernet MAC 1 (EMAC1).
 */
#define INTNO_EMAC1_IRQ                     152
#define INTNO_EMAC1_TX_ECC_CORRECTED_IRQ    153
#define INTNO_EMAC1_TX_ECC_UNCORRECTED_IRQ  154
#define INTNO_EMAC1_RX_ECC_CORRECTED_IRQ    155
#define INTNO_EMAC1_RX_ECC_UNCORRECTED_IRQ  156

/*
 *  Interrupts sourced from the USB OTG 0.
 */
#define INTNO_USB0_IRQ                      157
#define INTNO_USB0_ECC_CORRECTED            158
#define INTNO_USB0_ECC_UNCORRECTED          159

/*
 *  Interrupts sourced from the USB OTG 1.
 */
#define INTNO_USB1_IRQ                      160
#define INTNO_USB1_ECC_CORRECTED            161
#define INTNO_USB1_ECC_UNCORRECTED          162

/*
 *  Interrupts sourced from the CAN Controller 0.
 */
#define INTNO_CAN0_STS_IRQ                  163
#define INTNO_CAN0_MO_IRQ                   164
#define INTNO_CAN0_ECC_CORRECTED_IRQ        165
#define INTNO_CAN0_ECC_UNCORRECTED_IRQ      166,

/*
 *  Interrupts sourced from the CAN Controller 1.
 */
#define INTNO_CAN1_STS_IRQ                  167
#define INTNO_CAN1_MO_IRQ                   168
#define INTNO_CAN1_ECC_CORRECTED_IRQ        169
#define INTNO_CAN1_ECC_UNCORRECTED_IRQ      170

/*
 *  Interrupts sourced from the SDMMC Controller.
 */
#define INTNO_SDMMC_IRQ                     171
#define INTNO_SDMMC_PORTA_ECC_CORRECTED     172
#define INTNO_SDMMC_PORTA_ECC_UNCORRECTED   173
#define INTNO_SDMMC_PORTB_ECC_CORRECTED     174
#define INTNO_SDMMC_PORTB_ECC_UNCORRECTED   175

/*
 *  Interrupts sourced from the NAND Controller.
 */
#define INTNO_NAND_IRQ                      176
#define INTNO_NANDR_ECC_CORRECTED_IRQ       177
#define INTNO_NANDR_ECC_UNCORRECTED_IRQ     178
#define INTNO_NANDW_ECC_CORRECTED_IRQ       179
#define INTNO_NANDW_ECC_UNCORRECTED_IRQ     180
#define INTNO_NANDE_ECC_CORRECTED_IRQ       181
#define INTNO_NANDE_ECC_UNCORRECTED_IRQ     182

/*
 *  Interrupts sourced from the QSPI Controller.
 */
#define INTNO_QSPI_IRQ                      183
#define INTNO_QSPI_ECC_CORRECTED_IRQ        184
#define INTNO_QSPI_ECC_UNCORRECTED_IRQ      185

/*
 *  Interrupts sourced from the SPI Controllers 0 - 3.
 *  SPI0_IRQ corresponds to SPIM0. SPI1_IRQ corresponds to SPIM1.
 *  SPI2_IRQ corresponds to SPIS0. SPI3_IRQ corresponds to SPIS1.
 */
#define INTNO_SPI0_IRQ                      186
#define INTNO_SPI1_IRQ                      187
#define INTNO_SPI2_IRQ                      188
#define INTNO_SPI3_IRQ                      189

/*
 *  Interrupts sourced from the I2C Controllers 0 - 3.
 */
#define INTNO_I2C0_IRQ                      190
#define INTNO_I2C1_IRQ                      191
#define INTNO_I2C2_IRQ                      192
#define INTNO_I2C3_IRQ                      193

/*
 *  Interrupts sourced from the UARTs 0 - 1.
 */
#define INTNO_UART0                         194
#define INTNO_UART1                         195

/*
 *  Interrupts sourced from the GPIO 0 - 2.
 */
#define INTNO_GPIO0                         196
#define INTNO_GPIO1                         197
#define INTNO_GPIO2                         198

/*
 *  Interrupts sourced from the Timer controllers.
 */
#define INTNO_TIMER_L4SP_0_IRQ              199
#define INTNO_TIMER_L4SP_1_IRQ              200
#define INTNO_TIMER_OSC1_0_IRQ              201
#define INTNO_TIMER_OSC1_1_IRQ              202

/*
 *  Interrupts sourced from the Watchdog Timers 0 - 1.
 */
#define INTNO_WDOG0_IRQ                     203
#define INTNO_WDOG1_IRQ                     204

/*
 *  Interrupts sourced from the Clock Manager.
 */
#define INTNO_CLKMGR_IRQ                    205

/*
 *  Interrupts sourced from the Clock Manager MPU Wakeup.
 */
#define INTNO_MPUWAKEUP_IRQ                 206

/*
 *  Interrupts sourced from the FPGA Manager.
 */
#define INTNO_FPGA_MAN_IRQ                  207

/*
 *  Interrupts sourced from the CoreSight for CPU0 and CPU1's CTI.
 */
#define INTNO_NCTIIRQ0                      208
#define INTNO_NCTIIRQ1                      209

/*
 *  Interrupts sourced from the On-chip RAM.
 */
#define INTNO_RAM_ECC_CORRECTED_IRQ         210
#define INTNO_RAM_ECC_UNCORRECTED_IRQ       211

#define PERIPH_BASE             0xFF400000	/* Peripheral base address in the alias region */
#define MPCORE_BASE             0xFFFEC000	/* MPCore Private Memory Region Base Address */

/*
 *  DISTRIBUTED INTERRUPT CONTROLLER CPU INTERFACE
 */
#define TADR_DICCPU_BASE        (MPCORE_BASE + 0x0100)
#define TOFF_DICCPU_CR          0x0000			/* (RW) Controll register */
  #define DICCPU_CR_EN             0x00000001
  #define DICCPU_CR_EN_S           0x00000001
  #define DICCPU_CR_EN_NS          0x00000002
  #define DICCPU_CR_EN_ACKCTL      0x00000004
  #define DICCPU_CR_FIQEN          0x00000008
  #define DICCPU_CR_EN_SBPR        0x00000010
#define TOFF_DICCPU_PMR         0x0004			/* (PW) Priority mask register */
#define TOFF_DICCPU_BPR         0x0008			/* (RW) Binary point register */
#define TOFF_DICCPU_IAR         0x000C			/* (R)  Interrupt Acknowledge Register */
  #define DICCPU_IAR_CPUID         0x00001C00
  #define DICCPU_IAR_ACKINTID      0x000003FF
#define TOFF_DICCPU_EOI         0x0010			/* (W)  End of Interrupt Register */
#define TOFF_DICCPU_RII         0x0014			/* (R)  Running Interrupt Register */

/*
 *  DISTRIBUTED INTERRUPT CONTROLLER
 */
#define TADR_DIC_BASE           (MPCORE_BASE + 0x1000)
#define TOFF_DIC_CR             0x0000			/* (RW) Control Register */
  #ifndef DIC_CR_ENABLE
  #define DIC_CR_ENABLE            0x000000001
  #endif
  #ifndef DIC_CR_NS_ENABLE
  #define DIC_CR_NS_ENABLE         0x000000002
  #endif
#define TOFF_DIC_ICT            0x0004			/* (R)  Interrupt Controller type register */
#define TOFF_DIC_SE             0x0100			/* (RW) Interrupt enable set registers */
#define TOFF_DIC_CE             0x0180			/* (W)  Interrupt enable clear registets */
#define TOFF_DIC_IPR            0x0400			/* (RW) Interrupt priority registers */
#define TOFF_DIC_ITR            0x0800			/* (RW) Interrupt target registers */
#define TOFF_DIC_ICR            0x0C00			/* (RW) Interrupt configuration resgisters */

/*
 *  MPUL2 COMPONECT
 */
#define TADR_MPUL2_BASE         (MPCORE_BASE + 0x3000)
#define TOFF_MPUL2_CACHE_ID         0x0000
#define TOFF_MPUL2_CACHE_TYPE       0x0004
#define TOFF_MPUL2_CONTROL          0x0100
#define TOFF_MPUL2_AUX_CONTROL      0x0104
#define TOFF_MPUL2_TAG_RAM_CONTROL  0x0108
#define TOFF_MPUL2_DATA_RAM_CONTROL 0x010C
#define TOFF_MPUL2_EV_COUNTER_CTRL  0x0200
#define TOFF_MPUL2_EV_COUNTER1_CFG  0x0204
#define TOFF_MPUL2_EV_COUNTER0_CFG  0x0208
#define TOFF_MPUL2_EV_COUNTER1      0x020C
#define TOFF_MPUL2_EV_COUNTER0      0x0210
#define TOFF_MPUL2_INT_MASK         0x0214
#define TOFF_MPUL2_INT_MASK_STATUS  0x0218
#define TOFF_MPUL2_INT_RAW_STATUS   0x021c
#define TOFF_MPUL2_INT_CLEAR        0x0220
#define TOFF_MPUL2_CACHE_SYNC       0x0730
#define TOFF_MPUL2_INV_PA           0x0770
#define TOFF_MPUL2_INV_WAY          0x077C
#define TOFF_MPUL2_CLEAN_PA         0x07B0
#define TOFF_MPUL2_CLEAN_INDEX      0x07B8
#define TOFF_MPUL2_CLEAN_WAY        0x07BC
#define TOFF_MPUL2_CLEAN_INV_PA     0x07F0
#define TOFF_MPUL2_CLEAN_INV_INDEX  0x07F8
#define TOFF_MPUL2_CLEAN_INV_WAY    0x07FC
#define TOFF_MPUL2_D_LOCKDOWN0      0x0900
#define TOFF_MPUL2_I_LOCKDOWN0      0x0904
#define TOFF_MPUL2_D_LOCKDOWN1      0x0908
#define TOFF_MPUL2_I_LOCKDOWN1      0x090C
#define TOFF_MPUL2_D_LOCKDOWN2      0x0910
#define TOFF_MPUL2_I_LOCKDOWN2      0x0914
#define TOFF_MPUL2_D_LOCKDOWN3      0x0918
#define TOFF_MPUL2_I_LOCKDOWN3      0x091C
#define TOFF_MPUL2_D_LOCKDOWN4      0x0920
#define TOFF_MPUL2_I_LOCKDOWN4      0x0924
#define TOFF_MPUL2_D_LOCKDOWN5      0x0928
#define TOFF_MPUL2_I_LOCKDOWN5      0x092C
#define TOFF_MPUL2_D_LOCKDOWN6      0x0930
#define TOFF_MPUL2_I_LOCKDOWN6      0x0934
#define TOFF_MPUL2_D_LOCKDOWN7      0x0938
#define TOFF_MPUL2_I_LOCKDOWN7      0x093C
#define TOFF_MPUL2_LOCK_LINE_EN     0x0950
#define TOFF_MPUL2_UNLOCK_WAY       0x0954
#define TOFF_MPUL2_ADDR_FILTERING_START 0x0C00
#define TOFF_MPUL2_ADDR_FILTERING_END   0x0C04
#define TOFF_MPUL2_DEBUG_CTRL       0x0F40
#define TOFF_MPUL2_PREFETCH_CTRL    0x0F60
#define TOFF_MPUL2_POWER_CTRL       0x0F80

/*
 *  SD-MMC INTERFACE
 */
#define TADR_SDMMC1_BASE        (PERIPH_BASE + 0x304000)
#define TOFF_SDMMC_CTL          0x0000		/* (RW) Control Register */
  #define SDMMC_CTL_CTLLER                 0x00000001	/* Controller Reset */
  #define SDMMC_CTL_FIFO_RST               0x00000002	/* FIFO Reset */
  #define SDMMC_CTL_DMA_RST                0x00000004	/* Dma Reset */
  #define SDMMC_CTL_INT_EN                 0x00000010	/* Int Enable */
  #define SDMMC_CTL_RD_WAIT                0x00000040	/* Read Wait */
  #define SDMMC_CTL_SEND_IRQ_RESPONSE      0x00000080	/* Send Irq Response */
  #define SDMMC_CTL_ABT_RD_DATA            0x00000100	/* Abort Read Data */
  #define SDMMC_CTL_SEND_CCSD              0x00000200	/* Send CCSD */
  #define SDMMC_CTL_SEND_AUTO_STOP_CCSD    0x00000400	/* Send Auto Stop CCSD */
  #define SDMMC_CTL_CEATA_DEVICE_INT_STAT  0x00000800	/* Ceata Device Interrupt Status */
  #define SDMMC_CTL_USE_INTERNAL_DMAC      0x02000000	/* Use Internal DMAC */
#define TOFF_SDMMC_PWREN        0x0004		/* (RW) Power Enable Register */
  #define SDMMC_PWREN_POWER_EN             0x00000001	/* Power Enable */
#define TOFF_SDMMC_CLKDIV       0x0008		/* (RW) Clock Divider Register */
  #define SDMMC_CLKDIV_CLK_DIVR0           0x000000ff	/* Clk Divider 0 */
#define TOFF_SDMMC_CLKSRC       0x000C		/* (RW) SD Clock Source Register */
#define TOFF_SDMMC_CLKENA       0x0010		/* (RW) Clock Enable Register */
  #define SDMMC_CLKENA_CCLK_EN             0x00000001	/* Clock Enable Register */
  #define SDMMC_CLKENA_CCLK_LOW_POWER      0x00010000	/* Cclk Low Power */
#define TOFF_SDMMC_TMOUT        0x0014		/* (RW) Timeout Register */
#define TOFF_SDMMC_CTYPE        0x0018		/* (RW) Card Type Register */
  #define SDMMC_CTYPE_CARD_WIDTH2          0x00000001	/* Card Width 1 or 4 Bits */
  #define SDMMC_CTYPE_CARD_WIDTH1          0x00010000	/* Card Width 8 Bit */
#define TOFF_SDMMC_BLKSIZ       0x001C		/* (RW) Block Size Register */
  #define SDMMC_BLKSIZ_BLOCK_SIZE          0x0000ffff	/* Block Size */
#define TOFF_SDMMC_BYTCNT       0x0020		/* (RW) Byte Count Register */
#define TOFF_SDMMC_INTMSK       0x0024		/* (RW) Interrupt Mask Register */
#define TOFF_SDMMC_CMDARG       0x0028		/* (RW) Command Argument Register */
#define TOFF_SDMMC_CMD          0x002C		/* (RW) Command Register */
  #define SDMMC_CMD_CMD_INDEX              0x0000003f	/* Cmd Index */
  #define SDMMC_CMD_RESPONSE_EXPECT        0x00000040	/* Response Expect */
  #define SDMMC_CMD_RESPONSE_LEN           0x00000080	/* Response Length */
  #define SDMMC_CMD_CHECK_RESPONSE_CRC     0x00000100	/* Check Response Crc */
  #define SDMMC_CMD_DATA_EXPECTED          0x00000200	/* Data Transfer Expected */
  #define SDMMC_CMD_RD_WR                  0x00000400	/* Read Write */
  #define SDMMC_CMD_TFR_MOD                0x00000800	/* Transfer Mode */
  #define SDMMC_CMD_SEND_AUTO_STOP         0x00001000	/* Send Auto Stop */
  #define SDMMC_CMD_WAIT_PRVDATA_COMPLETE  0x00002000	/* Wait Previous Data Complete */
  #define SDMMC_CMD_STOP_ABT_CMD_SET_MSK   0x00004000	/* Stop Abort Cmd */
  #define SDMMC_CMD_SEND_INITIALIZATION    0x00008000	/* Send Initialization */
  #define SDMMC_CMD_CARD_NUMBER            0x001f0000	/* Card Number */
  #define SDMMC_CMD_UPDATE_CLK_REGS_ONLY   0x00200000	/* Update Clock Registers Only */
  #define SDMMC_CMD_RD_CEATA_DEVICE        0x00400000	/* Read CE-ATA Device(0) */
  #define SDMMC_CMD_CCS_EXPECTED           0x00800000	/* Command Completion Signal Expected(0) */
  #define SDMMC_CMD_EN_BOOT                0x01000000	/* Enable Boot(0) */
  #define SDMMC_CMD_EXPECT_BOOT_ACK        0x02000000	/* Expect Boot Ack(0) */
  #define SDMMC_CMD_DIS_BOOT               0x04000000	/* Disable Boot(0) */
  #define SDMMC_CMD_BOOT_MOD               0x08000000	/* Boot Mode(0) */
  #define SDMMC_CMD_VOLT_SWITCH            0x10000000	/* Volt Switch(0) */
  #define SDMMC_CMD_USE_HOLD               0x20000000	/* Use Hold Reg */
  #define SDMMC_CMD_START_CMD              0x80000000	/* Start Cmd */
#define TOFF_SDMMC_RESP0        0x0030		/* (R)  Response Register 0 */
#define TOFF_SDMMC_RESP1        0x0034		/* (R)  Response Register 1 */
#define TOFF_SDMMC_RESP2        0x0038		/* (R)  Response Register 2 */
#define TOFF_SDMMC_RESP3        0x003C		/* (R)  Response Register 3 */
#define TOFF_SDMMC_MINTSTS      0x0040		/* (R)  Masked Interrupt Status Register */
#define TOFF_SDMMC_RINTSTS      0x0044		/* (RW) Raw Interrupt Status Register */
  #define SDMMC_INTSTS_CD                  0x00000001	/* Card Detect */
  #define SDMMC_INTSTS_RE                  0x00000002	/* Response Error */
  #define SDMMC_INTSTS_CMD                 0x00000004	/* Command Done */
  #define SDMMC_INTSTS_DTO                 0x00000008	/* Data Transfer Over */
  #define SDMMC_INTSTS_TXDR                0x00000010	/* Transmit FIFO Data Request */
  #define SDMMC_INTSTS_RXDR                0x00000020	/* Receive FIFO Data Request */
  #define SDMMC_INTSTS_RCRC                0x00000040	/* Response CRC Error */
  #define SDMMC_INTSTS_DCRC                0x00000080	/* Data CRC Error */
  #define SDMMC_INTSTS_BAR                 0x00000100	/* Response Timeout Boot Ack Received */
  #define SDMMC_INTSTS_BDS                 0x00000200	/* Data Read Timeout Boot Data Start */
  #define SDMMC_INTSTS_HTO                 0x00000400	/* Data Starvation Host Timeout Volt Switch_int */
  #define SDMMC_INTSTS_FRUN                0x00000800	/* FIFO Underrun Overrun Error */
  #define SDMMC_INTSTS_HLE                 0x00001000	/* Hardware Locked Write Error */
  #define SDMMC_INTSTS_SBE                 0x00002000	/* Start-bit error */
  #define SDMMC_INTSTS_ACD                 0x00004000	/* Auto Command Done */
  #define SDMMC_INTSTS_EBE                 0x00008000	/* End-bit Error */
  #define SDMMC_INTSTS_SDIO_INT            0x00010000	/* SDIO Interrupt */
#define TOFF_SDMMC_STAT         0x0048		/* (R)  Status Register */
  #define SDMMC_STAT_FIFO_RX_WATERMARK     0x00000001	/* FIFO Rx Watermark */
  #define SDMMC_STAT_FIFO_TX_WATERMARK     0x00000002	/* FIFO Tx Watermark */
  #define SDMMC_STAT_FIFO_EMPTY            0x00000004	/* FIFO Empty */
  #define SDMMC_STAT_FIFO_FULL             0x00000008	/* FIFO Full */
  #define SDMMC_STAT_CMD_FSM_STATES        0x000000f0	/* Command FSM States */
  #define SDMMC_STAT_DATA_3_STAT           0x00000100	/* Data 3 Status */
  #define SDMMC_STAT_DATA_BUSY             0x00000200	/* Data Busy */
  #define SDMMC_STAT_DATA_STATE_MC_BUSY    0x00000400	/* Data State MC Busy */
  #define SDMMC_STAT_RESPONSE_INDEX        0x0001f800	/* Response Index */
  #define SDMMC_STAT_FIFO_COUNT            0x3ffe0000	/* FIFO Count */
#define TOFF_SDMMC_FIFOTH       0x004C		/* (RW) FIFO Threshold Watermark Register */
#define TOFF_SDMMC_CDETECT      0x0050		/* (R)  Card Detect Register */
#define TOFF_SDMMC_WRTPRT       0x0054		/* (R)  Write Protect Register */
  #define SDMMC_WRTPRT_WR_PROTECT          0x00000001	/* Write Protect */
#define TOFF_SDMMC_TCBCNT       0x005C		/* (R)  Transferred CIU Card Byte Count Register */
#define TOFF_SDMMC_TBBCNT       0x0060		/* (R)  Transferred Host to BIU-FIFO Byte Count Register */
#define TOFF_SDMMC_DEBNCE       0x0064		/* (RW) Debounce Count Register */
#define TOFF_SDMMC_USRID        0x0068		/* (RW) User ID Register */
#define TOFF_SDMMC_VERID        0x006C		/* (R)  Version ID Register */
#define TOFF_SDMMC_HCON         0x0070		/* (R)  Hardware Configuration Register */
#define TOFF_SDMMC_UHS_REG      0x0074		/* (RW) UHS-1 Register */
#define TOFF_SDMMC_RST          0x0078		/* (RW) Hardware Reset Register */
#define TOFF_SDMMC_BMOD         0x0080		/* (RW) Bus Mode Register */
  #define SDMMC_BMOD_SWR                   0x00000001	/* Software Reset */
  #define SDMMC_BMOD_FB                    0x00000002	/* Fixed Burst */
  #define SDMMC_BMOD_DSL                   0x0000007c	/* Descriptor Skip Length */
  #define SDMMC_BMOD_DE                    0x00000080	/* IDMAC Enable */
  #define SDMMC_BMOD_PBL                   0x00000700	/* Programmable Burst Length */
#define TOFF_SDMMC_PLDMND       0x0084		/* (W)  Poll Demand Register */
#define TOFF_SDMMC_DBADDR       0x0088		/* (RW) Descriptor List Base Address Register */
#define TOFF_SDMMC_IDSTS        0x008C		/* (RW) Internal DMAC Status Register */
  #define SDMMC_IDSTS_TI                   0x00000001	/* Transmit Interrupt */
  #define SDMMC_IDSTS_RI                   0x00000002	/* Receive Interrupt */
  #define SDMMC_IDSTS_FBE                  0x00000004	/* Fatal Bus Error Interrupt */
  #define SDMMC_IDSTS_DU                   0x00000010	/* Descriptor Unavailable Interrupt */
  #define SDMMC_IDSTS_CES                  0x00000020	/* Card Error Summary */
  #define SDMMC_IDSTS_NIS                  0x00000100	/* Normal Interrupt Summary */
  #define SDMMC_IDSTS_AIS                  0x00000200	/* Abnormal Interrupt Summary */
  #define SDMMC_IDSTS_FSM                  0x0001e000	/* Finite State Machine */
#define TOFF_SDMMC_IDINTEN      0x0090		/* (RW) Internal DMAC Interrupt Enable Register */
#define TOFF_SDMMC_DSCADDR      0x0094		/* (R)  Current Host Descriptor Address Register */
#define TOFF_SDMMC_BUFADDR      0x0098		/* (R)  Current Buffer Descriptor Address Register */
#define TOFF_SDMMC_CARDTHRCTL   0x0100		/* (RW) Card Threshold Control Register */
  #define SDMMC_CARDTHRCTL_CARDRDTHREN     0x00000001	/* Card Read Threshold Enable */
  #define SDMMC_CARDTHRCTL_CARDRDTHRESHOLD 0x0fff0000	/* Card Read Threshold */
#define TOFF_SDMMC_BACK_END_POWER 0x0104	/* (RW) Back End Power Register */
#define TOFF_SDMMC_DATA         0x0200		/* (RW) FIFO Data */


/*
 *  QSPI MODULE
 */
#define TADR_QSPI_BASE          (PERIPH_BASE + 0x305000)
#define TOFF_QSPI_CFG               0x0000	/* (RW) QSPI Configuration Register */
  #define QSPI_CFG_EN                      0x00000001	/* QSPI Enable */
  #define QSPI_CFG_SELCLKPOL               0x00000002	/* Clock Polarity */
  #define QSPI_CFG_SELCLKPHASE             0x00000004	/* Select Clock Phase */
  #define QSPI_CFG_ENDIRACC                0x00000080	/* Enable Direct Access Controller */
  #define QSPI_CFG_ENLEGACYIP              0x00000100	/* Legacy IP Mode Enable */
  #define QSPI_CFG_PERSELDEC               0x00000200	/* Peripheral select decode */
  #define QSPI_CFG_PERCSLINES              0x00003c00	/* Peripheral Chip Select Lines */
  #define QSPI_CFG_WP                      0x00004000	/* Write Protect Flash Pin */
  #define QSPI_CFG_ENDMA                   0x00008000	/* Enable DMA Peripheral Interface */
  #define QSPI_CFG_ENAHBREMAP              0x00010000	/* Enable AHB Address Re-mapping */
  #define QSPI_CFG_ENTERXIPNEXTRD          0x00020000	/* Enter XIP Mode on next READ */
  #define QSPI_CFG_ENTERXIPIMM             0x00040000	/* Enter XIP Mode Immediately */
  #define QSPI_CFG_BAUDDIV                 0x00780000	/* Master Mode Baud Rate Divisor */
  #define QSPI_CFG_IDLE                    0x80000000	/* Serial interface and QSPI pipeline is IDLE */
#define TOFF_QSPI_DEVRD             0x0004	/* (RW) Device Read Instruction Register */
  #define QSPI_DEVRD_RDOPCODE              0x000000FF	/* Read Opcode in non-XIP mode */
  #define QSPI_DEVRD_INSTWIDTH             0x00000300	/* Instruction Transfer Width */
  #define QSPI_DEVRD_ADDRWIDTH             0x00003000	/* Address Transfer Width */
  #define QSPI_DEVRD_DATAWIDTH             0x00030000	/* Data Transfer Width */
  #define QSPI_DEVRD_ENMODBITS             0x00100000	/* Mode Bit Enable */
  #define QSPI_DEVRD_DUMMYRDCLKS           0x1F000000	/* Dummy Read Clock Cycles */
#define TOFF_QSPI_DEVWR             0x0008	/* (RW) Device Write Instruction Register */
  #define QSPI_DEVWR_WROPCODE              0x000000FF	/* Write Opcode */
  #define QSPI_DEVWR_ADDRWIDTH             0x00003000	/* Address Transfer Width */
  #define QSPI_DEVWR_DATAWIDTH             0x00030000	/* Data Transfer Width */
  #define QSPI_DEVWR_DUMMYWRCLKS           0x1F000000	/* Dummy Write Clock Cycles */
#define TOFF_QSPI_DELAY             0x000C	/* (RW) QSPI Device Delay Register */
  #define QSPI_DELAY_INIT                  0x000000ff	/* Clock Delay with qspi_n_ss_out */
  #define QSPI_DELAY_AFTER                 0x0000ff00	/* Clock Delay for Last Transaction Bit */
  #define QSPI_DELAY_BTWN                  0x00ff0000	/* Clock Delay for Chip Select Deactivation */
  #define QSPI_DELAY_NSS                   0xff000000	/* Clock Delay for Chip Select Deassert */
#define TOFF_QSPI_RDDATACAP         0x0010	/* (RW) Read Data Capture Register */
  #define QSPI_RDDATACAP_BYP               0x00000001	/* Bypass */
  #define QSPI_RDDATACAP_DELAY             0x0000001E	/* Read delay */
#define TOFF_QSPI_DEVSZ             0x0014	/* (RW) Device Size Register */
  #define QSPI_DEVSZ_NUMADDRBYTES          0x0000000F	/* Number of address Bytes */
  #define QSPI_DEVSZ_BYTESPERDEVICEPAGE    0x0000FFF0	/* Number of Bytes per Device Page */
  #define QSPI_DEVSZ_BYTESPERSUBSECTOR     0x001F0000	/* Number of Bytes per Block */
#define TOFF_QSPI_SRAMPART          0x0018	/* (RW) SRAM Partition Register */
  #define QSPI_SRAMPART_ADDR               0x0000007F	/* SRAM Partition Register */
#define TOFF_QSPI_INDADDRTRIG       0x001C	/* (RW) Indirect AHB Address Trigger Register */
#define TOFF_QSPI_DMAPER            0x0020	/* (RW) DMA Peripheral Register */
  #define QSPI_DMAPER_NUMSGLREQBYTES       0x0000000F	/* Number of Single Bytes */
  #define QSPI_DMAPER_NUMBURSTREQBYTES     0x00000F00	/* Number of Burst Bytes */
#define TOFF_QSPI_REMAPADDR         0x0024	/* (RW) Remap Address Register */
#define TOFF_QSPI_MODBIT            0x0028	/* (RW) Mode Bit Register */
  #define QSPI_MODBIT_MOD                  0x000000FF	/* Mode */
#define TOFF_QSPI_SRAMFILL          0x002C	/* (R)  SRAM Fill Register */
  #define QSPI_SRAMFILL_INDRDPART          0x0000FFFF	/* SRAM Fill Level (Indirect Read Partition) */
  #define QSPI_SRAMFILL_INDWRPART          0xFFFF0000	/* SRAM Fill Level (Indirect Write Partition) */
#define TOFF_QSPI_TXTHRESH          0x0030	/* (RW) TX Threshold Register */
#define TOFF_QSPI_RXTHRESH          0x0034	/* (RW) RX Threshold Register */
#define TOFF_QSPI_IRQSTAT           0x0040	/* (RW) Interrupt Status Register */
  #define QSPI_IRQSTAT_UNDERFLOWDET        0x00000002	/* Underflow Detected */
  #define QSPI_IRQSTAT_INDOPDONE           0x00000004	/* Indirect Operation Complete */
  #define QSPI_IRQSTAT_INDRDREJECT         0x00000008	/* Indirect Read Reject */
  #define QSPI_IRQSTAT_PROTWRATTEMPT       0x00000010	/* Protected Area Write Attempt */
  #define QSPI_IRQSTAT_ILLEGALACC          0x00000020	/* Illegal AHB Access Detected */
  #define QSPI_IRQSTAT_INDXFRLVL           0x00000040	/* Transfer Watermark Reached */
  #define QSPI_IRQSTAT_RXOVER              0x00000080	/* Receive Overflow */
  #define QSPI_IRQSTAT_TXTHRESHCMP         0x00000100	/* Transmit FIFO Compared to Threshold */
  #define QSPI_IRQSTAT_TXFULL              0x00000200	/* Transmit FIFO Full */
  #define QSPI_IRQSTAT_RXTHRESHCMP         0x00000400	/* Receive FIFO Compared to Threshold */
  #define QSPI_IRQSTAT_RXFULL              0x00000800	/* Receive FIFO Full */
  #define QSPI_IRQSTAT_INDSRAMFULL         0x00001000	/* Indirect Read Partition overflow */
#define TOFF_QSPI_IRQMSK            0x0044	/* (RW) Interrupt Mask */
#define TOFF_QSPI_LOWWRPROT         0x0050	/* (RW) Lower Write Protection Register */
#define TOFF_QSPI_UPPWRPROT         0x0054	/* (RW) Upper Write Protection Register */
#define TOFF_QSPI_WRPROT            0x0058	/* (RW) Write Protection Register */
  #define QSPI_WRPROT_INV                  0x00000001	/* Write Protection Inversion Bit */
  #define QSPI_WRPROT_EN                   0x00000002	/* Write Protection Enable Bit */
#define TOFF_QSPI_INDRD             0x0060	/* (RW) Indirect Read Transfer Register */
  #define QSPI_INDRD_START                 0x00000001	/* Start Indirect Read */
  #define QSPI_INDRD_CANCEL                0x00000002	/* Cancel Indirect Read */
  #define QSPI_INDRD_RD_STAT               0x00000004	/* Indirect Read Status */
  #define QSPI_INDRD_SRAM_FULL             0x00000008	/* SRAM Full */
  #define QSPI_INDRD_RD_QUEUED             0x00000010	/* Queued Indirect Read Operations */
  #define QSPI_INDRD_IND_OPS_DONE_STAT     0x00000020	/* Indirect Completion Status */
  #define QSPI_INDRD_NUM_IND_OPS_DONE      0x000000c0	/* Completed Indirect Operations */
#define TOFF_QSPI_INDRDWATER        0x0064	/* (RW) Indirect Read Transfer Watermark Register */
#define TOFF_QSPI_INDRDSTADDR       0x0068	/* (RW) Indirect Read Transfer Start Address Register */
#define TOFF_QSPI_INDRDCNT          0x006C	/* (RW) Indirect Read Transfer Number Bytes Register */
#define TOFF_QSPI_INDWR             0x0070	/* (RW) Indirect Write Transfer Register */
  #define QSPI_INDWR_START                 0x00000001	/* Start Indirect Write */
  #define QSPI_INDWR_CANCEL                0x00000002	/* Cancel Indirect Write */
  #define QSPI_INDWR_RDSTAT                0x00000004	/* Indirect Write Status */
  #define QSPI_INDWR_SRAMFULL              0x00000008	/* Reserved - sramfull */
  #define QSPI_INDWR_RDQUEUED              0x00000010	/* Queued Indirect Write Operations */
  #define QSPI_INDWR_INDDONE               0x00000020	/* Indirect Completion Status */
  #define QSPI_INDWR_INDCNT                0x000000c0	/* Completed Indirect Operations */
#define TOFF_QSPI_INDWRWATER        0x0074	/* (RW) Indirect Write Transfer Watermark Register */
#define TOFF_QSPI_INDWRSTADDR       0x0078	/* (RW) Indirect Write Transfer Start Address Register */
#define TOFF_QSPI_INDWRCNT          0x007C	/* (RW) Indirect Write Transfer Count Register */
#define TOFF_QSPI_FLSHCMD           0x0090	/* (RW) Flash Command Register */
  #define QSPI_FLSHCMD_EXECCMD             0x00000001	/* Execute Command */
  #define QSPI_FLSHCMD_CMDEXECSTAT         0x00000002	/* Command Execution Status */
  #define QSPI_FLSHCMD_NUMDUMMYBYTES       0x00000f80	/* Number of Dummy Bytes */
  #define QSPI_FLSHCMD_NUMWRDATABYTES      0x00007000	/* Number of Write Data Bytes */
  #define QSPI_FLSHCMD_ENWRDATA            0x00008000	/* Write Data Enable */
  #define QSPI_FLSHCMD_NUMADDRBYTES        0x00030000	/* Number of Address Bytes */
  #define QSPI_FLSHCMD_ENMODBIT            0x00040000	/* Mode Bit Enable */
  #define QSPI_FLSHCMD_ENCMDADDR           0x00080000	/* Command Address Enable */
  #define QSPI_FLSHCMD_NUMRDDATABYTES      0x00700000	/* Number of Read Data Bytes */
  #define QSPI_FLSHCMD_ENRDDATA            0x00800000	/* Read Data Enable */
  #define QSPI_FLSHCMD_CMDOPCODE           0xff000000	/* Command Opcode */
#define TOFF_QSPI_FLSHCMDADDR       0x0094	/* (RW) Flash Command Address Registers */
#define TOFF_QSPI_FLSHCMDRDDATALO   0x00A0	/* (RW) Flash Command Read Data Register (Lower) */
#define TOFF_QSPI_FLSHCMDRDDATAUP   0x00A4	/* (RW) Flash Command Read Data Register (Upper) */
#define TOFF_QSPI_FLSHCMDWRDATALO   0x00A8	/* (RW) Flash Command Write Data Register (Lower) */
#define TOFF_QSPI_FLSHCMDWRDATAUP   0x00AC	/* (RW) Flash Command Write Data Register (Upper) */
#define TOFF_QSPI_MODULEID          0x00FC	/* (R)  Module ID Register */


/*
 *  GPIO MODULE
 */
#define TADR_GPIO0_BASE         (PERIPH_BASE + 0x308000)
#define TADR_GPIO1_BASE         (PERIPH_BASE + 0x309000)
#define TADR_GPIO2_BASE         (PERIPH_BASE + 0x30A000)
#define TOFF_GPIO_SWPORTA_DR    0x0000		/* (RW) Port A Data Register */
#define TOFF_GPIO_SWPORTA_DDR   0x0004		/* (RW) Port A Data Direction Register */
#define TOFF_GPIO_INTEN         0x0030		/* (RW) Interrupt Enable Register */
#define TOFF_GPIO_INTMSK        0x0034		/* (RW) Interrupt Mask Register */
#define TOFF_GPIO_INTTYPE_LEVEL 0x0038		/* (RW) Interrupt Level Register */
#define TOFF_GPIO_INT_POL       0x003c		/* (RW) Interrupt Polarity Register */
#define TOFF_GPIO_INTSTAT       0x0040		/* (RW) Interrupt Status Register */
#define TOFF_GPIO_RAW_INTSTAT   0x0044		/* (RW) Raw Interrupt Status Register */
#define TOFF_GPIO_DEBOUNCE      0x0048		/* (RW) Debounce Enable Register */
#define TOFF_GPIO_PORTA_EOI     0x004c		/* (W)  Clears Edge Interrupts Field */
#define TOFF_GPIO_EXT_PORTA     0x0050		/* (R)  External Port A Register */
#define TOFF_GPIO_LS_SYNC       0x0060		/* (RW) Synchronization Level Register */
  #define GPIO_LS_SYNC_GPIO_LS_SYNC        0x00000001	/* Synchronization Level Field */
#define TOFF_GPIO_ID_CODE       0x0064		/* (R)  ID Code Register */
#define TOFF_GPIO_VER_ID_CODE   0x006c		/* (R)  GPIO Version Register */
#define TOFF_GPIO_CFG_REG2      0x0070		/* (R)  Configuration Register 2 */
  #define GPIO_CFG_REG2_ENC_ID_PWIDTH_A    0x0000001f	/* Port A Width (less 1) */
  #define GPIO_CFG_REG2_ENC_ID_PWIDTH_B    0x000003e0	/* Port B Width (less 1) */
  #define GPIO_CFG_REG2_ENC_ID_PWIDTH_C    0x00007c00	/* Port C Width (less 1) */
  #define GPIO_CFG_REG2_ENC_ID_PWIDTH_D    0x000f8000	/* Port D Width (less 1) */
#define TOFF_GPIO_CFG_REG1      0x0074		/* (R)  Configuration Register 1 */
  #define GPIO_CFG_REG1_APB_DATA_WIDTH     0x00000003	/* APB DATA WIDTH */
  #define GPIO_CFG_REG1_NUM_PORTS          0x0000000c	/* NUM PORTS */
  #define GPIO_CFG_REG1_PORTA_SINGLE_CTL   0x00000010	/* PORT A SINGLE CTL */
  #define GPIO_CFG_REG1_PORTB_SINGLE_CTL   0x00000020	/* PORT B SINGLE CTL */
  #define GPIO_CFG_REG1_PORTC_SINGLE_CTL   0x00000040	/* PORT C SINGLE CTL */
  #define GPIO_CFG_REG1_PORTD_SINGLE_CTL   0x00000080	/* PORT D SINGLE CTL */
  #define GPIO_CFG_REG1_HW_PORTA           0x00000100	/* HW PORTA */
  #define GPIO_CFG_REG1_PORTA_INTR         0x00001000	/* Port A Interrupt Field */
  #define GPIO_CFG_REG1_DEBOUNCE           0x00002000	/* Debounce Field */
  #define GPIO_CFG_REG1_ADD_ENC_PARAMS     0x00004000	/* Encoded GPIO Parameters Available */
  #define GPIO_CFG_REG1_GPIO_ID            0x00008000	/* ID Field */
  #define GPIO_CFG_REG1_ENC_ID_WIDTH       0x001f0000	/* Encoded ID Width Field */

/*
 *  QSPI DATA ADDRESS
 */
#define TADR_QSPI_DATA_BASE     (PERIPH_BASE + 0x600000)

/*
 *  USB OTG CONTROLLER
 */
#define TADR_USB_OTG0_BASE      (PERIPH_BASE + 0x700000)
#define TADR_USB_OTG1_BASE      (PERIPH_BASE + 0x740000)

#define USB_OTG_HOST_BASE           0x400
#define USB_OTG_HOST_PORT_BASE      0x440
#define USB_OTG_HOST_CHANNEL_BASE   0x500
#define USB_OTG_DEVICE_BASE         0x800
#define USB_OTG_IN_ENDPOINT_BASE    0x900
#define USB_OTG_OUT_ENDPOINT_BASE   0xB00
#define USB_OTG_PCGCCTL_BASE        0xE00
#define USB_OTG_FIFO_BASE           0x1000
#define USB_OTG_FIFO_SIZE           0x1000
#define USB_OTG_DIRECT_FIFO_BASE    0x20000
#define USB_OTG_DIRECT_FIFO_SIZE    0x40000


#define TOFF_USBO_GOTGCTL   0x0000		/* (RW) USB_OTG Control and Status Register */
  #define USB_OTG_GOTGCTL_SRQSCS    0x00000001	/* Session request success */
  #define USB_OTG_GOTGCTL_SRQ       0x00000002	/* Session request */
  #define USB_OTG_GOTGCTL_VBVALOEN  0x00000004	/* VBUS valid override enable */
  #define USB_OTG_GOTGCTL_VBVALOVAL 0x00000008	/* VBUS valid override value */
  #define USB_OTG_GOTGCTL_AVALOEN   0x00000010	/* A-peripheral session valid override enable */
  #define USB_OTG_GOTGCTL_AVALOVAL  0x00000020	/* A-peripheral session valid override value */
  #define USB_OTG_GOTGCTL_BVALOEN   0x00000040	/* B-peripheral session valid override enable */
  #define USB_OTG_GOTGCTL_BVALOVAL  0x00000080	/* B-peripheral session valid override value  */
  #define USB_OTG_GOTGCTL_HNGSCS    0x00000100	/* Host negotiation success */
  #define USB_OTG_GOTGCTL_HNPRQ     0x00000200	/* HNP request */
  #define USB_OTG_GOTGCTL_HSHNPEN   0x00000400	/* Host set HNP enable */
  #define USB_OTG_GOTGCTL_DHNPEN    0x00000800	/* Device HNP enabled */
  #define USB_OTG_GOTGCTL_EHEN      0x00001000	/* Embedded host enable */
  #define USB_OTG_GOTGCTL_CIDSTS    0x00010000	/* Connector ID status */
  #define USB_OTG_GOTGCTL_DBCT      0x00020000	/* Long/short debounce time */
  #define USB_OTG_GOTGCTL_ASVLD     0x00040000	/* A-session valid */
  #define USB_OTG_GOTGCTL_BSVLD     0x00080000	/* B-session valid */
  #define USB_OTG_GOTGCTL_OTGVER    0x00100000	/* OTG version  */
#define TOFF_USBO_GOTGINT   0x0004		/* (RW) USB_OTG Interrupt Register */
  #define USB_OTG_GOTGINT_SEDET     0x00000004	/* Session end detected */
  #define USB_OTG_GOTGINT_SRSSCHG   0x00000100	/* Session request success status change */
  #define USB_OTG_GOTGINT_HNSSCHG   0x00000200	/* Host negotiation success status change */
  #define USB_OTG_GOTGINT_HNGDET    0x00020000	/* Host negotiation detected */
  #define USB_OTG_GOTGINT_ADTOCHG   0x00040000	/* A-device timeout change */
  #define USB_OTG_GOTGINT_DBCDNE    0x00080000	/* Debounce done */
#define TOFF_USBO_GAHBCFG   0x0008		/* (RW) Core AHB Configuration Register */
  #define USB_OTG_GAHBCFG_GINT      0x00000001	/* Global interrupt mask */
  #define USB_OTG_GAHBCFG_HBSTLEN   0x0000001E	/* Burst length/type */
  #define USB_OTG_GAHBCFG_HBSTLEN_0 0x00000002	/* Bit 0 */
  #define USB_OTG_GAHBCFG_HBSTLEN_1 0x00000004	/* Bit 1 */
  #define USB_OTG_GAHBCFG_HBSTLEN_2 0x00000008	/* Bit 2 */
  #define USB_OTG_GAHBCFG_HBSTLEN_3 0x00000010	/* Bit 3 */
  #define USB_OTG_GAHBCFG_DMAEN     0x00000020	/* DMA enable */
  #define USB_OTG_GAHBCFG_TXFELVL   0x00000080	/* TxFIFO empty level */
  #define USB_OTG_GAHBCFG_PTXFELVL  0x00000100	/* Periodic TxFIFO empty level */
  #define USB_OTG_GAHBCFG_REMMSUPP  0x00200000	/* enable/disable the functionality to wait the system DMA Done(0) */
  #define USB_OTG_GAHBCFG_NDMAWRIT  0x00400000	/* enable the system DMA Done functionality for all the DMA write Transaction(0) */
#define TOFF_USBO_GUSBCFG   0x000C		/* (RW) Core USB Configuration Register */
  #define USB_OTG_GUSBCFG_TOCAL     0x00000007	/* FS timeout calibration */
  #define USB_OTG_GUSBCFG_TOCAL_0   0x00000001	/* Bit 0 */
  #define USB_OTG_GUSBCFG_TOCAL_1   0x00000002	/* Bit 1 */
  #define USB_OTG_GUSBCFG_TOCAL_2   0x00000004	/* Bit 2 */
  #define USB_OTG_GUSBCFG_PHYIF     0x00000008
  #define USB_OTG_GUSBCFG_ULPIUTSEL 0x00000010
  #define USB_OTG_GUSBCFG_FSINTF    0x00000020
  #define USB_OTG_GUSBCFG_PHYSEL    0x00000040	/* USB 2.0 high-speed ULPI PHY or USB 1.1 full-speed serial transceiver select */
  #define USB_OTG_GUSBCFG_DDRSEL    0x00000080
  #define USB_OTG_GUSBCFG_SRPCAP    0x00000100	/* SRP-capable */
  #define USB_OTG_GUSBCFG_HNPCAP    0x00000200	/* HNP-capable */
  #define USB_OTG_GUSBCFG_TRDT      0x00003C00	/* USB turnaround time */
  #define USB_OTG_GUSBCFG_TRDT_0    0x00000400	/* Bit 0 */
  #define USB_OTG_GUSBCFG_TRDT_1    0x00000800	/* Bit 1 */
  #define USB_OTG_GUSBCFG_TRDT_2    0x00001000	/* Bit 2 */
  #define USB_OTG_GUSBCFG_TRDT_3    0x00002000	/* Bit 3 */
  #define USB_OTG_GUSBCFG_ULPIAR    0x00040000	/* ULPI Auto-resume */
  #define USB_OTG_GUSBCFG_ULPICSM   0x00080000	/* ULPI Clock SuspendM */
  #define USB_OTG_GUSBCFG_ULPIEVBUSD 0x00100000	/* ULPI External VBUS Drive */
  #define USB_OTG_GUSBCFG_ULPIEVBUSI 0x00200000	/* ULPI external VBUS indicator */
  #define USB_OTG_GUSBCFG_TSDPS     0x00400000	/* TermSel DLine pulsing selection */
  #define USB_OTG_GUSBCFG_PCCI      0x00800000	/* Indicator complement */
  #define USB_OTG_GUSBCFG_PTCI      0x01000000	/* Indicator pass through */
  #define USB_OTG_GUSBCFG_ULPIIPD   0x02000000	/* ULPI interface protect disable */
  #define USB_OTG_GUSBCFG_FHMOD     0x20000000	/* Forced host mode */
  #define USB_OTG_GUSBCFG_FDMOD     0x40000000	/* Forced peripheral mode */
  #define USB_OTG_GUSBCFG_CTXPKT    0x80000000	/* Corrupt Tx packet */
#define TOFF_USBO_GRSTCTL   0x0010		/* (RW) Core Reset Register */
  #define USB_OTG_GRSTCTL_CSRST     0x00000001	/* Core soft reset */
  #define USB_OTG_GRSTCTL_FCRST     0x00000004	/* Host frame counter reset */
  #define USB_OTG_GRSTCTL_RXFFLSH   0x00000010	/* RxFIFO flush */
  #define USB_OTG_GRSTCTL_TXFFLSH   0x00000020	/* TxFIFO flush */
  #define USB_OTG_GRSTCTL_TXFNUM    0x000007C0	/* TxFIFO number */
  #define USB_OTG_GRSTCTL_TXFNUM_0  0x00000040	/* Bit 0 */
  #define USB_OTG_GRSTCTL_TXFNUM_1  0x00000080	/* Bit 1 */
  #define USB_OTG_GRSTCTL_TXFNUM_2  0x00000100	/* Bit 2 */
  #define USB_OTG_GRSTCTL_TXFNUM_3  0x00000200	/* Bit 3 */
  #define USB_OTG_GRSTCTL_TXFNUM_4  0x00000400	/* Bit 4 */
  #define USB_OTG_GRSTCTL_DMAREQ    0x40000000	/* DMA request signal */
  #define USB_OTG_GRSTCTL_AHBIDL    0x80000000	/* AHB master idle */
#define TOFF_USBO_GINTSTS   0x0014		/* (RW)  Core Interrupt Register */
  #define USB_OTG_GINTSTS_CMOD      0x00000001	/* Current mode of operation */
  #define USB_OTG_GINTSTS_MMIS      0x00000002	/* Mode mismatch interrupt */
  #define USB_OTG_GINTSTS_OTGINT    0x00000004	/* OTG interrupt */
  #define USB_OTG_GINTSTS_SOF       0x00000008	/* Start of frame */
  #define USB_OTG_GINTSTS_RXFLVL    0x00000010	/* RxFIFO nonempty */
  #define USB_OTG_GINTSTS_NPTXFE    0x00000020	/* Nonperiodic TxFIFO empty */
  #define USB_OTG_GINTSTS_GINAKEFF  0x00000040	/* Global IN nonperiodic NAK effective */
  #define USB_OTG_GINTSTS_BOUTNAKEFF 0x00000080	/* Global OUT NAK effective */
  #define USB_OTG_GINTSTS_ESUSP     0x00000400	/* Early suspend */
  #define USB_OTG_GINTSTS_USBSUSP   0x00000800	/* USB suspend */
  #define USB_OTG_GINTSTS_USBRST    0x00001000	/* USB reset */
  #define USB_OTG_GINTSTS_ENUMDNE   0x00002000	/* Enumeration done */
  #define USB_OTG_GINTSTS_ISOODRP   0x00004000	/* Isochronous OUT packet dropped interrupt */
  #define USB_OTG_GINTSTS_EPMIS     0x00020000
  #define USB_OTG_GINTSTS_IEPINT    0x00040000	/* IN endpoint interrupt */
  #define USB_OTG_GINTSTS_OEPINT    0x00080000	/* OUT endpoint interrupt */
  #define USB_OTG_GINTSTS_IISOIXFR  0x00100000	/* Incomplete isochronous IN transfer */
  #define USB_OTG_GINTSTS_PXFR_INCOMPISOOUT 0x00200000	/* Incomplete periodic transfer */
  #define USB_OTG_GINTSTS_DATAFSUSP 0x00400000	/* Data fetch suspended */
  #define USB_OTG_GINTSTS_RSTDET    0x00800000	/* Reset detected interrupt */
  #define USB_OTG_GINTSTS_HPRTINT   0x01000000	/* Host port interrupt */
  #define USB_OTG_GINTSTS_HCINT     0x02000000	/* Host channels interrupt */
  #define USB_OTG_GINTSTS_PTXFE     0x04000000	/* Periodic TxFIFO empty */
  #define USB_OTG_GINTSTS_CIDSCHG   0x10000000	/* Connector ID status change */
  #define USB_OTG_GINTSTS_DISCINT   0x20000000	/* Disconnect detected interrupt */
  #define USB_OTG_GINTSTS_SRQINT    0x40000000	/* Session request/new session detected interrupt */
  #define USB_OTG_GINTSTS_WKUINT    0x80000000	/* Resume/remote wakeup detected interrupt */
#define TOFF_USBO_GINTMSK   0x0018		/* (RW)  Core Interrupt Mask Register */
  #define USB_OTG_GINTMSK_MMISM     0x00000002	/* Mode mismatch interrupt mask */
  #define USB_OTG_GINTMSK_OTGINT    0x00000004	/* OTG interrupt mask */
  #define USB_OTG_GINTMSK_SOFM      0x00000008	/* Start of frame mask */
  #define USB_OTG_GINTMSK_RXFLVLM   0x00000010	/* Receive FIFO nonempty mask */
  #define USB_OTG_GINTMSK_NPTXFEM   0x00000020	/* Nonperiodic TxFIFO empty mask */
  #define USB_OTG_GINTMSK_GINAKEFFM 0x00000040	/* Global nonperiodic IN NAK effective mask */
  #define USB_OTG_GINTMSK_GONAKEFFM 0x00000080	/* Global OUT NAK effective mask */
  #define USB_OTG_GINTMSK_ESUSPM    0x00000400	/* Early suspend mask */
  #define USB_OTG_GINTMSK_USBSUSPM  0x00000800	/* USB suspend mask */
  #define USB_OTG_GINTMSK_USBRST    0x00001000	/* USB reset mask */
  #define USB_OTG_GINTMSK_ENUMDNEM  0x00002000	/* Enumeration done mask */
  #define USB_OTG_GINTMSK_ISOODRPM  0x00004000	/* Isochronous OUT packet dropped interrupt mask */
  #define USB_OTG_GINTMSK_EOPFM     0x00008000	/* End of periodic frame interrupt mask */
  #define USB_OTG_GINTMSK_EPMISM    0x00020000	/* Endpoint mismatch interrupt mask */
  #define USB_OTG_GINTMSK_IEPINT    0x00040000	/* IN endpoints interrupt mask */
  #define USB_OTG_GINTMSK_OEPINT    0x00080000	/* OUT endpoints interrupt mask */
  #define USB_OTG_GINTMSK_IISOIXFRM 0x00100000	/* Incomplete isochronous IN transfer mask */
  #define USB_OTG_GINTMSK_PXFRM_IISOOXFRM 0x00200000	/* Incomplete periodic transfer mask */
  #define USB_OTG_GINTMSK_FSUSPM    0x00400000	/* Data fetch suspended mask */
  #define USB_OTG_GINTMSK_RSTDEM    0x00800000	/* Reset detected interrupt mask */
  #define USB_OTG_GINTMSK_PRTIM     0x01000000	/* Host port interrupt mask */
  #define USB_OTG_GINTMSK_HCIM      0x02000000	/* Host channels interrupt mask */
  #define USB_OTG_GINTMSK_PTXFEM    0x04000000	/* Periodic TxFIFO empty mask */
  #define USB_OTG_GINTMSK_LPMINTM   0x08000000	/* LPM interrupt Mask */
  #define USB_OTG_GINTMSK_CIDSCHGM  0x10000000	/* Connector ID status change mask */
  #define USB_OTG_GINTMSK_DISCINT   0x20000000	/* Disconnect detected interrupt mask */
  #define USB_OTG_GINTMSK_SRQIM     0x40000000	/* Session request/new session detected interrupt mask */
  #define USB_OTG_GINTMSK_WUIM      0x80000000	/* Resume/remote wakeup detected interrupt mask */
#define TOFF_USBO_GRXSTSR   0x001C		/* (RW) Receive Sts Q Read Register */
#define TOFF_USBO_GRXSTSP   0x0020		/* (RW) Receive Sts Q Read & POP Register */
  #define USB_OTG_GRXSTSP_EPNUM     0x0000000F	/* IN EP interrupt mask bits */
  #define USB_OTG_GRXSTSP_BCNT      0x00007FF0	/* OUT EP interrupt mask bits */
  #define USB_OTG_GRXSTSP_DPID      0x00018000	/* OUT EP interrupt mask bits */
  #define USB_OTG_GRXSTSP_PKTSTS    0x001E0000	/* OUT EP interrupt mask bits */
  #define USB_OTG_GRXSTSP_FN        0x00E00000
#define TOFF_USBO_GRXFSIZ   0x0024		/* (RW) Receive FIFO Size Register */
  #define USB_OTG_GRXFSIZ_RXFD      0x0000FFFF	/* RxFIFO depth */
#define TOFF_USBO_DIEPTXF0_HNPTXFSIZ 0x0028	/* (RW) EP0 / Non Periodic Tx FIFO Size Register */
  #define USB_OTG_NPTXFSA           0x0000FFFF	/* Nonperiodic transmit RAM start address */
  #define USB_OTG_NPTXFD            0xFFFF0000	/* Nonperiodic TxFIFO depth */
  #define USB_OTG_TX0FSA            0x0000FFFF	/* Endpoint 0 transmit RAM start address */
  #define USB_OTG_TX0FD             0xFFFF0000	/* Endpoint 0 TxFIFO depth */
#define TOFF_USBO_HNPTXSTS  0x002C		/* (RW) Non Periodic Tx FIFO/Queue Sts Register */
#define TOFF_USBO_GPVNDCTL  0x0034		/* (RW) User use PHY resgisters */
#define TOFF_USBO_GGPIO     0x0038		/* (RW) User debug gpio */
#define TOFF_USBO_CID       0x003C		/* (R)  User ID Register */
  #define USB_OTG_CID_PRODUCT_ID    0xFFFFFFFF	/* Product ID field */

#define TOFF_USBO_GSNPSID   0x0040		/* (R)  release number */
#define TOFF_USBO_GHWCFG1   0x0044		/* (R)  User HW config1 */
#define TOFF_USBO_GHWCFG2   0x0048		/* (R)  User HW config2 */
  #define USB_OTG_GHWCFG2_OP_MODE   0x00000007	/*  */
  #define USB_OTG_GHWCFG2_HNP_SRP_CAPABLE       0
  #define USB_ORG_GHWCFG2_SRP_ONLY_CAPABLE      1
  #define USB_OTG_GHWCFG2_NO_HNP_SRP_CAPABLE    2
  #define USB_OTG_GHWCFG2_SRP_CAPABLE_DEVICE    3
  #define USB_OTG_GHWCFG2_NO_SRP_CAPABLE_DEVICE 4
  #define USB_OTG_GHWCFG2_SRP_CAPABLE_HOST      5
  #define USB_OTG_GHWCFG2_NO_SRP_CAPABLE_HOST   6
  #define USB_OTG_GHWCFG2_UNDEFINED             7
#define TOFF_USBO_GHWCFG3   0x004C		/* (R)  User HW config3 */
#define TOFF_USBO_GHWCFG4   0x0050		/* (R)  User HW config4 */

#define TOFF_USBO_GDFIFOCFG 0x005C		/* (RW) DFIFO Software Config Register */
#define TOFF_USBO_HPTXFSIZ  0x0100		/* (RW) Host Periodic Tx FIFO Size Reg */
  #define USB_OTG_HPTXFSIZ_PTXSA    0x0000FFFF	/* Host periodic TxFIFO start address */
  #define USB_OTG_HPTXFSIZ_PTXFD    0xFFFF0000	/* Host periodic TxFIFO depth */
#define TOFF_USBO_DIEPTXF   0x0104		/* (RW) dev Periodic Transmit FIFO x 15 */
  #define USB_OTG_DIEPTXF_INEPTXSA  0x0000FFFF	/* IN endpoint FIFOx transmit RAM start address */
  #define USB_OTG_DIEPTXF_INEPTXFD  0xFFFF0000	/* IN endpoint TxFIFO depth */


/*
 *  USB OTG HOST
 */
#define TADR_USBO0_HOST_BASE    (TADR_USB_OTG0_BASE+USB_OTG_HOST_BASE)
#define TADR_USBO1_HOST_BASE    (TADR_USB_OTG1_BASE+USB_OTG_HOST_BASE)
#define TOFF_USBH_HCFG      0x0000		/* (RW) Host Configuration Register */
  #define USB_OTG_HCFG_FSLSPCS      0x00000003	/* FS/LS PHY clock select */
  #define USB_OTG_HCFG_FSLSPCS_0    0x00000001	/* Bit 0 */
  #define USB_OTG_HCFG_FSLSPCS_1    0x00000002	/* Bit 1 */
  #define USB_OTG_HCFG_FSLSS        0x00000004	/* FS- and LS-only support */
  #define USB_OTG_HCFG_ENA32KHZS    0x00000080
  #define USB_OTG_HCFG_DESCDMA      0x00800000
  #define USB_OTG_HCFG_FRLISTEN     0x03000000
  #define USB_OTG_HCFG_PERSCHEDENA  0x04000000
  #define USB_OTG_HCFG_MODECHTIMEN  0x80000000
#define TOFF_USBH_HFIR      0x0004		/* (RW) Host Frame Interval Register */
  #define USB_OTG_HFIR_FRIVL        0x0000FFFF	/* Frame interval */
  #define USB_OTG_HFIR_HFIRRLDCTRL  0x00010000
#define TOFF_USBH_HFNUM     0x0008		/* (R)  Host Frame Nbr/Frame Remaining */
  #define USB_OTG_HFNUM_FRNUM       0x0000FFFF	/* Frame number */
  #define USB_OTG_HFNUM_FTREM       0xFFFF0000	/* Frame time remaining */
#define TOFF_USBH_HPTXSTS   0x0010		/* (R)  Host Periodic Tx FIFO/ Queue Status */
  #define USB_OTG_HPTXSTS_PTXFSAVL  0x0000FFFF	/* Periodic transmit data FIFO space available */
  #define USB_OTG_HPTXSTS_PTXQSAV   0x00FF0000	/* Periodic transmit request queue space available */
  #define USB_OTG_HPTXSTS_PTXQSAV_0 0x00010000	/* Bit 0 */
  #define USB_OTG_HPTXSTS_PTXQSAV_1 0x00020000	/* Bit 1 */
  #define USB_OTG_HPTXSTS_PTXQSAV_2 0x00040000	/* Bit 2 */
  #define USB_OTG_HPTXSTS_PTXQSAV_3 0x00080000	/* Bit 3 */
  #define USB_OTG_HPTXSTS_PTXQSAV_4 0x00100000	/* Bit 4 */
  #define USB_OTG_HPTXSTS_PTXQSAV_5 0x00200000	/* Bit 5 */
  #define USB_OTG_HPTXSTS_PTXQSAV_6 0x00400000	/* Bit 6 */
  #define USB_OTG_HPTXSTS_PTXQSAV_7 0x00800000	/* Bit 7 */
  #define USB_OTG_HPTXSTS_TERM      0x01000000
  #define USB_OTG_HPTXSTS_TYPE      0x06000000
  #define USB_OTG_HPTXSTS_CHANENDPT 0x78000000
  #define USB_OTG_HPTXSTS_ODDDEVNMF 0x80000000
#define TOFF_USBH_HAINT     0x0014		/* (RW) Host All Channels Interrupt Register */
  #define USB_OTG_HAINT_HAINT       0x0000FFFF	/* Channel interrupts */
#define TOFF_USBH_HAINTMSK  0x0018		/* (RW) Host All Channels Interrupt Mask */
  #define USB_OTG_HAINTMSK_HAINTM   0x0000FFFF	/* Channel interrupt mask */
#define TOFF_USBH_HFIADDR   0x0018		/* (RW) Scatter-Gather Start Address Register */

/*
 *  USB OTG HPRT
 */
#define TADR_USBO0_HPRT0_BASE   (TADR_USB_OTG0_BASE+USB_OTG_HOST_PORT_BASE)
#define TADR_USBO1_HPRT1_BASE   (TADR_USB_OTG1_BASE+USB_OTG_HOST_PORT_BASE)
  #define USB_OTG_HPRT_PCSTS        0x00000001	/* Port connect status */
  #define USB_OTG_HPRT_PCDET        0x00000002	/* Port connect detected */
  #define USB_OTG_HPRT_PENA         0x00000004	/* Port enable */
  #define USB_OTG_HPRT_PENCHNG      0x00000008	/* Port enable/disable change */
  #define USB_OTG_HPRT_POCA         0x00000010	/* Port overcurrent active */
  #define USB_OTG_HPRT_POCCHNG      0x00000020	/* Port overcurrent change */
  #define USB_OTG_HPRT_PRES         0x00000040	/* Port resume */
  #define USB_OTG_HPRT_PSUSP        0x00000080	/* Port suspend */
  #define USB_OTG_HPRT_PRST         0x00000100	/* Port reset */
  #define USB_OTG_HPRT_PLSTS        0x00000C00	/* Port line status */
  #define USB_OTG_HPRT_PLSTS_0      0x00000400	/* Bit 0 */
  #define USB_OTG_HPRT_PLSTS_1      0x00000800	/* Bit 1 */
  #define USB_OTG_HPRT_PPWR         0x00001000	/* Port power */
  #define USB_OTG_HPRT_PTCTL        0x0001E000	/* Port test control */
  #define USB_OTG_HPRT_PTCTL_0      0x00002000	/* Bit 0 */
  #define USB_OTG_HPRT_PTCTL_1      0x00004000	/* Bit 1 */
  #define USB_OTG_HPRT_PTCTL_2      0x00008000	/* Bit 2 */
  #define USB_OTG_HPRT_PTCTL_3      0x00010000	/* Bit 3 */
  #define USB_OTG_HPRT_PSPD         0x00060000	/* Port speed */
  #define USB_OTG_HPRT_PSPD_0       0x00020000	/* Bit 0 */
  #define USB_OTG_HPRT_PSPD_1       0x00040000	/* Bit 1 */

/*
 *  USB HOST CHANNEL SPECIFIC
 */
#define TADR_USBO0_HC_BASE       (TADR_USB_OTG0_BASE+USB_OTG_HOST_CHANNEL_BASE)
#define TADR_USBO1_HC_BASE       (TADR_USB_OTG1_BASE+USB_OTG_HOST_CHANNEL_BASE)
#define USBO_HOST_CHANNEL_REG_SIZE    0x20
#define TOFF_USBHC_HCCHAR   0x0000
  #define USB_OTG_HCCHAR_MPSIZ      0x000007FF	/* Maximum packet size */
  #define USB_OTG_HCCHAR_EPNUM      0x00007800	/* Endpoint number */
  #define USB_OTG_HCCHAR_EPNUM_0    0x00000800	/* Bit 0 */
  #define USB_OTG_HCCHAR_EPNUM_1    0x00001000	/* Bit 1 */
  #define USB_OTG_HCCHAR_EPNUM_2    0x00002000	/* Bit 2 */
  #define USB_OTG_HCCHAR_EPNUM_3    0x00004000	/* Bit 3 */
  #define USB_OTG_HCCHAR_EPDIR      0x00008000	/* Endpoint direction */
  #define USB_OTG_HCCHAR_LSDEV      0x00020000	/* Low-speed device */
  #define USB_OTG_HCCHAR_EPTYP      0x000C0000	/* Endpoint type */
  #define USB_OTG_HCCHAR_EPTYP_0    0x00040000	/* Bit 0 */
  #define USB_OTG_HCCHAR_EPTYP_1    0x00080000	/* Bit 1 */
  #define USB_OTG_HCCHAR_MC         0x00300000	/* Multi Count (MC) / Error Count (EC) */
  #define USB_OTG_HCCHAR_MC_0       0x00100000	/* Bit 0 */
  #define USB_OTG_HCCHAR_MC_1       0x00200000	/* Bit 1 */
  #define USB_OTG_HCCHAR_DAD        0x1FC00000	/* Device address */
  #define USB_OTG_HCCHAR_DAD_0      0x00400000	/* Bit 0 */
  #define USB_OTG_HCCHAR_DAD_1      0x00800000	/* Bit 1 */
  #define USB_OTG_HCCHAR_DAD_2      0x01000000	/* Bit 2 */
  #define USB_OTG_HCCHAR_DAD_3      0x02000000	/* Bit 3 */
  #define USB_OTG_HCCHAR_DAD_4      0x04000000	/* Bit 4 */
  #define USB_OTG_HCCHAR_DAD_5      0x08000000	/* Bit 5 */
  #define USB_OTG_HCCHAR_DAD_6      0x10000000	/* Bit 6 */
  #define USB_OTG_HCCHAR_ODDFRM     0x20000000	/* Odd frame */
  #define USB_OTG_HCCHAR_CHDIS      0x40000000	/* Channel disable */
  #define USB_OTG_HCCHAR_CHENA      0x80000000	/* Channel enable */
#define TOFF_USBHC_HCSPLT   0x0004
  #define USB_OTG_HCSPLT_PRTADDR    0x0000007F	/* Port address */
  #define USB_OTG_HCSPLT_PRTADDR_0  0x00000001	/* Bit 0 */
  #define USB_OTG_HCSPLT_PRTADDR_1  0x00000002	/* Bit 1 */
  #define USB_OTG_HCSPLT_PRTADDR_2  0x00000004	/* Bit 2 */
  #define USB_OTG_HCSPLT_PRTADDR_3  0x00000008	/* Bit 3 */
  #define USB_OTG_HCSPLT_PRTADDR_4  0x00000010	/* Bit 4 */
  #define USB_OTG_HCSPLT_PRTADDR_5  0x00000020	/* Bit 5 */
  #define USB_OTG_HCSPLT_PRTADDR_6  0x00000040	/* Bit 6 */
  #define USB_OTG_HCSPLT_HUBADDR    0x00003F80	/* Hub address */
  #define USB_OTG_HCSPLT_HUBADDR_0  0x00000080	/* Bit 0 */
  #define USB_OTG_HCSPLT_HUBADDR_1  0x00000100	/* Bit 1 */
  #define USB_OTG_HCSPLT_HUBADDR_2  0x00000200	/* Bit 2 */
  #define USB_OTG_HCSPLT_HUBADDR_3  0x00000400	/* Bit 3 */
  #define USB_OTG_HCSPLT_HUBADDR_4  0x00000800	/* Bit 4 */
  #define USB_OTG_HCSPLT_HUBADDR_5  0x00001000	/* Bit 5 */
  #define USB_OTG_HCSPLT_HUBADDR_6  0x00002000	/* Bit 6 */
  #define USB_OTG_HCSPLT_XACTPOS    0x0000C000	/* XACTPOS */
  #define USB_OTG_HCSPLT_XACTPOS_0  0x00004000	/* Bit 0 */
  #define USB_OTG_HCSPLT_XACTPOS_1  0x00008000	/* Bit 1 */
  #define USB_OTG_HCSPLT_COMPLSPLT  0x00010000	/* Do complete split */
  #define USB_OTG_HCSPLT_SPLITEN    0x80000000	/* Split enable */
#define TOFF_USBHC_HCINT    0x0008
  #define USB_OTG_HCINT_XFRC        0x00000001	/* Transfer completed */
  #define USB_OTG_HCINT_CHH         0x00000002	/* Channel halted */
  #define USB_OTG_HCINT_AHBERR      0x00000004	/* AHB error */
  #define USB_OTG_HCINT_STALL       0x00000008	/* STALL response received interrupt */
  #define USB_OTG_HCINT_NAK         0x00000010	/* NAK response received interrupt */
  #define USB_OTG_HCINT_ACK         0x00000020	/* ACK response received/transmitted interrupt */
  #define USB_OTG_HCINT_NYET        0x00000040	/* Response received interrupt */
  #define USB_OTG_HCINT_TXERR       0x00000080	/* Transaction error */
  #define USB_OTG_HCINT_BBERR       0x00000100	/* Babble error */
  #define USB_OTG_HCINT_FRMOR       0x00000200	/* Frame overrun */
  #define USB_OTG_HCINT_DTERR       0x00000400	/* Data toggle error */
  #define USB_OTG_HCINT_BNAINTR     0x00000800
  #define USB_OTG_HCINT_XXACTERR    0x00001000
  #define USB_OTG_HCINT_DESCLSTR    0x00002000
#define TOFF_USBHC_HCINTMSK 0x000C
  #define USB_OTG_HCINTMSK_XFRCM    0x00000001	/* Transfer completed mask */
  #define USB_OTG_HCINTMSK_CHHM     0x00000002	/* Channel halted mask */
  #define USB_OTG_HCINTMSK_AHBERR   0x00000004	/* AHB error */
  #define USB_OTG_HCINTMSK_STALLM   0x00000008	/* STALL response received interrupt mask */
  #define USB_OTG_HCINTMSK_NAKM     0x00000010	/* NAK response received interrupt mask */
  #define USB_OTG_HCINTMSK_ACKM     0x00000020	/* ACK response received/transmitted interrupt mask */
  #define USB_OTG_HCINTMSK_NYET     0x00000040	/* response received interrupt mask */
  #define USB_OTG_HCINTMSK_TXERRM   0x00000080	/* Transaction error mask */
  #define USB_OTG_HCINTMSK_BBERRM   0x00000100	/* Babble error mask */
  #define USB_OTG_HCINTMSK_FRMORM   0x00000200	/* Frame overrun mask */
  #define USB_OTG_HCINTMSK_DTERRM   0x00000400	/* Data toggle error mask */
  #define USB_OTG_HCINTMSK_BNAINTR  0x00000800
  #define USB_OTG_HCINTMSK_DESCLSTR 0x00002000
#define TOFF_USBHC_HCTSIZ   0x0010
  #define USB_OTG_HCTSIZ_XFRSIZ     0x0007FFFF	/* Transfer size */
  #define USB_OTG_HCTSIZ_PKTCNT     0x1FF80000	/* Packet count */
  #define USB_OTG_HCTSIZ_DOPING     0x80000000	/* Do PING */
  #define USB_OTG_HCTSIZ_DPID       0x60000000	/* Data PID */
  #define USB_OTG_HCTSIZ_DPID_0     0x20000000	/* Bit 0 */
  #define USB_OTG_HCTSIZ_DPID_1     0x40000000	/* Bit 1 */
#define TOFF_USBHC_HCDMA    0x0014
  #define USB_OTG_HCDMA_DMAADDR     0xFFFFFFFF	/* DMA address */
#define TOFF_USBHC_HCDMAB   0x0018				/* (RW) Scatter/Gather DMA current address hold */

/*
 *  USB DEVICE(OTG)
 */
#define TADR_USBO0_DEVICE_BASE   (TADR_USB_OTG0_BASE+USB_OTG_DEVICE_BASE)
#define TADR_USBO1_DEVICE_BASE   (TADR_USB_OTG1_BASE+USB_OTG_DEVICE_BASE)
#define TOFF_USBD_DCFG      0x0000		/* (RW) dev Configuration Register */
  #define USB_OTG_DCFG_DSPD         0x00000003	/* Device speed */
  #define USB_OTG_DCFG_DSPD_0       0x00000001	/* Bit 0 */
  #define USB_OTG_DCFG_DSPD_1       0x00000002	/* Bit 1 */
  #define USB_OTG_DCFG_NZLSOHSK     0x00000004	/* Nonzero-length status OUT handshake */
  #define USB_OTG_DCFG_ENA32KHZSUSP 0x00000008
  #define USB_OTG_DCFG_DAD          0x000007F0	/* Device address */
  #define USB_OTG_DCFG_DAD_0        0x00000010	/* Bit 0 */
  #define USB_OTG_DCFG_DAD_1        0x00000020	/* Bit 1 */
  #define USB_OTG_DCFG_DAD_2        0x00000040	/* Bit 2 */
  #define USB_OTG_DCFG_DAD_3        0x00000080	/* Bit 3 */
  #define USB_OTG_DCFG_DAD_4        0x00000100	/* Bit 4 */
  #define USB_OTG_DCFG_DAD_5        0x00000200	/* Bit 5 */
  #define USB_OTG_DCFG_DAD_6        0x00000400	/* Bit 6 */
  #define USB_OTG_DCFG_PFIVL        0x00001800	/* Periodic (micro)frame interval */
  #define USB_OTG_DCFG_PFIVL_0      0x00000800	/* Bit 0 */
  #define USB_OTG_DCFG_PFIVL_1      0x00001000	/* Bit 1 */
  #define USB_OTG_DCFG_DESCDMA      0x00800000	/* Scatter/Gather DMA option select */
  #define USB_OTG_DCFG_PERSCHIVL    0x03000000	/* Periodic scheduling interval */
  #define USB_OTG_DCFG_PERSCHIVL_0  0x01000000	/* Bit 0 */
  #define USB_OTG_DCFG_PERSCHIVL_1  0x02000000	/* Bit 1 */
#define TOFF_USBD_DCTL      0x0004		/* (RW) dev Control Register */
  #define USB_OTG_DCTL_RWUSIG       0x00000001	/* Remote wakeup signaling */
  #define USB_OTG_DCTL_SDIS         0x00000002	/* Soft disconnect */
  #define USB_OTG_DCTL_GINSTS       0x00000004	/* Global IN NAK status */
  #define USB_OTG_DCTL_GONSTS       0x00000008	/* Global OUT NAK status */
  #define USB_OTG_DCTL_TCTL         0x00000070	/* Test control */
  #define USB_OTG_DCTL_TCTL_0       0x00000010	/* Bit 0 */
  #define USB_OTG_DCTL_TCTL_1       0x00000020	/* Bit 1 */
  #define USB_OTG_DCTL_TCTL_2       0x00000040	/* Bit 2 */
  #define USB_OTG_DCTL_SGINAK       0x00000080	/* Set global IN NAK */
  #define USB_OTG_DCTL_CGINAK       0x00000100	/* Clear global IN NAK */
  #define USB_OTG_DCTL_SGONAK       0x00000200	/* Set global OUT NAK */
  #define USB_OTG_DCTL_CGONAK       0x00000400	/* Clear global OUT NAK */
  #define USB_OTG_DCTL_POPRGDNE     0x00000800	/* Power-on programming done */
  #define USB_OTG_DCTL_GMC          0x00006000	/* Scatter/Gather mode, indicate number of packets to be serviced */
  #define USB_OTG_DCTL_IGNRFRMNUM   0x00008000	/* Scatter/Gather mode packets not flushed when a ISOC In */
  #define USB_OTG_DCTL_NAKONBBLE    0x00010000	/* Set NAK automatically on bebble */
#define TOFF_USBD_DSTS      0x0008		/* (RO) dev Status Register (RO) */
  #define USB_OTG_DSTS_SUSPSTS      0x00000001	/* Suspend status */
  #define USB_OTG_DSTS_ENUMSPD      0x00000006	/* Enumerated speed */
  #define USB_OTG_DSTS_ENUMSPD_0    0x00000002	/* Bit 0 */
  #define USB_OTG_DSTS_ENUMSPD_1    0x00000004	/* Bit 1 */
  #define USB_OTG_DSTS_EERR         0x00000008	/* Erratic error */
  #define USB_OTG_DSTS_FNSOF        0x003FFF00	/* Frame number of the received SOF */
#define TOFF_USBD_DIEPMSK   0x0010		/* (RW) dev IN Endpoint Mask */
  #define USB_OTG_DIEPMSK_XFRCM     0x00000001	/* Transfer completed interrupt mask */
  #define USB_OTG_DIEPMSK_EPDM      0x00000002	/* Endpoint disabled interrupt mask */
  #define USB_OTG_DIEPMSK_AHBERRM   0x00000004	/* AHB error interrupt mask */
  #define USB_OTG_DIEPMSK_TOM       0x00000008	/* Timeout condition mask (nonisochronous endpoints) */
  #define USB_OTG_DIEPMSK_ITTXFEMSK 0x00000010	/* IN token received when TxFIFO empty mask */
  #define USB_OTG_DIEPMSK_INEPNMM   0x00000020	/* IN token received with EP mismatch mask */
  #define USB_OTG_DIEPMSK_INEPNEM   0x00000040	/* IN endpoint NAK effective mask */
  #define USB_OTG_DIEPMSK_TXFURM    0x00000100	/* FIFO underrun mask */
  #define USB_OTG_DIEPMSK_BIM       0x00000200	/* BNA interrupt mask */
  #define USB_OTG_DIEPMSK_NAKMSK    0x00002000	/* NAK interrupt mask */
#define TOFF_USBD_DOEPMSK   0x0014		/* (RW) dev OUT Endpoint Mask */
  #define USB_OTG_DOEPMSK_XFRCM     0x00000001	/* Transfer completed interrupt mask */
  #define USB_OTG_DOEPMSK_EPDM      0x00000002	/* Endpoint disabled interrupt mask */
  #define USB_OTG_DOEPMSK_AHBERRM   0x00000004	/* AHB error interrupt mask */
  #define USB_OTG_DOEPMSK_STUPM     0x00000008	/* SETUP phase done mask */
  #define USB_OTG_DOEPMSK_OTEPDM    0x00000010	/* OUT token received when endpoint disabled mask */
  #define USB_OTG_DOEPMSK_B2BSTUP   0x00000040	/* Back-to-back SETUP packets received mask */
  #define USB_OTG_DOEPMSK_OPEM      0x00000100	/* OUT packet error mask */
  #define USB_OTG_DOEPMSK_BOIM      0x00000200	/* BNA interrupt mask */
  #define USB_OTG_DOEPMSK_BLEERRMSK  0x00001000	/* Babble Error interrupt mask */
  #define USB_OTG_DOEPMSK_NAKMSK     0x00002000	/* NAK interrupt mask */
  #define USB_OTG_DOEPMSK_NYETMSK    0x00004000	/* NYET interrupt mask */
#define TOFF_USBD_DAINT     0x0018		/* (R)  dev All Endpoints Itr Register */
  #define USB_OTG_DAINT_IEPINT      0x0000FFFF	/* IN endpoint interrupt bits */
  #define USB_OTG_DAINT_OEPINT      0xFFFF0000	/* OUT endpoint interrupt bits */
#define TOFF_USBD_DAINTMSK  0x001C		/* (RW) dev All Endpoints Itr Mask */
  #define USB_OTG_DAINTMSK_IEPM     0x0000FFFF	/* IN EP interrupt mask bits */
  #define USB_OTG_DAINTMSK_OEPM     0xFFFF0000	/* OUT EP interrupt mask bits */
#define TOFF_USBD_DVBUSDIS  0x0028		/* (RW) dev VBUS discharge Register */
  #define USB_OTG_DVBUSDIS_VBUSDT   0x0000FFFF	/* Device VBUS discharge time */
#define TOFF_USBD_DVBUSPULSE 0x002C		/* (RW) dev VBUS Pulse Register */
  #define USB_OTG_DVBUSPULSE_DVBUSP 0x00000FFF	/* Device VBUS pulsing time */
#define TOFF_USBD_DTHRCTL   0x0030		/* (RW) dev thr */
  #define USB_OTG_DTHRCTL_NONISOTHREN 0x00000001	/* Nonisochronous IN endpoints threshold enable */
  #define USB_OTG_DTHRCTL_ISOTHREN    0x00000002	/* ISO IN endpoint threshold enable */
  #define USB_OTG_DTHRCTL_TXTHRLEN    0x000007FC	/* Transmit threshold length */
  #define USB_OTG_DTHRCTL_TXTHRLEN_0  0x00000004	/* Bit 0 */
  #define USB_OTG_DTHRCTL_TXTHRLEN_1  0x00000008	/* Bit 1 */
  #define USB_OTG_DTHRCTL_TXTHRLEN_2  0x00000010	/* Bit 2 */
  #define USB_OTG_DTHRCTL_TXTHRLEN_3  0x00000020	/* Bit 3 */
  #define USB_OTG_DTHRCTL_TXTHRLEN_4  0x00000040	/* Bit 4 */
  #define USB_OTG_DTHRCTL_TXTHRLEN_5  0x00000080	/* Bit 5 */
  #define USB_OTG_DTHRCTL_TXTHRLEN_6  0x00000100	/* Bit 6 */
  #define USB_OTG_DTHRCTL_TXTHRLEN_7  0x00000200	/* Bit 7 */
  #define USB_OTG_DTHRCTL_TXTHRLEN_8  0x00000400	/* Bit 8 */
  #define USB_OTG_DTHRCTL_RXTHREN     0x00010000	/* Receive threshold enable */
  #define USB_OTG_DTHRCTL_RXTHRLEN    0x03FE0000	/* Receive threshold length */
  #define USB_OTG_DTHRCTL_RXTHRLEN_0  0x00020000	/* Bit 0 */
  #define USB_OTG_DTHRCTL_RXTHRLEN_1  0x00040000	/* Bit 1 */
  #define USB_OTG_DTHRCTL_RXTHRLEN_2  0x00080000	/* Bit 2 */
  #define USB_OTG_DTHRCTL_RXTHRLEN_3  0x00100000	/* Bit 3 */
  #define USB_OTG_DTHRCTL_RXTHRLEN_4  0x00200000	/* Bit 4 */
  #define USB_OTG_DTHRCTL_RXTHRLEN_5  0x00400000	/* Bit 5 */
  #define USB_OTG_DTHRCTL_RXTHRLEN_6  0x00800000	/* Bit 6 */
  #define USB_OTG_DTHRCTL_RXTHRLEN_7  0x01000000	/* Bit 7 */
  #define USB_OTG_DTHRCTL_RXTHRLEN_8  0x02000000	/* Bit 8 */
  #define USB_OTG_DTHRCTL_ARPEN       0x08000000	/* Arbiter parking enable */
#define TOFF_USBD_DIEPEMPMSK 0x0034		/* (RW) dev empty msk */
  #define USB_OTG_DIEPEMPMSK_INEPTXFEM 0x0000FFFF	/* IN EP Tx FIFO empty interrupt mask bits */

/*
 *  USB OTG IN ENDPOINT
 */
#define TADR_USBO0_INEP_BASE    (TADR_USB_OTG0_BASE+USB_OTG_IN_ENDPOINT_BASE)
#define TADR_USBO1_INEP_BASE    (TADR_USB_OTG1_BASE+USB_OTG_IN_ENDPOINT_BASE)
#define USBO_EP_REG_SIZE         0x20
#define TOFF_USBEI_DIEPCTL  0x0000		/* (RW) dev IN Endpoint Control Register */
  #define USB_OTG_DIEPCTL_MPSIZ     0x000007FF	/* Maximum packet size */
  #define USB_OTG_DIEPCTL_USBAEP    0x00008000	/* USB active endpoint */
  #define USB_OTG_DIEPCTL_EONUM_DPID 0x00010000	/* Even/odd frame */
  #define USB_OTG_DIEPCTL_NAKSTS    0x00020000	/* NAK status */
  #define USB_OTG_DIEPCTL_EPTYP     0x000C0000	/* Endpoint type */
  #define USB_OTG_DIEPCTL_EPTYP_0   0x00040000	/* Bit 0 */
  #define USB_OTG_DIEPCTL_EPTYP_1   0x00080000	/* Bit 1 */
  #define USB_OTG_DIEPCTL_STALL     0x00200000	/* STALL handshake */
  #define USB_OTG_DIEPCTL_TXFNUM    0x03C00000	/* TxFIFO number */
  #define USB_OTG_DIEPCTL_TXFNUM_0  0x00400000	/* Bit 0 */
  #define USB_OTG_DIEPCTL_TXFNUM_1  0x00800000	/* Bit 1 */
  #define USB_OTG_DIEPCTL_TXFNUM_2  0x01000000	/* Bit 2 */
  #define USB_OTG_DIEPCTL_TXFNUM_3  0x02000000	/* Bit 3 */
  #define USB_OTG_DIEPCTL_CNAK      0x04000000	/* Clear NAK */
  #define USB_OTG_DIEPCTL_SNAK      0x08000000	/* Set NAK */
  #define USB_OTG_DIEPCTL_SD0PID_SEVNFRM 0x10000000	/* Set DATA0 PID */
  #define USB_OTG_DIEPCTL_SODDFRM   0x20000000	/* Set odd frame */
  #define USB_OTG_DIEPCTL_EPDIS     0x40000000	/* Endpoint disable */
  #define USB_OTG_DIEPCTL_EPENA     0x80000000	/* Endpoint enable */
#define TOFF_USBEI_DIEPINT  0x0008		/* (RW) dev IN Endpoint Itr Register */
  #define USB_OTG_DIEPINT_XFRC      0x00000001	/* Transfer completed interrupt */
  #define USB_OTG_DIEPINT_EPDISD    0x00000002	/* Endpoint disabled interrupt */
  #define USB_OTG_DIEPINT_AHBERR    0x00000004	/* AHB error interrupt */
  #define USB_OTG_DIEPINT_TOC       0x00000008	/* Timeout condition */
  #define USB_OTG_DIEPINT_ITTXFE    0x00000010	/* IN token received when TxFIFO is empty */
  #define USB_OTG_DIEPINT_ITKNEPMIS 0x00000020	/* IN token received with EP Mismatch interrupt */
  #define USB_OTG_DIEPINT_INEPNE    0x00000040	/* IN endpoint NAK effective */
  #define USB_OTG_DIEPINT_TXFE      0x00000080	/* Transmit FIFO empty */
  #define USB_OTG_DIEPINT_TXFIFOUDRN 0x00000100	/* Transmit Fifo Underrun */
  #define USB_OTG_DIEPINT_BNA       0x00000200	/* Buffer not available interrupt */
  #define USB_OTG_DIEPINT_PKTDRPSTS 0x00000800	/* Packet dropped status */
  #define USB_OTG_DIEPINT_BERR      0x00001000	/* Babble error interrupt */
  #define USB_OTG_DIEPINT_NAK       0x00002000	/* NAK interrupt */
  #define USB_OTG_DIEPINT_NYET      0x00004000	/* NYET interrupt */
#define TOFF_USBEI_DIEPTSIZ 0x0010		/* (RW) IN Endpoint Txfer Size */
  #define USB_OTG_DIEPTSIZ_XFRSIZ   0x0007FFFF	/* Transfer size */
  #define USB_OTG_DIEPTSIZ_PKTCNT   0x1FF80000	/* Packet count */
  #define USB_OTG_DIEPTSIZ_MULCNT   0x60000000	/* Packet count */
#define TOFF_USBEI_DIEPDMA  0x0014		/* (RW) IN Endpoint DMA Address Register */
  #define USB_OTG_DIEPDMA_DMAADDR   0xFFFFFFFF	/* DMA address */
#define TOFF_USBEI_DTXFSTS  0x0018		/* (RW) IN Endpoint Tx FIFO Status Register */
  #define USB_OTG_DTXFSTS_INEPTFSAV 0x0000FFFF	/* IN endpoint TxFIFO space avail */
#define TOFF_USBEI_DIEPDMAB 0x001C		/* (R)  IN Endpoint DMAB */

/*
 *  USB OTG OUTPUT ENDPOINT
 */
#define TADR_USBO0_OUTEP_BASE   (TADR_USB_OTG0_BASE+USB_OTG_OUT_ENDPOINT_BASE)
#define TADR_USBO1_OUTEP_BASE   (TADR_USB_OTG1_BASE+USB_OTG_OUT_ENDPOINT_BASE)
#define TOFF_USBEO_DOEPCTL  0x0000		/* (RW) dev OUT Endpoint Control Register */
  #define USB_OTG_DOEPCTL_MPSIZ     0x000007FF	/* Maximum packet size */
  #define USB_OTG_DOEPCTL_USBAEP    0x00008000	/* USB active endpoint */
  #define USB_OTG_DOEPCTL_EONUM_DPID 0x00010000	/* Even/odd frame */
  #define USB_OTG_DOEPCTL_NAKSTS    0x00020000	/* NAK status */
  #define USB_OTG_DOEPCTL_EPTYP     0x000C0000	/* Endpoint type */
  #define USB_OTG_DOEPCTL_EPTYP_0   0x00040000	/* Bit 0 */
  #define USB_OTG_DOEPCTL_EPTYP_1   0x00080000	/* Bit 1 */
  #define USB_OTG_DOEPCTL_SNPM      0x00100000	/* Snoop mode */
  #define USB_OTG_DOEPCTL_STALL     0x00200000	/* STALL handshake */
  #define USB_OTG_DOEPCTL_CNAK      0x04000000	/* Clear NAK */
  #define USB_OTG_DOEPCTL_SNAK      0x08000000	/* Set NAK */
  #define USB_OTG_DOEPCTL_SD0PID_SEVNFRM  0x10000000	/* Set DATA0 PID */
  #define USB_OTG_DOEPCTL_SODDFRM   0x20000000	/* Set odd frame */
  #define USB_OTG_DOEPCTL_EPDIS     0x40000000	/* Endpoint disable */
  #define USB_OTG_DOEPCTL_EPENA     0x80000000	/* Endpoint enable */
#define TOFF_USBEO_DOEPINT  0x0008		/* (RW) dev OUT Endpoint Itr Register */
  #define USB_OTG_DOEPINT_XFRC      0x00000001	/* Transfer completed interrupt */
  #define USB_OTG_DOEPINT_EPDISD    0x00000002	/* Endpoint disabled interrupt */
  #define USB_OTG_DOEPINT_STUP      0x00000008	/* SETUP phase done */
  #define USB_OTG_DOEPINT_OTEPDIS   0x00000010	/* OUT token received when endpoint disabled */
  #define USB_OTG_DOEPINT_STSPHSERC 0x00000020	/* Status Phase Received for Control Write */
  #define USB_OTG_DOEPINT_B2BSTUP   0x00000040	/* Back-to-back SETUP packets received */
  #define USB_OTG_DOEPINT_OUTPKTERR 0x00000100	/* OUT Packet Error */
  #define USB_OTG_DOEPINT_BNA       0x00000200	/* BNA interrupt */
  #define USB_OTG_DOEPINT_PKTDRPSTS 0x00000800	/* Packet Drop Status interrupt */
  #define USB_OTG_DOEPINT_BBLEERR   0x00001000	/* BbleErr interrupt */
  #define USB_OTG_DOEPINT_NACK      0x00002000	/* NAK interrupt */
  #define USB_OTG_DOEPINT_NYET      0x00004000	/* NYET interrupt */
#define TOFF_USBEO_DOEPTSIZ 0x0010		/* (RW) dev OUT Endpoint Txfer Size */
  #define USB_OTG_DOEPTSIZ_XFRSIZ   0x0007FFFF	/* Transfer size */
  #define USB_OTG_DOEPTSIZ_PKTCNT   0x1FF80000	/* Packet count */
  #define USB_OTG_DOEPTSIZ_STUPCNT  0x60000000	/* SETUP packet count */
  #define USB_OTG_DOEPTSIZ_STUPCNT_0 0x20000000	/* Bit 0 */
  #define USB_OTG_DOEPTSIZ_STUPCNT_1 0x40000000	/* Bit 1 */
#define TOFF_USBEO_DOEPDMA  0x0014		/* (RW) dev OUT Endpoint DMA Address */
#define TOFF_USBEO_DIEPDMAB 0x001C		/* (R)  OUT Endpoint DMAB */

/*
 *  UNIVERSAL ASYNCHORONOUS RECEIVER TRANSMITTER
 */
#define TADR_UART0_BASE         (PERIPH_BASE + 0x802000)
#define TADR_UART1_BASE         (PERIPH_BASE + 0x803000)
#define TOFF_UART_RBR_THR_DLL   0x0000		/* (RW) Rx Buffer, Tx Holding, and Divisor Latch Low register */
#define TOFF_UART_IER_DLH       0x0004		/* (RW) Interrupt Enable and Divisor Latch High register */
  #define UART_IER_DLH_ERBFI       0x00000001	/* DLH[0] and Receive Data Interrupt Enable */
  #define UART_IER_DLH_ETBEI       0x00000002	/* DLH[1] and Transmit Data Interrupt Control */
  #define UART_IER_DLH_ELSI        0x00000004	/* DLH[2] and Enable Receiver Line Status */
  #define UART_IER_DLH_EDSSI       0x00000008	/* DLH[3] and Enable Modem Status Interrupt */
  #define UART_IER_DLH_PTIM        0x00000080	/* DLH[7] and PTIME THRE Interrupt Mode Enable */
#define TOFF_UART_IIR           0x0008		/* (R) Interrupt Identity Register register */
  #define UART_IIR_ID_MSK          0x0000000f	/* Interrupt ID */
  #define UART_IIR_ID_E_MODMSTAT       0x0
  #define UART_IIR_ID_E_NOINTRPENDING  0x1
  #define UART_IIR_ID_E_THREMPTY       0x2
  #define UART_IIR_ID_E_RXDATAVAILABLE 0x4
  #define UART_IIR_ID_E_RXLINESTAT     0x6
  #define UART_IIR_ID_E_CHARTMO        0xc
  #define UART_IIR_FIFOEN_MSK      0x000000c0	/* FIFO Enabled */
  #define UART_IIR_FIFOEN_E_DISD   (0x0<<4)
  #define UART_IIR_FIFOEN_E_END    (0x3<<4)
#define TOFF_UART_FCR           0x0008		/* (W)  FIFO Control register */
  #define UART_FCR_FIFOE           0x00000001	/* FIFO Enable */
  #define UART_FCR_RFIFOR          0x00000002	/* Rx FIFO Reset */
  #define UART_FCR_XFIFOR          0x00000004	/* Tx FIFO Reset */
  #define UART_FCR_DMAM            0x00000008	/* DMA Mode */
  #define UART_FCR_TET             0x00000030	/* Tx Empty Trigger Level */
  #define UART_FCR_RT              0x000000c0	/* Rx Trigger Level */
#define TOFF_UART_LCR           0x000C		/* (RW) Line Control register */
  #define UART_LCR_DLS_MSK         0x00000003	/* Data Length Select */
  #define UART_LCR_DLS_E_LEN5      0x0
  #define UART_LCR_DLS_E_LEN6      0x1
  #define UART_LCR_DLS_E_LEN7      0x2
  #define UART_LCR_DLS_E_LEN8      0x3
  #define UART_LCR_STOP            0x00000004	/* Stop Bits */
  #define UART_LCR_PEN             0x00000008	/* Parity Enable */
  #define UART_LCR_EPS_MSK         0x00000010	/* Even Parity Select */
  #define UART_LCR_EPS_E_ODDPAR    (0x0<<4)
  #define UART_LCR_EPS_E_EVENPAR   (0x1<<4)
  #define UART_LCR_BREAK           0x00000040	/* Break Control Bit */
  #define UART_LCR_DLAB            0x00000080	/* Divisor Latch Access Bit */
#define TOFF_UART_MCR           0x0010		/* (RW) Modem Control register */
  #define UART_MCR_DTR             0x00000001	/* Data Terminal Ready */
  #define UART_MCR_RTS             0x00000002	/* Request to Send */
  #define UART_MCR_OUT1            0x00000004	/* Out1 */
  #define UART_MCR_OUT2            0x00000008	/* out2 */
  #define UART_MCR_LOOPBACK        0x00000010	/* LoopBack Bit */
  #define UART_MCR_AFCE            0x00000020	/* Auto Flow Control Enable */
#define TOFF_UART_LSR           0x0014		/* (R) Line Status register */
  #define UART_LSR_DR              0x00000001	/* Data Ready bit */
  #define UART_LSR_OE              0x00000002	/* Overrun error */
  #define UART_LSR_PE              0x00000004	/* Parity Error */
  #define UART_LSR_FE              0x00000008	/* Framing Error */
  #define UART_LSR_BI              0x00000010	/* Break Interrupt */
  #define UART_LSR_THRE            0x00000020	/* Transmit Holding Register Empty bit */
  #define UART_LSR_TEMT            0x00000040	/* Transmitter Empty bit */
  #define UART_LSR_RFE             0x00000080	/* Receiver FIFO Error bit */
#define TOFF_UART_MSR           0x0018		/* (R) Modem Status register */
  #define UART_MSR_DCTS            0x00000001	/* Delta Clear to Send */
  #define UART_MSR_DDSR            0x00000002	/* Delta Data Set Ready */
  #define UART_MSR_TERI            0x00000004	/* Trailing Edge of Ring Indicator */
  #define UART_MSR_DDCD            0x00000008	/* Delta Data Carrier Detect */
  #define UART_MSR_CTS             0x00000010	/* Clear to Send */
  #define UART_MSR_DSR             0x00000020	/* Data Set Ready */
  #define UART_MSR_RI              0x00000040	/* Ring Indicator */
  #define UART_MSR_DCD             0x00000080	/* Data Carrier Detect */
#define TOFF_UART_SRBR          0x0030		/* (RW) Shadow Receive Buffer Register */
  #define UART_SRBR_SRBR           0x000000FF	/* Shadow Receive Buffer */
#define TOFF_UART_STHR          0x0034		/* (RW) Shadow Transmit Buffer Register */
  #define UART_STHR_STHR           0x000000FF	/* Shadow Transmit Buffer */
#define TOFF_UART_FAR           0x0070		/* (RW) FIFO Access Register */
  #define UART_FAR_SRBR_STHR       0x00000001	/* FIFO ACCESS Bit */
#define TOFF_UART_TFR           0x0074		/* (R)  Transmit FIFO Read Register */
  #define UART_TFR_TFR             0x000000FF	/* Transmit FIFO Read */
#define TOFF_UART_RFW           0x0078		/* (W)  Receive FIFO Write register */
  #define UART_RFW_RFWD            0x000000FF	/* Receive FIFO Write Field */
  #define UART_RFW_RFPE            0x00000100	/* Receive FIFO Parity Error */
  #define UART_RFW_RFFE            0x00000200	/* Receive FIFO Framing Error */
#define TOFF_UART_USR           0x007C		/* (R)  UART Status Register */
  #define UART_USR_TFNF            0x00000002	/* Transmit FIFO Not Full */
  #define UART_USR_TFE             0x00000004	/* Transmit FIFO Empty */
  #define UART_USR_RFNE            0x00000008	/* Receive FIFO Not Empty */
  #define UART_USR_RFF             0x00000010	/* Receive FIFO Full */
#define TOFF_UART_TFL           0x0080		/* (R)  Transmit FIFO Level register */
  #define UART_TFL_TFL             0x0000001F	/* Transmit FIFO Level */
#define TOFF_UART_RFL           0x0084		/* (R)  Receive FIFO Level Write register */
  #define UART_RFL_RFL             0x0000001F	/* Receive FIFO Level Write */
#define TOFF_UART_SRR           0x0088		/* (W) ALT_UART_SRR register */
  #define UART_SRR_UR              0x00000001	/* UART Reset */
  #define UART_SRR_RFR             0x00000002	/* Rx FIFO Reset */
  #define UART_SRR_XFR             0x00000004	/* Tx FIFO Reset */
#define TOFF_UART_SRTS          0x008C		/* (RW) Shadow Request to Send register */
  #define UART_SRTS_SRTS           0x00000001	/* Shadow Request to Send */
#define TOFF_UART_SBCR          0x0090		/* (RW) Shadow Break Control register */
  #define UART_SBCR_SBCR           0x00000001	/* Shadow Break Control */
#define TOFF_UART_SDMAM         0x0094		/* (RW) Shadow DMA Mode register */
  #define UART_SDMAM_SDMAM         0x00000001	/* Shadow DMA Mode */
#define TOFF_UART_SFE           0x0098		/* (RW) Shadow FIFO Enable register */
  #define UART_SFE_SFE             0x00000001	/* Shadow FIFO Enable */
#define TOFF_UART_SRT           0x009C		/* (RW) Shadow Rx Trigger register */
  #define UART_SRT_SRT             0x00000003	/* Shadow Rx Trigger Bits */
#define TOFF_UART_STET          0x00A0		/* (RW) Shadow Tx Empty Trigger register */
  #define UART_STET_STET           0x00000003	/* Shadow Tx Empty Trigger Bits */
#define TOFF_UART_HTX           0x00A4		/* (RW) Halt Tx register */
  #define UART_HTX_HTX             0x00000001	/* Halt Tx Bits */
#define TOFF_UART_DMASA         0x00A8		/* (W)  DMA Software Acknowledge register */
 #define UART_DMASA_DMASA          0x00000001	/* DMA Software Acknowledge */
#define TOFF_UART_CPR           0x00F4		/* (R)  Component Parameter register */
  #define UART_CPR_APBDATAWIDTH    0x00000003	/* APB DATA WIDTH */
  #define UART_CPR_AFCE_MOD        0x00000010	/* Auto Flow Control */
  #define UART_CPR_THRE_MOD        0x00000020	/* THRE MODE */
  #define UART_CPR_SIR_MOD         0x00000040	/* SIR MODE Unsupported */
  #define UART_CPR_SIR_LP_MOD      0x00000080	/* SIR LP MODE Unsupported */
  #define UART_CPR_ADDITIONAL_FEAT 0x00000100	/* ADDITIONAL FEATURES Supported */
  #define UART_CPR_FIFO_ACCESS     0x00000200	/* FIFO ACCESS Supported */
  #define UART_CPR_FIFO_STAT       0x00000400	/* FIFO STAT Supported */
  #define UART_CPR_SHADOW          0x00000800	/* SHADOW Supported */
  #define UART_CPR_UART_ADD_ENC_PARAM 0x00001000	/* Configuartion ID Register Present */
  #define UART_CPR_DMA_EXTRA       0x00002000	/* DMA EXTRA Supported */
  #define UART_CPR_FIFO_MOD        0x00ff0000	/* FIFO Depth */
#define TOFF_UART_UCV           0x00F8		/* (R) Component Version register */
  #define UART_UCV_UART_COMPONENT_VER 0x3331312a
#define TOFF_UART_CTR           0x00FC		/* (R) Component Type register */
  #define UART_CTR_PERIPHERAL_ID      0x44570110


/*
 *  PCGCCTL BIT DEFINITIONS
 */
#define USB_OTG_PCGCCTL_STOPCLK     0x00000001	/* SETUP packet count */
#define USB_OTG_PCGCTL_PWRCLMP      0x00000004
#define USB_OTG_PCGCTL_RSTPDWNMODULE 0x00000008


/*
 *  HPS I2C MODULE
 */
#define TADR_I2C1_BASE          (PERIPH_BASE + 0x804000)
#define TADR_I2C2_BASE          (PERIPH_BASE + 0x805000)
#define TADR_I2C3_BASE          (PERIPH_BASE + 0x806000)
#define TADR_I2C4_BASE          (PERIPH_BASE + 0x807000)
#define TOFF_I2C_CON            0x0000		/* (RW) I2C Control Register */
  #define I2C_CON_MST_MOD          0x00000001	/* Master Enable */
  #define I2C_CON_SPEED            0x00000006	/* Master Speed Control */
  #define I2C_CON_SPEED_STANDARD   0x00000002
  #define I2C_CON_SPEED_FAST       0x00000004
  #define I2C_CON_IC_10BITADDR_SLV 0x00000008	/* Slave Address Size */
  #define I2C_CON_IC_10BITADDR_MST 0x00000010	/* Master Address Size */
  #define I2C_CON_IC_RESTART_EN    0x00000020	/* Restart Enable */
  #define I2C_CON_IC_SLV_DIS       0x00000040	/* Slave Disable */
#define TOFF_I2C_TAR            0x0004		/* (RW) Target Address Register */
  #define I2C_TAR_IC_TAR           0x000003FF	/* Master Target Address */
  #define I2C_TAR_GC_OR_START      0x00000400	/* General Call OR Start */
  #define I2C_TAR_SPECIAL          0x00000800	/* Special */
  #define I2C_TAR_IC_10BITADDR     0x00001000	/*  Master Addressing Bit Control */
#define TOFF_I2C_SAR            0x0008		/* (RW) Slave Address Register */
  #define I2C_SAR_IC_SAR           0x000003ff	/* Slave Address */
#define TOFF_I2C_DATA_CMD       0x0010		/* (RW) Tx Rx Data and Command Register */
  #define I2C_DATA_CMD_DAT         0x000000ff	/* Tx Rx Data */
  #define I2C_DATA_CMD_CMD         0x00000100	/* Master Read Write Control */
  #define I2C_DATA_CMD_STOP        0x00000200	/* Generate Stop */
  #define I2C_DATA_CMD_RESTART     0x00000400	/* Generate Restart */
#define TOFF_I2C_SS_SCL_HCNT    0x0014		/* (RW) Std Spd Clock SCL HCNT Register */
  #define I2C_SS_SCL_HCNT_MSK      0x0000ffff	/* Std Spd SCL High Period */
#define TOFF_I2C_SS_SCL_LCNT    0x0018		/* (RW) Std Spd Clock SCL LCNT Register */
  #define I2C_SS_SCL_LCNT_MSK      0x0000ffff	/* Std Spd SCL Low Period */
#define TOFF_I2C_FS_SCL_HCNT    0x001C		/* (RW) Fast Spd Clock SCL HCNT Register */
  #define I2C_FS_SCL_HCNT_MSK      0x0000ffff	/* Fast Spd SCL High Period */
#define TOFF_I2C_FS_SCL_LCNT    0x0020		/* (RW) Fast Spd Clock SCL LCNT Register */
  #define I2C_FS_SCL_LCNT_MSK      0x0000ffff	/* Fast Spd SCL Low Period */
#define TOFF_I2C_INTR_STAT      0x002C		/* (R)  Interrupt Status Register */
  #define I2C_INTR_STAT_ALL        0x00000FFF	/* All Interrupt status */
  #define I2C_INTR_STAT_RX_UNDER   0x00000001	/* Receiver Under */
  #define I2C_INTR_STAT_RX_OVER    0x00000002	/* Receiver Over */
  #define I2C_INTR_STAT_RX_FULL    0x00000004	/* Receive Full */
  #define I2C_INTR_STAT_TX_OVER    0x00000008	/* Interrupt Transmit Over */
  #define I2C_INTR_STAT_TX_EMPTY   0x00000010	/* Interrupt Transmit Empty */
  #define I2C_INTR_STAT_R_RD_REQ   0x00000020	/* Interrupt Read Request */
  #define I2C_INTR_STAT_R_TX_ABRT  0x00000040	/* Interrupt TX Abort */
  #define I2C_INTR_STAT_R_RX_DONE  0x00000080	/* Interrupt RX Done */
  #define I2C_INTR_STAT_R_ACTIVITY 0x00000100	/* Interrupt R_activity */
  #define I2C_INTR_STAT_R_STOP_DET 0x00000200	/* Interrupt Stop Detect */
  #define I2C_INTR_STAT_R_START_DET 0x00000400	/* Interrupt Start Detect */
  #define I2C_INTR_STAT_R_GEN_CALL 0x00000800	/* Interrupt General Call */
#define TOFF_I2C_INTR_MSK       0x0030		/* (RW) Interrupt Mask Register */
#define TOFF_I2C_RAW_INTR_STAT  0x0034		/* (R)  Raw Interrupt Status Register */
#define TOFF_I2C_RX_TL          0x0038		/* (RW) Receive FIFO Threshold Register */
#define TOFF_I2C_TX_TL          0x003C		/* (RW) Transmit FIFO Threshold Level */
#define TOFF_I2C_CLR_INTR       0x0040		/* (R)  Combined and Individual Interrupt Register */
#define TOFF_I2C_CLR_RX_UNDER   0x0044		/* (R)  Rx Under Interrupt Register */
#define TOFF_I2C_CLR_RX_OVER    0x0048		/* (R)  RX Over Interrupt Register */
#define TOFF_I2C_CLR_TX_OVER    0x004C		/* (R)  TX Over Interrupt Bit */
#define TOFF_I2C_CLR_RD_REQ     0x0050		/* (R)  Interrupt Read Request Register */
#define TOFF_I2C_CLR_TX_ABRT    0x0054		/* (R)  Tx Abort Interrupt Register */
#define TOFF_I2C_CLR_RX_DONE    0x0058		/* (R)  Rx Done Interrupt Register */
#define TOFF_I2C_CLR_ACTIVITY   0x005C		/* (R)  Activity Interrupt Register */
#define TOFF_I2C_CLR_STOP_DET   0x0060		/* (R)  Stop Detect Interrupt Register */
#define TOFF_I2C_CLR_START_DET  0x0064		/* (R)  Start Detect Interrupt Register */
#define TOFF_I2C_CLR_GEN_CALL   0x0068		/* (R)  GEN CALL Interrupt Register */
#define TOFF_I2C_EN             0x006C		/* (RW) Enable Register */
  #define I2C_EN_EN_SET            0x00000001	/* Enable Bit */
  #define I2C_EN_TXABT_SET         0x00000002	/* TX abort Bit */
#define TOFF_I2C_STAT           0x0070		/* (R)  Status Register */
  #define I2C_STAT_ACTIVITY        0x00000001	/* Activity Status Bit */
  #define I2C_STAT_TFNF            0x00000002	/* TX FIFO Not Full Bit */
  #define I2C_STAT_TFE             0x00000004	/* TX FIFO Empty Bit */
  #define I2C_STAT_RFNE            0x00000008	/* RX FIFO Empty Bit */
  #define I2C_STAT_RFF             0x00000010	/* RX FIFO Full Bit */
  #define I2C_STAT_MST_ACTIVITY    0x00000020	/* Master FSM Activity Status Bit */
  #define I2C_STAT_SLV_ACTIVITY    0x00000040	/*  Slave FSM Activity Status Bit */
#define TOFF_I2C_TXFLR          0x0074		/* (R)  Transmit FIFO Level Register */
  #define I2C_TXFLR_MSK           0x0000007f	/* Transmit FIFO Level Bit */
#define TOFF_I2C_RXFLR          0x0078		/* (R)  Receive FIFO Level Register */
  #define I2C_RXFLR_MSK           0x0000007f	/* Receive FIFO Level Bit */
#define TOFF_I2C_SDA_HOLD       0x007C		/* (RW) SDA Hold Register */
  #define I2C_SDA_HOLD_IC_SDA      0x0000ffff	/* SDA Hold Bit */
#define TOFF_I2C_TX_ABRT_SRC    0x0080		/* (RW) Transmit Abort Source Register */
#define TOFF_I2C_SLV_DATA_NACK  0x0084		/* (RW) Generate Slave Data NACK */
  #define I2C_SLV_DATA_NACK_ONLY   0x00000001	/* Generate Nack Bit */
#define TOFF_I2C_DMA_CR         0x0088		/* (RW) DMA Control */
  #define I2C_DMA_CR_RDMAE         0x00000001	/* Receive DMA Enable Bit */
  #define I2C_DMA_CR_TDMAE         0x00000002	/* Transmit DMA Enable Bit */
#define TOFF_I2C_DMA_TDLR       0x008C		/* (RW) DMA Transmit Data Level */
#define TOFF_I2C_DMA_RDLR       0x0090		/* (RW) DMA Receive Data Level */
#define TOFF_I2C_SDA_SETUP      0x0094		/* (RW) SDA Setup Register */
#define TOFF_I2C_ACK_GENERAL_CALL 0x0098	/* (RW) ACK General Call */
#define TOFF_I2C_EN_STAT        0x009C		/* (R)  Enable Status Register */
#define TOFF_I2C_FS_SPKLEN      0x00A0		/* (RW) SS and FS Spike Suppression Limit Register */
  #define I2C_FS_SPKLEN_MSK        0x000000ff	/* Spike Suppression Limit Register */
#define TOFF_I2C_COMP_PARAM_1   0x00F4		/* (R)  Component Parameter Register 1 */
#define TOFF_I2C_COMP_VER       0x00F8		/* (R)  Component Version Register */
#define TOFF_I2C_COMP_TYPE      0x00FC		/* (R)  Component Type Register */

/*
 *  L4 WATCHDOG TIMER
 */
#define TADR_L4WD0_BASE         (PERIPH_BASE + 0x902000)
#define TADR_L4WD1_BASE         (PERIPH_BASE + 0x903000)
#define TOFF_L4WD_CR                0x0000		/* RW) Control Register */
  #define L4WD_CR_WDT_EN                        0x00000001	/* Enable */
  #define L4WD_CR_RMOD                          0x00000002	/* Response Mode */
#define TOFF_L4WD_TORR              0x0004		/* (RW) Timeout Range Register */
  #define L4WD_TORR_TOP                         0x0000000f	/* Timeout Period */
  #define L4WD_TORR_TOP_INIT                    0x000000f0	/* Timeout Period for Initialization */
#define TOFF_L4WD_CCVR              0x0008		/* (R)  Current Counter Value Register */
#define TOFF_L4WD_CRR               0x000c		/* (W)  Counter Restart Register */
  #define L4WD_CRR_WDT_CRR                      0x000000ff	/* Counter Restart Register */
#define TOFF_L4WD_STAT              0x0010		/* (R)  Interrupt Status Register. */
  #define L4WD_STAT_WDT_STAT                    0x00000001	/* Interrupt Status */
#define TOFF_L4WD_EOI               0x0014		/* (R)  Interrupt Clear Register */
#define TOFF_L4WD_CP_WDT_USER_TOP_MAX   0x00e4	/* (R)  Component Parameters Register 5 */
  #define L4WD_EOI_WDT_EOI                      0x00000001	/* Interrupt Clear */
#define TOFF_L4WD_CP_WDT_USER_TOP_INIT_MAX  0x00e8	/* (R)  Component Parameters Register 4 */
#define TOFF_L4WD_CD_WDT_TOP_RST    0x00ec		/* (R)  Component Parameters Register 3 */
#define TOFF_L4WD_CP_WDT_CNT_RST    0x00f0		/* (R)  Component Parameters Register 2 */
#define TOFF_L4WD_COMP_PARAM_1      0x00f4		/* (R)  Component Parameters Register 1 */
  #define L4WD_COMP_PARAM_1_CP_WDT_ALWAYS_EN    0x00000001	/* Always Enable */
  #define L4WD_COMP_PARAM_1_CP_WDT_DFLT_RMOD    0x00000002	/* Default Mode */
  #define L4WD_COMP_PARAM_1_CP_WDT_DUAL_TOP     0x00000004	/* Dual Timeout Period */
  #define L4WD_COMP_PARAM_1_CP_WDT_HC_RMOD      0x00000008	/* Hardcode Response Mode */
  #define L4WD_COMP_PARAM_1_CP_WDT_HC_RPL       0x00000010	/* Hardcode Reset Pulse Length */
  #define L4WD_COMP_PARAM_1_CP_WDT_HC_TOP       0x00000020	/* Hardcode Timeout Period */
  #define L4WD_COMP_PARAM_1_CP_WDT_USE_FIX_TOP  0x00000040	/* Use Pre-defined (Fixed) Timeout Values */
  #define L4WD_COMP_PARAM_1_CP_WDT_PAUSE        0x00000080	/* Include Pause Input */
  #define L4WD_COMP_PARAM_1_CP_WDT_APB_DATA_WIDTH 0x00000300 /* APB Data Width */
  #define L4WD_COMP_PARAM_1_CP_WDT_DFLT_RPL     0x00001c00	/* Default Reset Pulse Length */
  #define L4WD_COMP_PARAM_1_CP_WDT_DFLT_TOP     0x000f0000	/* Default Timeout Period */
  #define L4WD_COMP_PARAM_1_CP_WDT_DFLT_TOP_INIT 0x00f00000	/* Default Initial Timeout Period */
  #define L4WD_COMP_PARAM_1_CP_WDT_CNT_WIDTH    0x1f000000	/* Counter Width in Bits */

#define TOFF_L4WD_COMP_VER          0x00f8		/* (R)  Component Version */
#define TOFF_L4WD_COMP_TYPE         0x00fc		/* (R)  Component Type Register */



/*
 *  CLOCK MANAGER
 */
#define TADR_CLKMGR_MGR_BASE    (PERIPH_BASE + 0x904000)
#define TOFF_CLKMGR_CTL                   0x0000	/* (RW) Clock Manager Module */
  #define CLKMGR_CTL_SAFEMOD       0x00000001	/* Safe Mode */
  #define CLKMGR_CTL_ENSFMDWR      0x00000004	/* Enable SafeMode on Warm Reset */
#define TOFF_CLKMGR_BYPASS                0x0004	/* (RW) PLL Bypass Register */
  #define CLKMGR_BYPASS_MAINPLL    0x00000001	/* Main PLL Bypass */
  #define CLKMGR_BYPASS_SDRPLL     0x00000002	/* SDRAM PLL Bypass */
  #define CLKMGR_BYPASS_SDRPLLSRC  0x00000004	/* SDRAM PLL Bypass Source */
  #define CLKMGR_BYPASS_PERPLL     0x00000008	/* Peripheral PLL Bypass */
  #define CLKMGR_BYPASS_PERPLLSRC  0x00000010	/* Peripheral PLL Bypass Source */
#define TOFF_CLKMGR_INTER                 0x0008	/* (RW) Interrupt Status Register */
  #define CLKMGR_INTER_MAINPLLACHIEVED  0x00000001	/* Main PLL Achieved Lock */
  #define CLKMGR_INTER_PERPLLACHIEVED   0x00000002	/* Peripheral PLL Achieved Lock */
  #define CLKMGR_INTER_SDRPLLACHIEVED   0x00000004	/* SDRAM PLL Achieved Lock */
  #define CLKMGR_INTER_MAINPLLLOSTK     0x00000008	/* Main PLL Lost Lock */
  #define CLKMGR_INTER_PERPLLLOST       0x00000010	/* Peripheral PLL Lost Lock */
  #define CLKMGR_INTER_SDRPLLLOST       0x00000020	/* SDRAM PLL Lost Lock */
  #define CLKMGR_INTER_MAINPLLLOCKED    0x00000040	/* Main PLL Current Lock Status */
  #define CLKMGR_INTER_PERPLLLOCKED     0x00000080	/* Peripheral PLL Current Lock Status */
  #define CLKMGR_INTER_SDRPLLLOCKED     0x00000100	/* SDRAM PLL Current Lock Status */
#define TOFF_CLKMGR_INTREN                0x000C	/* (RW) Interrupt Enable Register */
  #define CLKMGR_INTREN_MAINPLLACHIEVED 0x00000001	/* Main PLL Achieved Lock Interrupt Enable */
  #define CLKMGR_INTREN_PERPLLACHIEVED  0x00000002	/* Peripheral PLL Achieved Lock Interrupt Enable */
  #define CLKMGR_INTREN_SDRPLLACHIEVED  0x00000004	/* SDRAM PLL Achieved Lock Interrupt Enable */
  #define CLKMGR_INTREN_MAINPLLLOST     0x00000008	/* Main PLL Achieved Lock Interrupt Enable */
  #define CLKMGR_INTREN_PERPLLLOST      0x00000010	/* Peripheral PLL Achieved Lock Interrupt Enable */
  #define CLKMGR_INTREN_SDRPLLLOST      0x00000020	/* SDRAM PLL Achieved Lock Interrupt Enable */
#define TOFF_CLKMGR_DBCTL                 0x0010	/* (RW) Debug clock Control Register */
  #define CLKMGR_DBCTL_STAYOSC1    0x00000001	/* Debug Clocks Stay on EOSC1_CLK */
  #define CLKMGR_DBCTL_ENSFMDWR    0x00000002	/* Debug Clocks Enable Safe Mode */
#define TOFF_CLKMGR_STAT                  0x0014	/* (R)  Status Register */
  #define CLKMGR_STAT_BUSY         0x00000001	/* HW Managed Clocks BUSY */

#define TADR_CLKMGR_MPLL_BASE   (PERIPH_BASE + 0x904040)
#define TOFF_CLKMGR_MPLL_VCO              0x0000	/* (RW) Main PLL VCO Control Register */
  #define CLKMGR_MPLL_VCO_BGPWRDN    0x00000001	/* BG PWRDN */
  #define CLKMGR_MPLL_VCO_EN    0x00000002	/* Enable */
  #define CLKMGR_MPLL_VCO_PWRDN 0x00000004	/* Power down */
  #define CLKMGR_MPLL_VCO_NUMER 0x0000FFF8	/* Numerator (M) */
  #define CLKMGR_MPLL_VCO_DENOM 0x003F0000	/* Denominator (N) */
  #define CLKMGR_MPLL_VCO_OUTRSTALL  0x01000000	/* All Output Counter Reset */
  #define CLKMGR_MPLL_VCO_OUTRST     0x7E000000	/* Output Counter Reset */
  #define CLKMGR_MPLL_VCO_REGEXTSEL  0x80000000	/* External Regulator Input Select */
#define TOFF_CLKMGR_MPLL_MISC             0x0004	/* (RW) Main PLL VCO Advanced Control Register */
  #define CLKMGR_MPLL_MISC_BWADJEN   0x00000001	/* Loop Bandwidth Adjust Enabled */
  #define CLKMGR_MPLL_MISC_BWADJ     0x00001FFE	/* Loop Bandwidth Adjust */
  #define CLKMGR_MPLL_MISC_FASTEN    0x00002000	/* Fast Locking Enable */
  #define CLKMGR_MPLL_MISC_SATEN     0x00004000	/* Saturation Enable */
#define TOFF_CLKMGR_MPLL_MPUCLK           0x0008	/* (RW) Main PLL C0 Control Register for Clock mpu_clk */
  #define CLKMGR_MPLL_MPUCLK_CNT     0x000001FF	/* Counter */
#define TOFF_CLKMGR_MPLL_MAINCLK          0x000C	/* (RW) Main PLL C1 Control Register for Clock main_clk */
  #define CLKMGR_MPLL_MAINCLK_CNT    0x000001FF	/* Counter */
#define TOFF_CLKMGR_MPLL_DBGATCLK         0x0010	/* (RW) Main PLL C2 Control Register for Clock dbg_base_clk */
  #define CLKMGR_MPLL_DBGATCLK_CNT   0x000001FF	/* Counter */
#define TOFF_CLKMGR_MPLL_MAINQSPICLK      0x0014	/* (RW) Main PLL C3 Control Register for Clock main_qspi_clk */
  #define CLKMGR_MPLL_MAINQSPICLK_CNT 0x000001FF	/* Counter */
#define TOFF_CLKMGR_MPLL_MAINNANDSDMMCCLK 0x0018	/* (RW) Main PLL C4 Control Register for Clock main_nand_sdmmc_clk */
  #define CLKMGR_MPLL_MAINNANDSDMMCCLK_CNT 0x000001FF	/* Counter */
#define TOFF_CLKMGR_MPLL_CFGS2FUSER0CLK   0x001C	/* (RW) Main PLL C5 Control Register for Clock cfg_s2f_user0_clk */
  #define CLKMGR_MPLL_CFGS2FUSER0CLK_CNT   0x000001FF	/* Counter */
#define TOFF_CLKMGR_MPLL_EN               0x0020	/* (RW) Enable Register */
  #define CLKMGR_MPLL_EN_L4MAINCLK   0x00000001	/* l4_main_clk Enable */
  #define CLKMGR_MPLL_EN_L3MPCLK     0x00000002	/* l3_mp_clk Enable */
  #define CLKMGR_MPLL_EN_L4MPCLK     0x00000004	/* l4_mp_clk Enable */
  #define CLKMGR_MPLL_EN_L4SPCLK     0x00000008	/* l4_sp_clk Enable */
  #define CLKMGR_MPLL_EN_DBGATCLK    0x00000010	/* dbg_at_clk Enable */
  #define CLKMGR_MPLL_EN_DBGCLK      0x00000020	/* dbg_clk Enable */
  #define CLKMGR_MPLL_EN_DBGTRACECLK 0x00000040	/* dbg_trace_clk Enable */
  #define CLKMGR_MPLL_EN_DBGTMRCLK   0x00000080	/* dbg_timer_clk Enable */
  #define CLKMGR_MPLL_EN_CFGCLK      0x00000100	/* cfg_clk Enable */
  #define CLKMGR_MPLL_EN_S2FUSER0CLK 0x00000200	/* s2f_user0_clk Enable */
#define TOFF_CLKMGR_MPLL_MAINDIV          0x0024	/* (RW) Main Divide Register */
  #define CLKMGR_MPLL_MDV_L3MPCLK    0x00000003	/* L3 MP Clock Divider */
  #define CLKMGR_MPLL_MDV_L3SPCLK    0x0000000C	/* L3 SP Clock Divider */
  #define CLKMGR_MPLL_MDV_L4MPCLK    0x00000070	/* L4 MP Clock Divider */
  #define CLKMGR_MPLL_MDV_L4SPCLK 0x00000380	/* L4 SP Clock Divider */
#define TOFF_CLKMGR_MPLL_DBGDIV           0x0028	/* (RW) Debug Divide Register */
  #define CLKMGR_MPLL_DBGDIV_DBGATCLK 0x00000003	/* Debug AT Clock Divider */
  #define CLKMGR_MPLL_DBGDIV_DBGCLK   0x0000000C	/* Debug Clock Divider */
#define TOFF_CLKMGR_MPLL_TRACEDIV         0x002C	/* (RW) Trace Divide Register */
  #define CLKMGR_MPLL_TRACEDIV_TRACECLK 0x00000007	/* Debug Trace Divide Register */
#define TOFF_CLKMGR_MPLL_L4SRC            0x0030	/* (RW) L4 MP SP APB Clock Source */
  #define CLKMGR_MPLL_L4SRC_L4MP     0x00000001		/* l4_mp_clk Source */
  #define CLKMGR_MPLL_L4SRC_L4SP     0x00000002		/* l4_sp_clk Source */
#define TOFF_CLKMGR_MPLL_STAT             0x0034	/* (R)  Main PLL Output Counter Reset Ack Status Register */
  #define CLKMGR_MPLL_STAT_OUTRSTACK  0x0000003F	/* Output Counter Reset Acknowledge */

#define TADR_CLKMGR_PERPLL_BASE (PERIPH_BASE + 0x904080)
#define TOFF_CLKMGR_PERPLL_VCO            0x0000	/* (RW) Peripheral PLL VCO Control Register */
  #define CLKMGR_PERPLL_VCO_BGPWRDN    0x00000001	/* BG PWRDN */
  #define CLKMGR_PERPLL_VCO_EN         0x00000002	/* Enable */
  #define CLKMGR_PERPLL_VCO_PWRDN      0x00000004	/* Power down */
  #define CLKMGR_PERPLL_VCO_NUMER      0x0000FFF8	/* Numerator (M) */
  #define CLKMGR_PERPLL_VCO_DENOM      0x003F0000	/* Denominator (N) */
  #define CLKMGR_PERPLL_VCO_PSRC       0x00C00000	/* Clock Source */
  #define CLKMGR_PERPLL_VCO_OUTRSTALL  0x01000000	/* All Output Counter Reset */
  #define CLKMGR_PERPLL_VCO_OUTRST     0x7E000000	/* Output Counter Reset */
  #define CLKMGR_PERPLL_VCO_REGEXTSEL  0x80000000	/* External Regulator Input Select */
#define TOFF_CLKMGR_PERPLL_MISC           0x0004	/* (RW) Peripheral PLL VCO Advanced Control Register */
  #define CLKMGR_PERPLL_MISC_BWADJEN   0x00000001	/* Loop Bandwidth Adjust Enabled */
  #define CLKMGR_PERPLL_MISC_BWADJ     0x00001FFE	/* Loop Bandwidth Adjust */
  #define CLKMGR_PERPLL_MISC_FASTEN    0x00002000	/* Fast Locking Enable */
  #define CLKMGR_PERPLL_MISC_SATEN     0x00004000	/* Saturation Enable */
#define TOFF_CLKMGR_PERPLL_EMAC0CLK       0x0008	/* (RW) Peripheral PLL C0 Control Register for Clock emac0_clk */
  #define CLKMGR_PERPLL_EMAC0CLK_CNT   0x000001FF	/* Counter */
#define TOFF_CLKMGR_PERPLL_EMAC1CLK       0x000C	/* (RW) Peripheral PLL C1 Control Register for Clock emac1_clk */
  #define CLKMGR_PERPLL_EMAC1CLK_CNT   0x000001FF	/* Counter */
#define TOFF_CLKMGR_PERPLL_PERQSPICLK     0x0010	/* (RW) Peripheral PLL C2 Control Register for Clock periph_qspi_clk */
  #define CLKMGR_PERPLL_PERQSPICLK_CNT 0x000001FF	/* Counter */
#define TOFF_CLKMGR_PERPLL_PERNANDSDMMCCLK 0x0014	/* (RW) Peripheral PLL C3 Control Register for Clock periph_nand_sdmmc_clk */
  #define CLKMGR_PERPLL_PERNANDSDMMCCLK_CNT 0x000001FF	/* Counter */
#define TOFF_CLKMGR_PERPLL_PERBASECLK     0x0018	/* (RW) Peripheral PLL C4 Control Register for Clock periph_base_clk */
  #define CLKMGR_PERPLL_PERBASECLK_CNT 0x000001FF	/* Counter */
#define TOFF_CLKMGR_PERPLL_S2FUSER        0x001C	/* (RW) eripheral PLL C5 Control Register for Clock s2f_user1_clk */
  #define CLKMGR_PERPLL_S2FUSER1CLK_CNT 0x000001FF	/* Counter */
#define TOFF_CLKMGR_PERPLL_EN             0x0020	/* (RW) Enable Register */
  #define CLKMGR_PERPLL_EN_EMAC0CLK    0x00000001	/* emac0_clk Enable */
  #define CLKMGR_PERPLL_EN_EMAC1CLK    0x00000002	/* emac1_clk Enable */
  #define CLKMGR_PERPLL_EN_USBCLK      0x00000004	/* usb_mp_clk Enable */
  #define CLKMGR_PERPLL_EN_SPIMCLK     0x00000008	/* spi_m_clk Enable */
  #define CLKMGR_PERPLL_EN_CAN0CLK     0x00000010	/* can0_clk Enable */
  #define CLKMGR_PERPLL_EN_CAN1CLK     0x00000020	/* can1_clk Enable */
  #define CLKMGR_PERPLL_EN_GPIOCLK     0x00000040	/* gpio_clk Enable */
  #define CLKMGR_PERPLL_EN_S2FUSER1CLK 0x00000080	/* s2f_user1_clk Enable */
  #define CLKMGR_PERPLL_EN_SDMMCCLK    0x00000100	/* sdmmc_clk Enable */
  #define CLKMGR_PERPLL_EN_NANDXCLK    0x00000200	/* nand_x_clk Enable */
  #define CLKMGR_PERPLL_EN_NANDCLK     0x00000400	/* nand_clk Enable */
  #define CLKMGR_PERPLL_EN_QSPICLK     0x00000800	/* qspi_clk Enable */
#define TOFF_CLKMGR_PERPLL_DIV            0x0024	/* (RW) Divide Register */
  #define CLKMGR_PERPLL_DIV_USBCLK     0x00000007	/* USB Clock Divider */
  #define CLKMGR_PERPLL_DIV_SPIMCLK    0x00000038	/* SPI Master Clock Divider */
  #define CLKMGR_PERPLL_DIV_CAN0CLK    0x000001C0	/* CAN0 Clock Divider */
  #define CLKMGR_PERPLL_DIV_CAN1CLK    0x00000E00	/* CAN1 Clock Divider */
#define TOFF_CLKMGR_PERPLL_GPIODIV        0x0028	/* (RW) GPIO Divide Register */
  #define CLKMGR_PERPLL_GPIODIV_GPIODBCLK 0x00FFFFFF	/* GPIO De-bounce Clock Divider */
#define TOFF_CLKMGR_PERPLL_SRC            0x002C	/* (RW) Flash Clock Source Register */
  #define CLKMGR_PERPLL_SRC_SDMMC      0x00000003	/* SDMMC Clock Source */
  #define CLKMGR_PERPLL_SRC_NAND       0x0000000C	/* NAND Clock Source */
  #define CLKMGR_PERPLL_SRC_QSPI       0x00000030	/* QSPI Clock Source */
#define TOFF_CLKMGR_PERPLL_STAT           0x0030	/* (R)  Peripheral PLL Output Counter Reset Ack Status Register */
  #define CLKMGR_PERPLL_STAT_OUTRSTACK 0x0000003F	/* Output Counter Reset Acknowledge */


#define TADR_CLKMGR_PPLL_BASE   (PERIPH_BASE + 0x9040C0)
#define TOFF_CLKMGR_SDRPLL_VCO            0x0000	/* (RW) SDRAM PLL VCO Control Register */
  #define CLKMGR_SDRPLL_VCO_BGPWRDN    0x00000001	/* BG PWRDN */
  #define CLKMGR_SDRPLL_VCO_EN         0x00000002	/* Enable */
  #define CLKMGR_SDRPLL_VCO_PWRDN      0x00000004	/* Power down */
  #define CLKMGR_SDRPLL_VCO_NUMER      0x0000FFF8	/* Numerator (M) */
  #define CLKMGR_SDRPLL_VCO_DENOM      0x003F0000	/* Denominator (N) */
  #define CLKMGR_SDRPLL_VCO_SSRC       0x00C00000	/* Clock Source */
  #define CLKMGR_SDRPLL_VCO_OUTRSTALL  0x01000000	/* SDRAM All Output Counter Reset */
  #define CLKMGR_SDRPLL_VCO_OUTRST     0x7E000000	/* Output Counter Reset */
  #define CLKMGR_SDRPLL_VCO_REGEXTSEL  0x80000000	/* External Regulator Input Select */
#define TOFF_CLKMGR_SDRPLL_CTL            0x0004	/* (RW) SDRAM PLL VCO Advanced Control Register */
  #define CLKMGR_SDRPLL_CTL_BWADJEN    0x00000001	/* Loop Bandwidth Adjust Enabled */
  #define CLKMGR_SDRPLL_CTL_BWADJ      0x00001FFE	/* Loop Bandwidth Adjust */
  #define CLKMGR_SDRPLL_CTL_FASTEN     0x00002000	/* Fast Locking Enable */
  #define CLKMGR_SDRPLL_CTL_SATEN      0x00004000	/* Saturation Enable */
#define TOFF_CLKMGR_SDRPLL_DDRDQSCLK      0x0008	/* (RW) SDRAM PLL C0 Control Register for Clock ddr_dqs_clk */
  #define CLKMGR_SDRPLL_DDRDQSCLK_CNT  0x000001FF	/* Counter */
  #define CLKMGR_SDRPLL_DDRDQSCLK_PHASE 0x001FFE00	/* Phase Shift */
#define TOFF_CLKMGR_SDRPLL_DDR2XDQSCLK    0x000C	/* (RW) SDRAM PLL C1 Control Register for Clock ddr_2x_dqs_clk */
  #define CLKMGR_SDRPLL_DDR2XDQSCLK_CNT 0x000001FF	/* Counter */
  #define CLKMGR_SDRPLL_DDR2XDQSCLK_PHASE 0x001FFE00	/* Phase Shift */
#define TOFF_CLKMGR_SDRPLL_DDRDQCLK       0x0010	/* (RW) SDRAM PLL C2 Control Register for Clock ddr_dq_clk */
  #define CLKMGR_SDRPLL_DDRDQCLK_CNT   0x000001FF	/* Counter */
  #define CLKMGR_SDRPLL_DDRDQCLK_PHASE 0x001FFE00	/* Phase Shift */
#define TOFF_CLKMGR_SDRPLL_S2FUSER2CLK    0x0014	/* (RW) SDRAM PLL C5 Control Register for Clock s2f_user2_clk */
  #define CLKMGR_SDRPLL_S2FUSER2CLK_CNT   0x000001FF	/* Counter */
  #define CLKMGR_SDRPLL_S2FUSER2CLK_PHASE 0x001FFE00	/* Phase Shift */
#define TOFF_CLKMGR_SDRPLL_EN             0x0018	/* (RW) Enable Register */
  #define CLKMGR_SDRPLL_EN_DDRDQSCLK   0x00000001	/* ddr_dqs_clk Enable */
  #define CLKMGR_SDRPLL_EN_DDR2XDQSCLK 0x00000002	/* ddr_2x_dqs_clk Enable */
  #define CLKMGR_SDRPLL_EN_DDRDQCLK    0x00000004	/* ddr_dq_clk Enable */
  #define CLKMGR_SDRPLL_EN_S2FUSER2CLK 0x00000008	/* s2f_user2_clk Enable */
#define TOFF_CLKMGR_SDRPLL_STAT           0x001C	/* (R)  SDRAM PLL Output Counter Reset Ack Status Register */
  #define CLKMGR_SDRPLL_STAT_OUTRSTACK 0x0000003F	/* Output Counter Reset Acknowledge */

#define TADR_CLKMGR_MISC_MAINCLK_BASE (PERIPH_BASE + 0x9040E0)
#define TOFF_CLKMGR_MISC_MPUCLK           0x0000	/* (RW) Main PLL C0 Control Register  */
  #define CLKMGR_MISC_MPUCLK_CNT   0x000001FF	/* Counter */

#define TOFF_CLKMGR_MISC_MAINCLK          0x0004	/* (RW) Main PLL C1 Control Register */
  #define CLKMGR_MISC_MAINCLK_CNT  0x000001FF	/* Couner */
#define TOFF_CLKMGR_MISC_DBGATCLK         0x0008	/* (RW) Main PLL C2 Control Register */
  #define CLKMGR_MISC_DBGATCLK_CNT 0x000001FF	/* Counter */

/*
 *  RESET MANAGER
 */
#define TADR_RSTMGR_BASE        (PERIPH_BASE + 0x905000)
#define TOFF_RSTMGR_STAT        0x0000
  #define RSTMGR_STAT_PORVOLTRST       0x00000001	/* Power-On Voltage Detector Cold Reset */
  #define RSTMGR_STAT_NPORPINRST       0x00000002	/* nPOR Pin Cold Reset */
  #define RSTMGR_STAT_FPGACOLDRST      0x00000004	/* FPGA Core Cold Reset */
  #define RSTMGR_STAT_CFGIOCOLDRST     0x00000008	/* CONFIG_IO Cold Reset */
  #define RSTMGR_STAT_SWCOLDRST        0x00000010	/* Software Cold Reset */
  #define RSTMGR_STAT_NRSTPINRST       0x00000100	/* nRST Pin Warm Reset */
  #define RSTMGR_STAT_FPGAWARMRST      0x00000200	/* FPGA Core Warm Reset */
  #define RSTMGR_STAT_SWWARMRST        0x00000400	/* Software Warm Reset */
  #define RSTMGR_STAT_MPUWD0RST        0x00001000	/* MPU Watchdog 0 Warm Reset */
  #define RSTMGR_STAT_MPUWD1RST        0x00002000	/* MPU Watchdog 1 Warm Reset */
  #define RSTMGR_STAT_L4WD0RST         0x00004000	/* L4 Watchdog 0 Warm Reset */
  #define RSTMGR_STAT_L4WD1RST         0x00008000	/* L4 Watchdog 1 Warm Reset */
  #define RSTMGR_STAT_FPGADBGRST       0x00040000	/* FPGA Core Debug Reset */
  #define RSTMGR_STAT_CDBGREQRST       0x00080000	/* DAP Debug Reset */
  #define RSTMGR_STAT_SDRSELFREFTMO    0x01000000	/* SDRAM Self-Refresh Timeout */
  #define RSTMGR_STAT_FPGAMGRHSTMO     0x02000000	/* FPGA manager handshake Timeout */
  #define RSTMGR_STAT_SCANHSTMO        0x04000000	/* SCAN manager handshake Timeout */
  #define RSTMGR_STAT_FPGAHSTMO        0x08000000	/* FPGA handshake Timeout */
  #define RSTMGR_STAT_ETRSTALLTMO      0x10000000	/* ETR Stall Timeout */
#define TOFF_RSTMGR_CTL         0x0004			/* (RW) Control Register */
  #define RSTMGR_CTL_SWCOLDRSTREQ      0x00000001	/* Software Cold Reset Request */
  #define RSTMGR_CTL_SWWARMRSTREQ      0x00000002	/* Software Warm Reset Request */
  #define RSTMGR_CTL_SDRSELFREFEN      0x00000010	/* SDRAM Self-Refresh Enable */
  #define RSTMGR_CTL_SDRSELFREFREQ     0x00000020	/* SDRAM Self-Refresh Request */
  #define RSTMGR_CTL_SDRSELFREQACK     0x00000040	/* SDRAM Self-Refresh Acknowledge */
  #define RSTMGR_CTL_FPGAMGRHSEN       0x00000100	/* FPGA Manager Handshake Enable */
  #define RSTMGR_CTL_FPGAMGRHSREQ      0x00000200	/* FPGA Manager Handshake Request */
  #define RSTMGR_CTL_FPGAMGRHSACK      0x00000400	/* FPGA Manager Handshake Acknowledge */
  #define RSTMGR_CTL_SCANMGRHSEN       0x00001000	/* SCAN Manager Handshake Enable */
  #define RSTMGR_CTL_SCANMGRHSREQ      0x00002000	/* SCAN Manager Handshake Request */
  #define RSTMGR_CTL_SCANMGRHSACK      0x00004000	/* SCAN Manager Handshake Acknowledge */
  #define RSTMGR_CTL_FPGAHSEN          0x00010000	/* FPGA Handshake Enable */
  #define RSTMGR_CTL_FPGAHSREQ         0x00020000	/* FPGA Handshake Request */
  #define RSTMGR_CTL_FPGAHSACK         0x00040000	/* FPGA Handshake Acknowledge */
  #define RSTMGR_CTL_ETRSTALLEN        0x00100000	/* ETR (Embedded Trace Router) Stall Enable */
  #define RSTMGR_CTL_ETRSTALLREQ       0x00200000	/* ETR (Embedded Trace Router) Stall Request */
  #define RSTMGR_CTL_ETRSTALLACK       0x00400000	/* ETR (Embedded Trace Router) Stall Acknowledge */
  #define RSTMGR_CTL_ETRSTALLWARMRST   0x00800000	/* ETR (Embedded Trace Router) Stall After Warm Reset */
#define TOFF_RSTMGR_COUNTS      0x0008		/* (RW) Reset Cycles Count Register */
  #define RSTMGR_COUNTS_WARMRSTCYCLES  0x000000ff	/* Warm reset release delay count */
  #define RSTMGR_COUNTS_NRSTCNT        0x0fffff00	/* nRST Pin Count */
#define TOFF_RSTMGR_MPUMODRST   0x0010
  #define RSTMGR_MPUMODRST_CPU0        0x00000001	/* CPU0 */
  #ifndef RSTMGR_MPUMODRST_CPU1
  #define RSTMGR_MPUMODRST_CPU1        0x00000002	/* CPU1 */
  #endif
  #define RSTMGR_MPUMODRST_WDS         0x00000004	/* Watchdogs */
  #define RSTMGR_MPUMODRST_SCUPER      0x00000008	/* SCU/Peripherals */
  #define RSTMGR_MPUMODRST_L2          0x00000010	/* L2 */
#define TOFF_RSTMGR_PERMODRST   0x0014		/* (RW) Peripheral Module Reset Register */
  #define RSTMGR_PERMODRST_EMAC0       0x00000001	/* EMAC0 */
  #define RSTMGR_PERMODRST_EMAC1       0x00000002	/* EMAC1 */
  #define RSTMGR_PERMODRST_USB0        0x00000004	/* USB0 */
  #define RSTMGR_PERMODRST_USB1        0x00000008	/* USB1 */
  #define RSTMGR_PERMODRST_NAND        0x00000010	/* NAND Flash */
  #define RSTMGR_PERMODRST_QSPI        0x00000020	/* QSPI Flash */
  #ifndef RSTMGR_PERMODRST_L4WD0
  #define RSTMGR_PERMODRST_L4WD0       0x00000040	/* L4 Watchdog 0 */
  #endif
  #define RSTMGR_PERMODRST_L4WD1       0x00000080	/* L4 Watchdog 1 */
  #define RSTMGR_PERMODRST_OSC1TMR0    0x00000100	/* OSC1 Timer 0 */
  #define RSTMGR_PERMODRST_OSC1TMR1    0x00000200	/* OSC1 Timer 1 */
  #define RSTMGR_PERMODRST_SPTMR0      0x00000400	/* SP Timer 0 */
  #define RSTMGR_PERMODRST_SPTMR1      0x00000800	/* SP Timer 1 */
  #define RSTMGR_PERMODRST_I2C0        0x00001000	/* I2C0 */
  #define RSTMGR_PERMODRST_I2C1        0x00002000	/* I2C1 */
  #define RSTMGR_PERMODRST_I2C2        0x00004000	/* I2C2 */
  #define RSTMGR_PERMODRST_I2C3        0x00008000	/* I2C3 */
  #define RSTMGR_PERMODRST_UART0       0x00010000	/* UART0 */
  #define RSTMGR_PERMODRST_UART1       0x00020000	/* UART1 */
  #define RSTMGR_PERMODRST_SPIM0       0x00040000	/* SPIM0 */
  #define RSTMGR_PERMODRST_SPIM1       0x00080000	/* SPIM1 */
  #define RSTMGR_PERMODRST_SPIS0       0x00100000	/* SPIS0 */
  #define RSTMGR_PERMODRST_SPIS1       0x00200000	/* SPIS1 */
  #define RSTMGR_PERMODRST_SDMMC       0x00400000	/* SD/MMC */
  #define RSTMGR_PERMODRST_CAN0        0x00800000	/* CAN0 */
  #define RSTMGR_PERMODRST_CAN1        0x01000000	/* CAN1 */
  #define RSTMGR_PERMODRST_GPIO0       0x02000000	/* GPIO0 */
  #define RSTMGR_PERMODRST_GPIO1       0x04000000	/* GPIO1 */
  #define RSTMGR_PERMODRST_GPIO2       0x08000000	/* GPIO2 */
  #define RSTMGR_PERMODRST_DMA         0x10000000	/* DMA Controller */
  #define RSTMGR_PERMODRST_SDR         0x20000000	/* SDRAM Controller Subsystem */
#define TOFF_RSTMGR_PER2MODRST  0x0018		/* (RW) Peripheral 2 Module Reset Register */
  #define RSTMGR_PER2MODRST_DMAIF0     0x00000001	/* FPGA DMA0 */
  #define RSTMGR_PER2MODRST_DMAIF1     0x00000002	/* FPGA DMA1 */
  #define RSTMGR_PER2MODRST_DMAIF2     0x00000004	/* FPGA DMA2 */
  #define RSTMGR_PER2MODRST_DMAIF3     0x00000008	/* FPGA DMA3 */
  #define RSTMGR_PER2MODRST_DMAIF4     0x00000010	/* FPGA DMA4 */
  #define RSTMGR_PER2MODRST_DMAIF5     0x00000020	/* FPGA DMA5 */
  #define RSTMGR_PER2MODRST_DMAIF6     0x00000040	/* FPGA DMA6 */
  #define RSTMGR_PER2MODRST_DMAIF7     0x00000080	/* FPGA DMA7 */
#define TOFF_RSTMGR_BRGMODRST   0x001C		/* (RW) Bridge Module Reset Register */
  #ifndef RSTMGR_BRGMODRST_H2F
  #define RSTMGR_BRGMODRST_H2F         0x00000001	/* HPS2FPGA Bridge */
  #endif
  #ifndef RSTMGR_BRGMODRST_LWH2F
  #define RSTMGR_BRGMODRST_LWH2F       0x00000002	/* LWHPS2FPGA Bridge */
  #endif
  #ifndef RSTMGR_BRGMODRST_F2H
  #define RSTMGR_BRGMODRST_F2H         0x00000004	/* FPGA2HPS Bridge */
  #endif
#define TOFF_RSTMGR_MISCMODRST  0x0020		/* (RW) Miscellaneous Module Reset Register */
  #define RSTMGR_MISCMODRST_ROM        0x00000001	/* Boot ROM */
  #define RSTMGR_MISCMODRST_OCRAM      0x00000002	/* On-chip RAM */
  #define RSTMGR_MISCMODRST_SYSMGR     0x00000004	/* System Manager (Cold or Warm) */
  #define RSTMGR_MISCMODRST_SYSMGRCOLD 0x00000008	/* System Manager (Cold-only) */
  #define RSTMGR_MISCMODRST_FPGAMGR    0x00000010	/* FPGA Manager */
  #define RSTMGR_MISCMODRST_ACPIDMAP   0x00000020	/* ACP ID Mapper */
  #define RSTMGR_MISCMODRST_S2F        0x00000040	/* HPS to FPGA Core (Cold or Warm) */
  #define RSTMGR_MISCMODRST_S2FCOLD    0x00000080	/* HPS to FPGA Core (Cold-only) */
  #define RSTMGR_MISCMODRST_NRSTPIN    0x00000100	/* nRST Pin */
  #define RSTMGR_MISCMODRST_TSCOLD     0x00000200	/* Timestamp */
  #define RSTMGR_MISCMODRST_CLKMGRCOLD 0x00000400	/* Clock Manager */
  #define RSTMGR_MISCMODRST_SCANMGR    0x00000800	/* Scan Manager */
  #define RSTMGR_MISCMODRST_FRZCTLCOLD 0x00001000	/* Freeze Controller */
  #define RSTMGR_MISCMODRST_SYSDBG     0x00002000	/* System/Debug */
  #define RSTMGR_MISCMODRST_DBG        0x00004000	/* Debug */
  #define RSTMGR_MISCMODRST_TAPCOLD    0x00008000	/* TAP Controller */
  #define RSTMGR_MISCMODRST_SDRCOLD    0x00010000	/* SDRAM Controller Subsystem Cold Reset */

/*
 *  SYSTEM MANAGER MODULE
 */
#define TADR_SYSMGR_BASE        (PERIPH_BASE + 0x908000)
#define TOFF_SYSMGR_SILICONID1              0x0000	/* (R)  Silicon ID1 Register */
#define TOFF_SYSMGR_SILICONID2              0x0004	/* (R)  Silicon ID2 Register */
#define TOFF_SYSMGR_WDDBG                   0x0010	/* (RW) L4 Watchdog Debug Register */
#define TOFF_SYSMGR_HPSINFO                 0x0018	/* (R)  Boot Info Register */
  #define SYSMGR_HPSINFO_DUALCORE           0x00000001	/* Dual Core */
  #define SYSMGR_HPSINFO_CAN                0x00000002	/* CAN */
#define TOFF_SYSMGR_PARITYINJ               0x001C	/* (RW) Parity Fail Injection Register */
#define TOFF_SYSMGR_FPGAINTF_GBL            0x0020	/* (RW) FPGA Interface Global Disable Register */
#define TOFF_SYSMGR_FPGAINTF_INDIV          0x0024	/* (RW) FPGA Interface Individual Disable Register */
#define TOFF_SYSMGR_FPGAINTF_MODULE         0x0028	/* (RW) FPGA Interface Module Disable Register */
#define TOFF_SYSMGR_SCANMGR_CTL             0x0030	/* (RW) Scan Manager Control Register */
#define TOFF_SYSMGR_FRZCTL_VIOCTL           0x0040	/* (RW) Freeze Control VIO Control Register */
#define TOFF_SYSMGR_FRZCTL_HIOCTL           0x0050	/* (RW) HIO Control Register */
#define TOFF_SYSMGR_FRZCTL_SRC              0x0054	/* (RW) Source Register */
#define TOFF_SYSMGR_FRZCTL_HWCTL            0x0058	/* (RW) Hardware Control Register */
#define TOFF_SYSMGR_EMAC_CTL                0x0060	/* (RW) EMAC Control Register */
#define TOFF_SYSMGR_EMAC_L3MST              0x0064	/* (RW) EMAC L3 Master AxCACHE Register */
#define TOFF_SYSMGR_DMA_CTL                 0x0070	/* (RW) DMA Controller Control Register */
  #define SYSMGR_DMA_CTL_CHANSEL_0          0x00000001	/* Channel Select 0 */
  #define SYSMGR_DMA_CTL_CHANSEL_1          0x00000002	/* Channel Select 1 */
  #define SYSMGR_DMA_CTL_CHANSEL_2          0x00000004	/* Channel Select 2 */
  #define SYSMGR_DMA_CTL_CHANSEL_3          0x00000008	/* Channel Select 3 */
  #define SYSMGR_DMA_CTL_MGRNONSECURE       0x00000010	/* Manager Thread Security */
  #define SYSMGR_DMA_CTL_IRQNONSECURE       0x00001FE0	/* IRQ Security */
#define TOFF_SYSMGR_DMA_PERSECURITY         0x0074	/* (RW) Peripheral Security Register */
#define TOFF_SYSMGR_ISW_HANDOFF             0x0080	/* (RW) Preloader to OS Handoff Information */

#define TOFF_SYSMGR_ROMCODE_CTL             0x00C0	/* (RW) Boot ROM Code Register Control Register */
#define TOFF_SYSMGR_ROMCODE_CPU1STARTADDR   0x00C4	/* (RW) CPU1 Start Address Register */
#define TOFF_SYSMGR_ROMCODE_INITSWSTATE     0x00C8	/* (RW) Preloader (initial software) State Register */
#define TOFF_SYSMGR_ROMCODE_INITSWLASTLD    0x00CC	/* (RW) Preloader (initial software) Last Image Loaded Register */
#define TOFF_SYSMGR_ROMCODE_BOOTROMSWSTATE  0x00D0	/* (RW) Boot ROM Software State Register */
#define TOFF_SYSMGR_ROMCODE_WARMRAM_EN      0x00E0	/* (RW) Enable Register */
#define TOFF_SYSMGR_ROMCODE_WARMRAM_DATASTART 0x0E4	/* (RW) Data Start Register */
#define TOFF_SYSMGR_ROMCODE_WARMRAM_LEN     0x00E8	/* (RW) Length Register */
#define TOFF_SYSMGR_ROMCODE_WARMRAM_EXECUTION 0x0EC	/* (RW) Execution Register */
#define TOFF_SYSMGR_ROMCODE_WARMRAM_CRC     0x00F0	/* (RW) Expected CRC Register */

#define TOFF_SYSMGR_ROMHW_CTL               0x0100	/* (RW) Boot ROM Hardware Control Register */
#define TOFF_SYSMGR_SDMMC_CTL               0x0108	/* (RW) SDMMC Control Register */
  #define SYSMGR_SDMMC_CTL_DRVSEL           0x00000007	/* Drive Clock Phase Shift Select */
  #define SYSMGR_SDMMC_CTL_DRVSEL_E_DEGREES0    0x00000000
  #define SYSMGR_SDMMC_CTL_DRVSEL_E_DEGREES45   0x00000001
  #define SYSMGR_SDMMC_CTL_DRVSEL_E_DEGREES90   0x00000002
  #define SYSMGR_SDMMC_CTL_DRVSEL_E_DEGREES135  0x00000003
  #define SYSMGR_SDMMC_CTL_DRVSEL_E_DEGREES180  0x00000004
  #define SYSMGR_SDMMC_CTL_DRVSEL_E_DEGREES225  0x00000005
  #define SYSMGR_SDMMC_CTL_DRVSEL_E_DEGREES270  0x00000006
  #define SYSMGR_SDMMC_CTL_DRVSEL_E_DEGREES315  0x00000007
  #define SYSMGR_SDMMC_CTL_SMPLSE           0x00000038	/* Sample Clock Phase Shift Select */
  #define SYSMGR_SDMMC_CTL_SMPLSEL_E_DEGREES0   0x00000000
  #define SYSMGR_SDMMC_CTL_SMPLSEL_E_DEGREES45  0x00000008
  #define SYSMGR_SDMMC_CTL_SMPLSEL_E_DEGREES90  0x00000010
  #define SYSMGR_SDMMC_CTL_SMPLSEL_E_DEGREES135 0x00000018
  #define SYSMGR_SDMMC_CTL_SMPLSEL_E_DEGREES180 0x00000020
  #define SYSMGR_SDMMC_CTL_SMPLSEL_E_DEGREES225 0x00000028
  #define SYSMGR_SDMMC_CTL_SMPLSEL_E_DEGREES270 0x00000030
  #define SYSMGR_SDMMC_CTL_SMPLSEL_E_DEGREES315 0x00000038
#define TOFF_SYSMGR_SDMMC_L3MST             0x010C	/* (RW) SD/MMC L3 Master HPROT Register */
#define TOFF_SYSMGR_NAND_BOOTSTRAP          0x0110	/* (RW) Bootstrap Control Register */
#define TOFF_SYSMGR_NAND_L3MST              0x0114	/* (RW) NAND L3 Master AxCACHE Register */
#define TOFF_SYSMGR_USB_L3MST               0x0118	/* (RW) USB L3 Master HPROT Register */

#define TOFF_SYSMGR_ECC_L2                  0x0140	/* (RW) L2 Data RAM ECC Enable Register */
#define TOFF_SYSMGR_ECC_OCRAM               0x0144	/* (RW) On-chip RAM ECC Enable Register */
#define TOFF_SYSMGR_ECC_USB0                0x0148	/* (RW) USB0 RAM ECC Enable Register */
#define TOFF_SYSMGR_ECC_USB1                0x014C	/* (RW) USB1 RAM ECC Enable Register */
#define TOFF_SYSMGR_ECC_EMAC0               0x0150	/* (RW) EMAC0 RAM ECC Enable Register */
#define TOFF_SYSMGR_ECC_EMAC1               0x0154	/* (RW) EMAC1 RAM ECC Enable Register */
#define TOFF_SYSMGR_ECC_DMA                 0x0158	/* (RW) DMA RAM ECC Enable Register */
#define TOFF_SYSMGR_ECC_CAN0                0x015C	/* (RW) CAN0 RAM ECC Enable Register */
#define TOFF_SYSMGR_ECC_CAN1                0x0160	/* (RW) CAN1 RAM ECC Enable Register */
#define TOFF_SYSMGR_ECC_NAND                0x0164	/* (RW) NAND RAM ECC Enable Register */
#define TOFF_SYSMGR_ECC_QSPI                0x0168	/* (RW) QSPI RAM ECC Enable Register */
#define TOFF_SYSMGR_ECC_SDMMC               0x016c	/* (RW) SDMMC RAM ECC Enable Register */

#define TOFF_SYSMGR_PINMUX_EMACIO0          0x0400	/* (RW) emac0_tx_clk Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO1          0x0404	/* (RW) emac0_tx_d0 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO2          0x0408	/* (RW) emac0_tx_d1 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO3          0x040C	/* (RW) emac0_tx_d2 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO4          0x0410	/* (RW) emac0_tx_d3 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO5          0x0414	/* (RW) emac0_rx_d0 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO6          0x0418	/* (RW) emac0_mdio Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO7          0x041C	/* (RW) emac0_mdc Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO8          0x0420	/* (RW) emac0_rx_ctl Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO9          0x0424	/* (RW) emac0_tx_ctl Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO10         0x0428	/* (RW) emac0_rx_clk Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO11         0x042C	/* (RW) emac0_rx_d1 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO12         0x0430	/* (RW) emac0_rx_d2 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO13         0x0434	/* (RW) emac0_rx_d3 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO14         0x0438	/* (RW) emac1_tx_clk Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO15         0x043C	/* (RW) emac1_tx_d0 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO16         0x0440	/* (RW) emac1_tx_d1 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO17         0x0444	/* (RW) emac1_tx_ctl Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO18         0x0448	/* (RW) emac1_rx_d0 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_EMACIO19         0x044C	/* (RW) emac1_rx_d1 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_FLSHIO0          0x0450	/* (RW) sdmmc_cmd Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_FLSHIO1          0x0454	/* (RW) sdmmc_pwren Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_FLSHIO2          0x0458	/* (RW) sdmmc_d0 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_FLSHIO3          0x045C	/* (RW) sdmmc_d1 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_FLSHIO4          0x0460	/* (RW) sdmmc_d4 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_FLSHIO5          0x0464	/* (RW) sdmmc_d5 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_FLSHIO6          0x0468	/* (RW) sdmmc_d6 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_FLSHIO7          0x046C	/* (RW) sdmmc_d7 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_FLSHIO8          0x0470	/* (RW) sdmmc_clk_in Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_FLSHIO9          0x0474	/* (RW) sdmmc_clk Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_FLSHIO10         0x0478	/* (RW) sdmmc_d2 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_FLSHIO11         0x047C	/* (RW) sdmmc_d3 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO0       0x0480	/* (RW) trace_clk Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO1       0x0484	/* (RW) trace_d0 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO2       0x0488 	/* (RW) trace_d1 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO3       0x048C 	/* (RW) trace_d2 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO4       0x0490	/* (RW) trace_d3 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO5       0x0494	/* (RW) trace_d4 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO6       0x0498	/* (RW) trace_d5 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO7       0x049C	/* (RW) trace_d6 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO8       0x04A0	/* (RW) trace_d7 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO9       0x04A4	/* (RW) spim0_clk Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO10      0x04A8	/* (RW) spim0_mosi Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO11      0x04AC	/* (RW) spim0_miso Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO12      0x04B0	/* (RW) spim0_ss0 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO13      0x04B4	/* (RW) uart1_rx Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO14      0x04B8	/* (RW) uart1_tx Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO15      0x04BC	/* (RW) i2c1_sda Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO16      0x04C0	/* (RW) i2c1_scl Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO17      0x04C4	/* (RW) can0_rx Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO18      0x04C8	/* (RW) spis0_clk Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO19      0x04CC	/* (RW) spis1_clk Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO20      0x04D0	/* (RW) spis1_mosi Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO21      0x04D4	/* (RW) spis1_miso Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO22      0x04D8	/* (RW) spis1_ss0 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO23      0x04DC	/* (RW) uart1_rx Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO24      0x04E0	/* (RW) uart1_tx Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO25      0x04E4	/* (RW) i2c1_sda Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO26      0x04E8	/* (RW) i2c1_scl Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO27      0x04EC	/* (RW) spim0_ss0_alt Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO28      0x04F0	/* (RW) spis0_clk Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO29      0x04F4	/* (RW) spis0_mosi Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO30      0x04F8	/* (RW) spis0_miso Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GENERALIO31      0x04FC	/* (RW) spis0_ss0 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO0        0x0500	/* (RW) nand_ale Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO1        0x0504	/* (RW) nand_ce Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO2        0x0508	/* (RW) nand_cle Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO3        0x050C	/* (RW) nand_re Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO4        0x0510	/* (RW) nand_rb Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO5        0x0514	/* (RW) nand_dq0 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO6        0x0518	/* (RW) nand_dq1 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO7        0x051C	/* (RW) nand_dq2 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO8        0x0520	/* (RW) nand_dq3 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO9        0x0524	/* (RW) nand_dq4 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO10       0x0528	/* (RW) nand_dq5 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO11       0x052C	/* (RW) nand_dq6 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO12       0x0530	/* (RW) nand_dq7 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO13       0x0534	/* (RW) nand_wp Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO14       0x0538	/* (RW) nand_we Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO15       0x053C	/* (RW) qspi_io0 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO16       0x0540	/* (RW) qspi_io1 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO17       0x0544	/* (RW) qspi_io2 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO18       0x0548	/* (RW) qspi_io3 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO19       0x054C	/* (RW) qspi_ss0 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO20       0x0550	/* (RW) qpsi_clk Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED1IO21       0x0554	/* (RW) qspi_ss1 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED2IO0        0x0558	/* (RW) emac1_mdio Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED2IO1        0x055C	/* (RW) emac1_mdc Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED2IO2        0x0560	/* (RW) emac1_tx_d2 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED2IO3        0x0564	/* (RW) emac1_tx_d3 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED2IO4        0x0568	/* (RW) emac1_rx_clk Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED2IO5        0x056C	/* (RW) emac1_rx_ctl Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED2IO6        0x0570	/* (RW) emac1_rx_d2 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_MIXED2IO7        0x0574	/* (RW) emac1_rx_d3 Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX48       0x0578	/* (RW) GPIO/LoanIO 48 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX49       0x057C	/* (RW) GPIO/LoanIO 49 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX50       0x0580	/* (RW) GPIO/LoanIO 50 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX51       0x0584	/* (RW) GPIO/LoanIO 51 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX52       0x0588	/* (RW) GPIO/LoanIO 52 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX53       0x058C	/* (RW) GPIO/LoanIO 53 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX54       0x0590	/* (RW) GPIO/LoanIO 54 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX55       0x0594	/* (RW) GPIO/LoanIO 55 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX56       0x0598	/* (RW) GPIO/LoanIO 56 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX57       0x059C	/* (RW) GPIO/LoanIO 57 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX58       0x05A0	/* (RW) GPIO/LoanIO 58 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX59       0x05A4	/* (RW) GPIO/LoanIO 59 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX60       0x05A8	/* (RW) GPIO/LoanIO 60 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX61       0x05AC	/* (RW) GPIO/LoanIO 61 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX62       0x05B0	/* (RW) GPIO/LoanIO 62 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX63       0x05B4	/* (RW) GPIO/LoanIO 63 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX64       0x05B8	/* (RW) GPIO/LoanIO 64 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX65       0x05BC	/* (RW) GPIO/LoanIO 65 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX66       0x05C0	/* (RW) GPIO/LoanIO 66 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX67       0x05C4	/* (RW) GPIO/LoanIO 67 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX68       0x05C8	/* (RW) GPIO/LoanIO 68 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX69       0x05CC	/* (RW) GPIO/LoanIO 69 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLINMUX70       0x05D0	/* (RW) GPIO/LoanIO 70 Input Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX0          0x05D4	/* (RW) GPIO/LoanIO 0 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX1          0x05D8	/* (RW) GPIO/LoanIO 1 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX2          0x05DC	/* (RW) GPIO/LoanIO 2 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX3          0x05E0	/* (RW) GPIO/LoanIO 3 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX4          0x05E4	/* (RW) GPIO/LoanIO 4 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX5          0x05E8	/* (RW) GPIO/LoanIO 5 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX6          0x05EC	/* (RW) GPIO/LoanIO 6 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX7          0x05F0	/* (RW) GPIO/LoanIO 7 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX8          0x05F4	/* (RW) GPIO/LoanIO 8 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX9          0x05F8	/* (RW) GPIO/LoanIO 9 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX10         0x05FC	/* (RW) GPIO/LoanIO 10 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX11         0x0600	/* (RW) GPIO/LoanIO 11 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX12         0x0604	/* (RW) GPIO/LoanIO 12 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX13         0x0608	/* (RW) GPIO/LoanIO 13 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX14         0x060C	/* (RW) GPIO/LoanIO 14 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX15         0x0610	/* (RW) GPIO/LoanIO 15 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX16         0x0614	/* (RW) GPIO/LoanIO 16 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX17         0x0618	/* (RW) GPIO/LoanIO 17 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX18         0x061C	/* (RW) GPIO/LoanIO 18 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX19         0x0620	/* (RW) GPIO/LoanIO 19 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX20         0x0624	/* (RW) GPIO/LoanIO 20 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX21         0x0628	/* (RW) GPIO/LoanIO 21 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX22         0x062C	/* (RW) GPIO/LoanIO 22 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX23         0x0630	/* (RW) GPIO/LoanIO 23 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX24         0x0634	/* (RW) GPIO/LoanIO 24 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX25         0x0638	/* (RW) GPIO/LoanIO 25 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX26         0x063C	/* (RW) GPIO/LoanIO 26 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX27         0x0640	/* (RW) GPIO/LoanIO 27 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX28         0x0644	/* (RW) GPIO/LoanIO 28 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX29         0x0648	/* (RW) GPIO/LoanIO 29 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX30         0x064C	/* (RW) GPIO/LoanIO 30 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX31         0x0650	/* (RW) GPIO/LoanIO 31 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX32         0x0654	/* (RW) GPIO/LoanIO 32 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX33         0x0658	/* (RW) GPIO/LoanIO 33 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX34         0x065C	/* (RW) GPIO/LoanIO 34 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX35         0x0660	/* (RW) GPIO/LoanIO 35 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX36         0x0664	/* (RW) GPIO/LoanIO 36 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX37         0x0668	/* (RW) GPIO/LoanIO 37 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX38         0x066C	/* (RW) GPIO/LoanIO 38 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX39         0x0670	/* (RW) GPIO/LoanIO 39 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX40         0x0674	/* (RW) GPIO/LoanIO 40 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX41         0x0678	/* (RW) GPIO/LoanIO 41 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX42         0x067C	/* (RW) GPIO/LoanIO 42 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX43         0x0680	/* (RW) GPIO/LoanIO 43 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX44         0x0684	/* (RW) GPIO/LoanIO 44 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX45         0x0688	/* (RW) GPIO/LoanIO 45 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX46         0x068C	/* (RW) GPIO/LoanIO 46 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX47         0x0690	/* (RW) GPIO/LoanIO 47 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX48         0x0694	/* (RW) GPIO/LoanIO 48 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX49         0x0698	/* (RW) GPIO/LoanIO 49 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX50         0x069C	/* (RW) GPIO/LoanIO 50 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX51         0x06A0	/* (RW) GPIO/LoanIO 51 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX52         0x06A4	/* (RW) GPIO/LoanIO 52 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX53         0x06A8	/* (RW) GPIO/LoanIO 53 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX54         0x06AC	/* (RW) GPIO/LoanIO 54 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX55         0x06B0	/* (RW) GPIO/LoanIO 55 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX56         0x06B4	/* (RW) GPIO/LoanIO 56 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX57         0x06B8	/* (RW) GPIO/LoanIO 57 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX58         0x06BC	/* (RW) GPIO/LoanIO 58 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX59         0x06C0	/* (RW) GPIO/LoanIO 59 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX60         0x06C4	/* (RW) GPIO/LoanIO 60 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX61         0x06C8	/* (RW) GPIO/LoanIO 61 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX62         0x06CC	/* (RW) GPIO/LoanIO 62 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX63         0x06D0	/* (RW) GPIO/LoanIO 63 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX64         0x06D4	/* (RW) GPIO/LoanIO 64 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX65         0x06D8	/* (RW) GPIO/LoanIO 65 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX66         0x06DC	/* (RW) GPIO/LoanIO 66 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX67         0x06E0	/* (RW) GPIO/LoanIO 67 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX68         0x06E4	/* (RW) GPIO/LoanIO 68 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX69         0x06E8	/* (RW) GPIO/LoanIO 69 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_GPLMUX70         0x06EC	/* (RW) GPIO/LoanIO 70 Output/Output Enable Mux Selection Register */
#define TOFF_SYSMGR_PINMUX_NANDUSEFPGA      0x06F0	/* (RW) Select source for NAND signals */
#define TOFF_SYSMGR_PINMUX_RGMII1USEFPGA    0x06F8	/* (RW) Select source for RGMII1 signals */
#define TOFF_SYSMGR_PINMUX_I2C0USEFPGA      0x0704	/* (RW) Select source for I2C0 signals */
#define TOFF_SYSMGR_PINMUX_RGMII0USEFPGA    0x0714	/* (RW) Select source for RGMII0 signals */
#define TOFF_SYSMGR_PINMUX_I2C3USEFPGA      0x0724	/* (RW) Select source for I2C3 signals */
#define TOFF_SYSMGR_PINMUX_I2C2USEFPGA      0x0728	/* (RW) Select source for I2C2 signals */
#define TOFF_SYSMGR_PINMUX_I2C1USEFPGA      0x072C	/* (RW) Select source for I2C1 signals */
#define TOFF_SYSMGR_PINMUX_SPIM1USEFPGA     0x0730	/* (RW) Select source for SPIM1 signals */
#define TOFF_SYSMGR_PINMUX_SPIM0USEFPGA     0x0738	/* (RW) Select source for SPIM0 signals */


/*
 *  DMA MODULE
 */
#define TADR_DMA_BASE           (PERIPH_BASE + 0xA01000)
#define TOFF_DMA_DSR                        0x0000	/* (R)  DMA Manager Status Register */
#define TOFF_DMA_DPC                        0x0004	/* DMA Program Counter Register */
#define TOFF_DMA_INTEN                      0x0020	/* (RW) Interrupt Enable Register */
#define TOFF_DMA_INT_EVENT_RIS              0x0024	/* (R)  Event-Interrupt Raw Status Register */
#define TOFF_DMA_INTMIS                     0x0028	/* (R)  Interrupt Status Register */
#define TOFF_DMA_INTCLR                     0x002C	/* (W)  Interrupt Clear Register */
#define TOFF_DMA_FSRD                       0x0030	/* (R)  Fault Status DMA Manager Register */
  #define DMA_MANAGER_FAULT_UNDEF_INSTR         0x00000001	/* executing an undefined instruction */
  #define DMA_MANAGER_FAULT_OPERAND_INVALID     0x00000002	/* executing an instruction operand that was not valid */
  #define DMA_MANAGER_FAULT_DMAGO_ERR           0x00000010	/* executing DMAGO with inappropriate security permissions */
  #define DMA_MANAGER_FAULT_MGR_EVNT_ERR        0x00000020	/* executing DMAWFE or DMASEV with inappropriate security permissions */
  #define DMA_MANAGER_FAULT_INSTR_FETCH_ERR		0x00010000	/* instruction fetch AXI bus response was not OKAY */
  #define DMA_MANAGER_FAULT_DBG_INSTR           0x40000000	/* abort occured because of an instruction issued through the debug interface */
#define TOFF_DMA_FSRC                       0x0034	/* Fault Status DMA Channel Register */
#define TOFF_DMA_FTRD                       0x0038	/* Fault Type DMA Manager Register */
#define TOFF_DMA_FTR                        0x0040	/* (R)  Fault Type DMA Channel Registers */
  #define DMA_CHANNEL_FAULT_UNDEF_INSTR         0x00000001	/* attempted to execute an undefined instruction */
  #define DMA_CHANNEL_FAULT_OPERAND_INVALID     0x00000002	/* attempted to execute an instruction operand that was not valid for the DMA configuration */
  #define DMA_CHANNEL_FAULT_CH_EVNT_ERR         0x00000020	/* in non-secure state attempted to execute the DMAWFE or DMASEV instruction for a secure event or secure interrupt */
  #define DMA_CHANNEL_FAULT_CH_PERIPH_ERR       0x00000040	/* in non-secure state attempted to execute the DMAWFP, DMALDP, DMASTP, or DMAFLUSHP instruction involving a secure peripheral */
  #define DMA_CHANNEL_FAULT_CH_RDWR_ERR         0x00000080	/* in non-secure state attempted to perform a secure read or write */
  #define DMA_CHANNEL_FAULT_MFIFO_ERR           0x00001000	/* The DMA channel MFIFO is too small to hold the DMALD instruction data */
															/* or too small to servic the DMAST instruction request */
  #define DMA_CHANNEL_FAULT_ST_DATA_UNAVAILABLE 0x00002000	/* The DMA channel MFIFO did not have the data for the DMAST instruction */
  #define DMA_CHANNEL_FAULT_INSTR_FETCH_ERR     0x00010000	/* The DMA channel instruction fetch AXI bus response was not OKAY. */
  #define DMA_CHANNEL_FAULT_DATA_WRITE_ERR      0x00020000	/* The DMA channel data write AXI bus response was not OKAY */
  #define DMA_CHANNEL_FAULT_DATA_READ_ERR       0x00040000	/* The DMA channel data read AXI bus reponse was not OKAY */
  #define DMA_CHANNEL_FAULT_DBG_INSTR           0x40000000	/* The DMA channel abort occured because of an instruction issued through the debug interface */
  #define DMA_CHANNEL_FAULT_LOCKUP_ERR          0x80000000	/* The DMA channel has locked up due to resource starvation. */
#define TOFF_DMA_CSR                        0x0100	/* (R) Channel Status Registers */
#define TOFF_DMA_CPC                        0x0104	/* Channel Program Counter Registers */
#define TOFF_DMA_SAR                        0x0400	/* (R)  Source Address Registers */
#define TOFF_DMA_DAR                        0x0404	/* (R)  Destination Address Registers */
#define TOFF_DMA_CCR                        0x0408	/* (R)  Channel Control Registers */
#define TOFF_DMA_LC0                        0x040C	/* (R)  Loop Counter 0 Registers */
#define TOFF_DMA_LC1                        0x0410	/* (R)  Loop Counter 1 Registers */
#define TOFF_DMA_DBGSTATUS                  0x0D00	/* (R)  Debug Status Register */
#define TOFF_DMA_DBGCMD                     0x0D04	/* (W)  Debug Command Register */
#define TOFF_DMA_DBGINST0                   0x0D08	/* (W)  Debug Instruction-0 Register */
#define TOFF_DMA_DBGINST1                   0x0D0C	/* (W)  Debug Instruction-1 Register */
#define TOFF_DMA_CR0                        0x0E00	/* (RW) Configuration Registers 0 */
#define TOFF_DMA_CR1                        0x0E04	/* (RW) Configuration Registers 1 */
#define TOFF_DMA_CR2                        0x0E08	/* (RW) Configuration Registers 2 */
#define TOFF_DMA_CR3                        0x0E0C	/* (RW) Configuration Registers 3 */
#define TOFF_DMA_CR4                        0x0E10	/* (RW) Configuration Registers 4 */
#define TOFF_DMA_CRD                        0x0E14	/* DMA Configuration Register */
#define TOFF_DMA_WD                         0x0E80	/* Watchdog Register */



/*
 *  SPIS MODULE
 */
#define TADR_SPIS1_BASE         (PERIPH_BASE + 0xA02000)
#define TADR_SPIS2_BASE         (PERIPH_BASE + 0xA03000)
#define TOFF_SPIS_CTLR0                     0x0000	/* (RW) Control Register 0 */
  #define SPIS_CTLR0_DFS                        0x0000000F	/* Data Frame Size */
  #define SPIS_CTLR0_FRF                        0x00000030	/* Frame Format */
  #define SPIS_CTLR0_SCPH                       0x00000040	/* Serial Clock Phase */
  #define SPIS_CTLR0_SCPOL                      0x00000080	/* Serial Clock Polarity */
  #define SPIS_CTLR0_TMOD                       0x00000300	/* Transfer Mode */
  #define SPIS_CTLR0_SLV_OE                     0x00000400	/* Slave Output Enable */
  #define SPIS_CTLR0_SRL                        0x00000800	/* Shift Register Loop */
  #define SPIS_CTLR0_CFS                        0x0000F000	/* Control Frame Size */
#define TOFF_SPIS_SPIENR                    0x0008	/* (RW) Enable Register */
  #define SPIS_SPIENR_SPI_EN                    0x00000001	/* Enable */
#define TOFF_SPIS_MWCR                      0x000C	/* (RW) Microwire Control Register */
  #define SPIS_MWCR_MWMOD                       0x00000001	/* Microwire Transfer Mode */
  #define SPIS_MWCR_MDD                         0x00000002	/* Microwire Control */
#define TOFF_SPIS_TXFTLR                    0x0018	/* (RW) Transmit FIFO Threshold Level Register */
  #define SPIS_TXFTLR_TFT                       0x000000FF	/* Transmit FIFO Threshold */
#define TOFF_SPIS_RXFTLR                    0x001C	/* (RW) Receive FIFO Threshold Level Register */
  #define SPIS_RXFTLR_RFT                       0x000000FF	/* Receive FIFO Threshold */
#define TOFF_SPIS_TXFLR                     0x0020	/* (RW) Transmit FIFO Level Register */
  #define SPIS_TXFLR_TXTFL                      0x000001FF	/* Transmit FIFO Level */
#define TOFF_SPIS_RXFLR                     0x0024	/* (RW) Receive FIFO Level Register */
  #define SPIS_RXFLR_RXTFL                      0x000001FF	/* Receive FIFO Level */
#define TOFF_SPIS_SR                        0x0028	/* (R)  Status Register */
  #define SPIS_SR_BUSY                          0x00000001	/* SPI Busy Flag */
  #define SPIS_SR_TFNF                          0x00000002	/* Transmit FIFO Not Full */
  #define SPIS_SR_TFE                           0x00000004	/* Transmit FIFO Empty */
  #define SPIS_SR_RFNE                          0x00000008	/* Receive FIFO Not Empty */
  #define SPIS_SR_RFF                           0x00000010	/* Receive FIFO Full */
  #define SPIS_SR_TXE                           0x00000020	/* Transmission Error */
#define TOFF_SPIS_IMR                       0x002C	/* (RW) Receive FIFO Full Interrupt Mask */
#define TOFF_SPIS_ISR                       0x0030	/* (R)  Interrupt Status Register */
  #define SPIS_ISR_TXEIS                        0x00000001	/* Transmit FIFO Empty Interrupt Status */
  #define SPIS_ISR_TXOIS                        0x00000002	/* Transmit FIFO Overflow Interrupt Status */
  #define SPIS_ISR_RXUIS                        0x00000004	/* Receive FIFO Underflow Interrupt Status */
  #define SPIS_ISR_RXOIS                        0x00000008	/* Receive FIFO Overflow Interrupt Status */
  #define SPIS_ISR_RXFIS                        0x00000010	/* Receive FIFO Full Interrupt Status */
#define TOFF_SPIS_RISR                      0x0034	/* (R)  Raw Interrupt Status Register */
  #define SPIS_RISR_TXEIR                       0x00000001	/* Transmit FIFO Empty Raw Interrupt Status */
  #define SPIS_RISR_TXOIR                       0x00000002	/* Transmit FIFO Overflow Raw Interrupt Status */
  #define SPIS_RISR_RXUIR                       0x00000004	/* Receive FIFO Underflow Raw Interrupt Status */
  #define SPIS_RISR_RXOIR                       0x00000008	/* Receive FIFO Overflow Raw Interrupt Status */
  #define SPIS_RISR_RXFIR                       0x00000010	/* Receive FIFO Full Raw Interrupt Status */
#define TOFF_SPIS_TXOICR                    0x0038	/* (R) Transmit FIFO Overflow Interrupt Clear Register  */
  #define SPIS_TXOICR_TXOICR                    0x00000001	/* Clear Transmit FIFO Overflow Interrupt */
#define TOFF_SPIS_RXOICR                    0x003C	/* (R)  Receive FIFO Overflow Interrupt Clear Register */
  #define SPIS_RXOICR_RXOICR                    0x00000001	/* Clear Receive FIFO Overflow Interrupt */
#define TOFF_SPIS_RXUICR                    0x0040	/* (R)  Receive FIFO Underflow Interrupt Clear Register */
  #define SPIS_RXUICR_RXUICR                    0x00000001	/* Clear Receive FIFO Underflow Interrupt */
#define TOFF_SPIS_ICR                       0x0048	/* (R)  Interrupt Clear Register */
  #define SPIS_ICR_ICR                          0x00000001	/* Clear Interrupts */
#define TOFF_SPIS_DMACR                     0x004C	/* (RW) DMA Control Register */
  #define SPIS_DMACR_RDMAE                      0x00000001	/* Receive DMA Enable */
  #define SPIS_DMACR_TDMAE                      0x00000002	/* Transmit DMA Enable */
#define TOFF_SPIS_DMATDLR                   0x0050	/* (RW) DMA Transmit Data Level Regoster */
  #define SPIS_DMATDLR_DMATDL                   0x000000FF	/* Transmit Data Level */
#define TOFF_SPIS_DMARDLR                   0x0054	/* (RW) DMA Receive Data Level Register */
  #define SPIS_DMARDLR_DMARDL                   0x000000FF	/* Receive Data Level */
#define TOFF_SPIS_IDR                       0x0058	/* (R)  Identification Register */
#define TOFF_SPIS_SPI_VER_ID                0x005C	/* (R)  Component Version Register */
#define TOFF_SPIS_DR                        0x0060	/* (RW) Data Register */
  #define SPIS_DR_DR                            0x0000FFFF	/* Data */


/*
 *  SPIM MODULE
 */
#define TADR_SPIM1_BASE         (PERIPH_BASE + 0xB00000)
#define TADR_SPIM2_BASE         (PERIPH_BASE + 0xB01000)
#define TOFF_SPIM_CTLR0                     0x0000	/* (RW) Control Register 0 */
  #define SPIM_CTLR0_DFS                        0x0000000F	/* Data Frame Size */
  #define SPIM_CTLR0_FRF                        0x00000030	/* Frame Format */
  #define SPIM_CTLR0_SCPH                       0x00000040	/* Serial Clock Phase */
  #define SPIM_CTLR0_SCPOL                      0x00000080	/* Serial Clock Polarity */
  #define SPIM_CTLR0_TMOD                       0x00000300	/* Transfer Mode */
  #define SPIM_CTLR0_SRL                        0x00000800	/* Shift Register Loop */
  #define SPIM_CTLR0_CFS                        0x0000F000	/* Control Frame Size */
#define TOFF_SPIM_CTLR1                     0x0004	/* (RW) Control Register 1 */
  #define SPIM_CTLR1_NDF                        0x0000ffff	/* Number of Data Frames */
#define TOFF_SPIM_SPIENR                    0x0008	/* (RW) Enable Register */
  #define SPIM_SPIENR_SPI_EN                    0x00000001	/* Enable */
#define TOFF_SPIM_MWCR                      0x000C	/* (RW) Microwire Control Register */
  #define SPIM_MWCR_MWMOD                       0x00000001	/* Microwire Transfer Mode */
  #define SPIM_MWCR_MDD                         0x00000002	/* Microwire Control */
  #define SPIM_MWCR_MHS                         0x00000004	/* Microwire Handshaking */
#define TOFF_SPIM_SER                       0x0010	/* (RW) Slave Enable Register */
  #define SPIM_SER_SER                          0x0000000F	/* Slave Select Enable Flag */
#define TOFF_SPIM_BAUDR                     0x0014	/* (RW) Baud Rate Select Register */
  #define SPIM_BAUDR_SCKDV                      0x0000FFFF	/* SPI Clock Divider */
#define TOFF_SPIM_TXFTLR                    0x0018	/* (RW) Transmit FIFO Threshold Level Register */
  #define SPIM_TXFTLR_TFT                       0x000000FF	/* Transmit FIFO Threshold Level */
#define TOFF_SPIM_RXFTLR                    0x001C	/* (RW) Receive FIFO Threshold Level Register */
  #define SPIM_RXFTLR_RFT                       0x000000FF	/* Receive FIFO Threshold Level */
#define TOFF_SPIM_TXFLR                     0x0020	/* (RW) Transmit FIFO Level Register */
  #define SPIM_TXFLR_TXTFL                      0x000001FF	/* Transmit FIFO Level */
#define TOFF_SPIM_RXFLR                     0x0024	/* (R)  Receive FIFO Level Register */
  #define SPIM_RXFLR_RXTFL                      0x000001FF	/* Receive FIFO Level */
#define TOFF_SPIM_SR                        0x0028	/* (R)  Status Register */
  #define SPIM_SR_BUSY                          0x00000001	/* SPI Busy Flag */
  #define SPIM_SR_TFNF                          0x00000002	/* Transmit FIFO Not Full */
  #define SPIM_SR_TFE                           0x00000004	/* Transmit FIFO Empty */
  #define SPIM_SR_RFNE                          0x00000008	/* Receive FIFO Not Empty */
  #define SPIM_SR_RFF                           0x00000010	/* Receive FIFO Full */
#define TOFF_SPIM_IMR                       0x002C	/* (RW) Interrupt Mask Register */
#define TOFF_SPIM_ISR                       0x0030	/* (R)  Interrupt Status Register */
  #define SPIM_ISR_TXEIS                        0x00000001	/* Transmit FIFO Empty Interrupt Status */
  #define SPIM_ISR_TXOIS                        0x00000002	/* Transmit FIFO Overflow Interrupt Status */
  #define SPIM_ISR_RXUIS                        0x00000004	/* Receive FIFO Underflow Interrupt Status */
  #define SPIM_ISR_RXOIS                        0x00000008	/* Receive FIFO Overflow Interrupt Status */
  #define SPIM_ISR_RXFIS                        0x00000010	/* Receive FIFO Full Interrupt Status */
  #define SPIM_ISR_MSTIS                        0x00000020	/* Multi-Master Contention Interrupt Status */
#define TOFF_SPIM_RISR                      0x0034	/* (R) Raw Interrupt Status Register  */
  #define SPIM_RISR_TXEIR                       0x00000001	/* Transmit FIFO Empty Raw Interrupt Status */
  #define SPIM_RISR_TXOIR                       0x00000002	/* Transmit FIFO Overflow Raw Interrupt Status */
  #define SPIM_RISR_RXUIR                       0x00000004	/* Receive FIFO Underflow Raw Interrupt Status */
  #define SPIM_RISR_RXOIR                       0x00000008	/* Receive FIFO Overflow Raw Interrupt Status */
  #define SPIM_RISR_RXFIR                       0x00000010	/* Receive FIFO Full Raw Interrupt Status */
#define TOFF_SPIM_TXOICR                    0x0038	/* (R)  Transmit FIFO Overflow Interrupt Clear Register */
  #define SPIM_TXOICR_TXOICR                    0x00000001	/* Clear Transmit FIFO Overflow Interrupt */
#define TOFF_SPIM_RXOICR                    0x003C	/* (R)  Receive FIFO Overflow Interrupt Clear Register */
  #define SPIM_RXOICR_RXOICR                    0x00000001	/* Clear Receive FIFO Overflow Interrupt */
#define TOFF_SPIM_RXUICR                    0x0040	/* (R)  Receive FIFO Underflow Interrupt Clear Register */
  #define SPIM_RXUICR_RXUICR                    0x00000001	/* Clear Receive FIFO Underflow Interrupt */
#define TOFF_SPIM_ICR                       0x0048	/* (R)  Interrupt Clear Register */
  #define SPIM_ICR_ICR                          0x00000001	/* Clear Interrupt */
#define TOFF_SPIM_DMACR                     0x004C	/* (RW) DMA Control Register */
  #define SPIM_DMACR_RDMAE                      0x00000001	/* Receive DMA Enable */
  #define SPIM_DMACR_TDMAE                      0x00000002	/* Transmit DMA Enable */
#define TOFF_SPIM_DMATDLR                   0x0050	/* (RW) DMA Transmit Data Level Register */
  #define SPIM_DMATDLR_DMATDL                   0x000000FF	/* Transmit Data Level */
#define TOFF_SPIM_DMARDLR                   0x0054	/* (RW) DMA Receive Data Level Register */
  #define SPIM_DMARDLR_DMARDL                   0x000000FF	/* Receive Data Level */
#define TOFF_SPIM_IDR                       0x0058	/* (R)  Identification Register */
#define TOFF_SPIM_SPI_VER_ID                0x005C	/* (R)  Component Version Register */
#define TOFF_SPIM_DR                        0x0060	/* (RW) Data Register */
  #define SPIM_DR_DR                            0x0000FFFF	/* Data */
#define TOFF_SPIM_RX_SMPL_DLY               0x00F0	/* (RW) RX Sample Delay Register */
  #define SPIM_RX_SMPL_DLY_RSD                  0x0000007F	/* Receive Data Sample Delay */



#endif  /* _SOCFPGA_CV_H_ */

